#include "zcommon.acs"
#library "WORMS"

#DEFINE WEAPON_SHOTS_SHOTGUN 2

#define CIRCLE_STARTTID 800
#define ASPECT_4_3 (4.0 / 3)
#define ASPECT_5_4 1.25
#define ASPECT_16_9 (16.0 / 9)
#define ASPECT_16_10 1.6

#define ROPEANDRUBBER_BASE      400

#define ROPE_OPEN               (ROPEANDRUBBER_BASE - 3)
#define ROPE_ENTER              (ROPEANDRUBBER_BASE - 2)
#define ROPE_RESPAWN            (ROPEANDRUBBER_BASE - 1)

#define ROPE_HOLD               (ROPEANDRUBBER_BASE + 1)
#define ROPE_DRAWLINE           (ROPEANDRUBBER_BASE + 2)
#define ROPE_GETUNUSEDTID       (ROPEANDRUBBER_BASE + 3)
#define ROPE_REEL               (ROPEANDRUBBER_BASE + 5)

#define 		ProjectileTid			210

#define			MaxInventory			30
#define			MaxPlayersArray			32

#define SPAWN_BARRELS 994
#define SPAWN_ARMOR 984
#define SPAWN_BEAM 839
#define SPAWN_HEALTH 990
#define SPAWN_TOOLCRATE 960
#define SPAWN_WEAPONCRATE 986
#define SPAWN_MINES 961

#define CROSSHAIR 939
#define FORCEINDICATOR 969

str PlayerWalljumpCheck = "None";               
int orbitarray[5];                                          

bool ClientMenu[MaxPlayersArray];

bool TornadoDone = True;
bool IsWalljumping = False;
int ClosestPlayer = 0;
int KickFacing = 0;
int GirdersPlaced = 0;
bool MinesSpawning = True;

#DEFINE LVL_YPOS 				96.0
int mapstart;
int mapend;
			
// World Related
int NumTurns = 					0;		// Total number of turns played
int Wind = 0;                       	// Current wind strength
int WindDirection = 0;              	// Current wind direction
str ShotStatus = "";                                
bool SuddenDeathNotice = False;         // Has the sudden death warning been seen

int SkinWeapon[MaxPlayersArray] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };


str FireStr[10] = { "FireRise6", "FireRise7", "FireRise8", "FireRise9", "FireRise5",
                    "FireRise5B", "FireRise6B", "FireRise7B", "FireRise8B", "FireRise9B" };

// Message Strings

str BarrelMsg[4] = { "Barrels are raining\nfrom the sky!",
                    "Nuclear waste!  How refreshing!",
                    "A little radioactivity can\ngo a long way.",
                    "Here are some obstacles to\nhinder your progress!" };

str MedkitMsg[4] = { "Somebody upstairs likes you!",
                     "Health from the heavens!",
                     "Who keeps dropping these medikits?!",
                     "Your health insurance paid off!"  };

str CrateMsg[4] = { "Mystery boxes!  Grab them\nwhile you can!",
                    "There's treasure in them there hills!",
                    "Snatch those crates!",
                    "Did somebody call a weapons dealer?" };

str ToolMsg[4] = { "Utility crate drop!  Tools for fools!",
                   "No doubt there is something useful in here...",
                   "Tools to make your lives easier,\nand your opponents shorter.",
                   "More tool crates?  Who would have guessed." };


str ArmorMsg[4] = { "A gift from the gods!",
                    "Armor, a Marines best friend!",
                    "Protect your hide!",
                    "Exploding too often?  Grab this!" };

#define             Bazooka             0
#define             Grenade             1
#define             ClusterBomb         2
#define             Shotgun             3
#define             Uzi                 4
#define             MolotovCocktail     5
#define             Mine                6
#define             SuicideDemon        7
#define             Bat                 8
#define             PlasmaGun           9
#define             BFG                 10
#define             Teleporter          11
#define             AirStriker          12
#define             Railgun             13
#define             Jetpack             14
#define             HomingMissile       15
#define             KamikazeBomber      16
#define             Girders             17
#define             BananaBomb          18
#define             Dynamite            19
#define             Flamethrower        20
#define             ClusterDemon        21
#define             EnergyBarrier       22
#define             SentryGun           23
#define             Kick                24
#define             GirderKit           25
#define             Parachute           26
#define             SkipTurn            27
#define             NapalmStrike        28
#define				NinjaRope			29

str WeaponList[MaxInventory] = 
						{   
						"BazookaRocket",
                        "Grenade",
                        "Cluster",
                        "WeaponShotgun",
                        "WeaponUzi",
                        "Molotov",
                        "Mine",
                        "WeaponDemon",
                        "BaseballBat",
                        "PlasmaGun",
                        "WeaponBFG",
                        "ItemTeleport",
                        "AirStrike",
                        "WeaponRailGun",
                        "ItemJetpack",
                        "HomingMissile",
                        "KamikazeBomber",
                        "Girder",
                        "Banana",
                        "Dynamite",
                        "Flamethrower",
                        "ClusterDemon",
                        "Barrier",
                        "SentryGun",
						"Kick",
						"GirderKit",
						"ParachuteAmmo",
						"SkipTurnAmmo",
						"NapalmStrikeAmmo",
						"RopeAmmo"
};

str WeaponNiceName[MaxInventory] = 
					{
                        "Bazooka",
                        "Grenade",
                        "Cluster Bomb",
                        "Shotgun",
                        "Uzi",
                        "Molotov Cocktail",
						"Mine",
                        "Suicide Demon",
                        "Baseball Bat",
                        "Plasma Gun",
                        "BFG8.5k",
                        "Teleporter",
                        "Air Strike",
                        "Railgun",
                        "Jetpack",
                        "Homing Missile",
                        "Headless Bomber",
                        "Girder",
                        "Banana Bomb",
                        "Dynamite",
                        "Flamethrower",
                        "Cluster Demon",
                        "Energy Barrier",
                        "Sentry Gun",
						"Mighty Foot",
						"Girder Kit",
						"Parachute",
						"Skip Turn",
						"Napalm Strike",
						"Ninja Rope"
						
					};
                    
					
str WeaponAmmoList[MaxInventory] = {
                            "bazookaammo",
                            "GrenadeAmmo",
                            "ClusterAmmo",
                            "WeaponShotgun",
                            "WeaponUzi",
                            "MolotovAmmo",
                            "MineAmmo",
                            "DemonAmmo",
                            "BatAmmo",
                            "PlasmaAmmo",
                            "BFGAmmo",
                            "TeleportAmmo",
                            "AirstrikeAmmo",
                            "RailgunAmmo",
                            "JetpackAmmo",
                            "HomingMissileAmmo",
                            "KamikazeBomberAmmo",
                            "GirderAmmo",
                            "BananaAmmo",
                            "DynamiteAmmo",
                            "FlamethrowerAmmo",
                            "ClusterDemonAmmo",
                            "BarrierAmmo",
                            "SentryGunAmmo",
							"KickAmmo",
							"GirderKitAmmo",
							"ParachuteAmmo",
							"SkipTurnAmmo",
							"NapalmStrikeAmmo",
							"RopeAmmo"
							
							};
                                     

str Hints[19] =   { 

                    "The longer a bazooka missile is in flight, the more damage it will do.",
                    "You can use the RUN key to aim faster.",
                    "For best results, judge by your previous angle and force!",
                    "While firing, the Uzi and Plasma Gun can be aimed.",
                    "The BFG will damage anything underneath it.",
                    "Remember to set a fuse length on your grenades, clusters and mines!",
                    "You have 3 seconds to move after firing a shot.  Take cover!",
                    "Remember to take the wind into consideration before firing!",
                    "Suicide demons must be triggered manually after released.",
                    "Cluster fragments are affected by wind.",
                    "Railgun shots travel through targets - line it up for maximum damage.",
                    "Airstrike missiles are affected by wind, make sure to align your target!",
                    "Girders can only be placed a certain distance from your player.",
                    "Molotovs, grenades and cluster bombs are not affected by wind.",
                    "Jetpack fuel is limited - use it wisely!",
                    "Headless bombers will run until they hit something.",
                    "The baseball bat serves to send your enemies flying.",
                    "Use your turn time wisely: sitting around will leave you at a disadvantage.",
                    "You can walljump by turning and pressing jump as you hit a wall."
                };

str AimStates[2][91] = {
			{ 
			
				"AIM1", "AIM1", "AIM3", "AIM3", "AIM5", "AIM5", "AIM7", "AIM7", "AIM9", "AIM9", "AIM11", "AIM11", "AIM13", 
				"AIM13", "AIM15", "AIM15", "AIM17", "AIM17", "AIM19", "AIM19", "AIM21", "AIM21", "AIM23", "AIM23", "AIM25", 
				"AIM25", "AIM27", "AIM27", "AIM29", "AIM29", "AIM31", "AIM31", "AIM33", "AIM33", "AIM35", "AIM35", "AIM37", 
				"AIM37", "AIM39", "AIM39", "AIM41", "AIM41", "AIM43", "AIM43", "AIM45", "AIM45", "AIM47", "AIM47", "AIM49", 
				"AIM49", "AIM51", "AIM51", "AIM53", "AIM53", "AIM55", "AIM55", "AIM57", "AIM57", "AIM59", "AIM59", "AIM61", 
				"AIM61", "AIM63", "AIM63", "AIM65", "AIM65", "AIM67", "AIM67", "AIM69", "AIM69", "AIM71", "AIM71", "AIM73", 
				"AIM73", "AIM75", "AIM75", "AIM77", "AIM77", "AIM79", "AIM79", "AIM81", "AIM81", "AIM83", "AIM83", "AIM85",
				"AIM86", "AIM87", "AIM88", "AIM89", "AIM90", "AIM90"},
			{
								
				"AIM1N", "AIM1N", "AIM3N", "AIM3N", "AIM5N", "AIM5N", "AIM7N", "AIM7N", "AIM9N", "AIM9N", "AIM11N", "AIM11N", "AIM13N", 
				"AIM13N", "AIM15N", "AIM15N", "AIM17N", "AIM17N", "AIM19N", "AIM19N", "AIM21N", "AIM21N", "AIM23N", "AIM23N", "AIM25N", 
				"AIM25N", "AIM27N", "AIM27N", "AIM29N", "AIM29N", "AIM31N", "AIM31N", "AIM33N", "AIM33N", "AIM35N", "AIM35N", "AIM37N", 
				"AIM37N", "AIM39N", "AIM39N", "AIM41N", "AIM41N", "AIM43N", "AIM43N", "AIM45N", "AIM45N", "AIM47N", "AIM47N", "AIM49N", 
				"AIM49N", "AIM51N", "AIM51N", "AIM53N", "AIM53N", "AIM55N", "AIM55N", "AIM57N", "AIM57N", "AIM59N", "AIM59N", "AIM61N", 
				"AIM61N", "AIM63N", "AIM63N", "AIM65N", "AIM65N", "AIM67N", "AIM67N", "AIM69N", "AIM69N", "AIM71N", "AIM71N", "AIM73N", 
				"AIM73N", "AIM75N", "AIM75N", "AIM77N", "AIM77N", "AIM79N", "AIM79N", "AIM81N", "AIM81N", "AIM83N", "AIM83N", "AIM85N",
				"AIM86N", "AIM87N", "AIM87N", "AIM87N", "AIM87N", "AIM87N" }
			};

int PlayerSkin[MaxPlayersArray] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
str BeamPower = "";
int MissilePos[2] = { 0, 0 };
int ShotStat[3] = { 0, 0, 0 };

str voices[5][18] = 
			{ 
				{  	"sisko/turn",
					"sisko/cratedrop",
					"sisko/shoot",
					"sisko/miss",
					"sisko/hit",
					"sisko/teamhurt",
					"sisko/pickup",
					"sisko/hitself",
					"sisko/win",
					"sisko/grenade",
					"sisko/banana",
					"sisko/airstrike",
					"sisko/giggle",
					"sisko/hurryup",
					"sisko/turnend",
					"sisko/wasteturn",
					"sisko/jump",
					"sisko/nuts"
				},
				
				{
					"odo/turn",
					"odo/cratedrop",
					"odo/shoot",
					"odo/miss",
					"odo/hit",
					"odo/teamhurt",
					"odo/pickup",
					"odo/hitself",
					"odo/win",
					"odo/grenade",
					"odo/banana",
					"odo/airstrike",
					"odo/giggle",
					"odo/hurryup",
					"odo/turnend",
					"odo/wasteturn",
					"odo/jump",
					"odo/nuts"
				},
				
				{
					"chief/turn",
					"chief/cratedrop",
					"chief/shoot",
					"chief/miss",
					"chief/hit",
					"chief/teamhurt",
					"chief/pickup",
					"chief/hitself",
					"chief/win",
					"chief/grenade",
					"chief/banana",
					"chief/airstrike",
					"chief/giggle",
					"chief/hurryup",
					"chief/turnend",
					"chief/wasteturn",
					"chief/jump",
					"chief/nuts"
				},
				{
					"quark/turn",
					"quark/cratedrop",
					"quark/shoot",
					"quark/miss",
					"quark/hit",
					"quark/teamhurt",
					"quark/pickup",
					"quark/hitself",
					"quark/win",
					"quark/grenade",
					"quark/banana",
					"quark/airstrike",
					"quark/giggle",
					"quark/hurryup",
					"quark/turnend",
					"quark/wasteturn",
					"quark/jump",
					"quark/nuts"
				},
				{
					"cat/turn",
					"",
					"cat/shoot",
					"cat/miss",
					"cat/hit",
					"cat/teamhurt",
					"",
					"cat/hitself",
					"cat/win",
					"",
					"",
					"",
					"",
					"",
					"cat/turnend",
					"cat/wasteturn",
					"cat/jump",
					"cat/pain"
				}
};


#define				MostAcrobatic		15
#define				Acrobatics			14
#define             Deaths              13
#define             TurnDamage          12
#define				MostSuicidal		11
#define				MostSelfDamage		10
#define				LongestShooter		 9
#define				LongestShot			 8
#define				HighestShooter		 7
#define				HighestShot			 6
#define				BestShooter			 5
#define				BestShot			 4
#define				TopKiller			 3
#define 			TopKills			 2
#define             TotalDamage          1
#define				TotalGameTime		 0

int Statistics[16];
    //  [0] Total Game Time
    //  [6] Highest Shot
    //  [7] Highest Shooter
    //  [8] Longest Shot
    //  [9] Longest Shooter
    //  [10] Highest Self Damage
    //  [11] Most suicidal player
    //  [12] Total Damage
    //  [13] Total Deaths
    //  [14] Most Walljumps
    //  [15] Most Acrobatic

int PlayerLoop = 0;
int TimeLoop = 0;
int WindTurns = 0;
bool RunOnce = false;
bool DidFire = false;
int blueteam = 0;
int redteam = 0;

str TimeStr[5] = { "Time1", "Time2", "Time3", "Time4", "Time5" };
str GameTimeColorStr = "Yellow";

// Player Related
#define             PlayerTurn      0
#define		    	EndTurn	    	2
#define             Menu            5
#define             MusicPlaying    6
#define             IsFiring        7
#define             HasFired        8
#define		    	JetpackUsed	    9
#define		    	Voted	    	10

bool PlayerControl[11][MaxPlayersArray];
	// [0]	PlayerTurn	// Whose turn is it?
	// [1]	PlayerLeft	// Has this player left the game?
	// [2] 	EndTurn		// Has this players turn ended?
	// [3]	TakenDamage	// Has this player taken damage?
	// [4]	LivesSet	// Have lives been set for this round?
	// [5] 	MenuToggle	// Is the weapon menu currently selected?
	// [6] 	MusicPlaying	// Is the music script running already for this player
	// [7]	IsFiring	// Is this player currently firing a weapon
	// [8]	HasFired	// Has this player finished their firing sequence
	// [9]	JetpackUsed	// Has this player used up their jetpack
	// [10] Voted		// Has this player voted

int LastPlayer;                 // The last player to run through the turn loop
int Players = 0;                // Total player count

str PlayerTeam2[MaxPlayersArray] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

// Player Ints
#define				JetpackFuelRemaining    18
#define				RopeLengthMod			17
#define				RopesRemaining			16
#define             Stupidity               15
#define             TotalPlayerDamage       14
#define				TotalDamageDone			13
#define             TurnDamageTaken         12
#define				Kills					11
#define             Lives                   10
#define             AfterHealth             9
#define             BeforeHealth            8
#define				WeaponIndex				7
#define             Aim                     4
#define				FacingAngle				3
#define				AimButton				2
#define				MoveButton				1

int PlayerInts[19][MaxPlayersArray];
	// [0]	PlayerKillCount		// Score per player
	// [1]	PlayerFacing		// Button Check for direction
	// [2]	PlayerAimButton		// Button Check for aim
	
	// [12]	PlayerStupidity
	// [13]	PlayerBackShot

int Inventory[MaxPlayersArray][MaxInventory];			// Player Inventory

bool Gui_Cursor = false;                // Is the player using the GUI cursor?
bool Gui_Clicked = false;               // Has the player clicked while using the cursor?


bool moving = false;
bool aiming = false;
bool shooting = false;    // Allow the player to do these things during his turn

// Player Related - Aim/Pitch/Firing related

int HUDAim[MaxPlayersArray] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

int PreviousAngle[MaxPlayersArray] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      			  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };          // Player previous shot counter

bool alive[MaxPlayersArray] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };                 // Is player alive?

bool SwitchedWeapon = false;            // Has weapon been switched?


// Weapon Related
bool Airstrike = false;                 // Is there an airstrike happening?
bool Targetted = false;                 // Has the player targetted with the cursor?
str PlayerWeapon[MaxPlayersArray];           // Current Player Weapon
int WeaponForce = 0;                // Amount of force applied to projectile


int WeaponInAir = 0;                // Time current players missile has been in air for

int ShotgunShots = WEAPON_SHOTS_SHOTGUN;   // Amount of shotgun shots per turn

int MisX = 0;                       // X Force component for FixedMul
int MisZ = 0;                       // Z Force

int BatPlayer = 0;                  // Batters up

// Weapon related


int fuseseconds[MaxPlayersArray] = { 3, 3, 3, 3, 3, 3, 3, 3,         // Fuses for explosives
                        3, 3, 3, 3, 3, 3, 3, 3, 
                        3, 3, 3, 3, 3, 3, 3, 3, 
                        3, 3, 3, 3, 3, 3, 3, 3 };
        
int fireamount[MaxPlayersArray] = { 3, 3, 3, 3, 3, 3, 3, 3,         // How many to fire
                        3, 3, 3, 3, 3, 3, 3, 3,
                        3, 3, 3, 3, 3, 3, 3, 3,
                        3, 3, 3, 3, 3, 3, 3, 3 };






bool Backshot;
int PlayerPosition;



global int 1:GAME_TURNTIME;             // Turn time
global int 2:GAME_GAMETIME;             // Total game time before sudden death
global int 3:GAME_DAMAGE_SCALAR;        // Damage multiplier
global int 53:GAME_FALLDAMAGE;
global int 54:GAME_DROPTURNS;
global int 55:LVL_WINDMAX;
global int 59:GAME_SUDDENDEATHMODE;
global int 4:GAME_GRAVITY;              // Gravity
global bool 5:GAME_SUDDENDEATH;         // Sudden Death mode
global int 6:GAME_SUDDENDEATH_WATERRISE; // Mapunits water rises on each turn after sudden death
                                     
                                        //// Drop chances
global int 7:LVL_CHANCE_BARRELS;         // Barrels
global int 8:LVL_CHANCE_MINES;           // Mines
global int 9:LVL_CHANCE_MEDKITS;         // Medkits
global int 10:LVL_CHANCE_MEDKITS_SMALL; 
global int 11:LVL_CHANCE_MEDKITS_BIG;
global int 12:LVL_CHANCE_CRATES;           // weapon crates
global int 13:LVL_CHANCE_TOOLS;            // Tool crates
global int 14:LVL_CHANCE_ARMOR;            // Armor
global int 15:LVL_CHANCE_ARMOR_GREEN;      // Percentage Chance - Green armor
global int 16:LVL_CHANCE_ARMOR_BLUE;       // Percentage Chance - Blue armor
global int 17:LVL_CHANCE_ARMOR_RED;        // Percentage Chance - Red Armor
global int 18:GAME_MAPWATER;

                                        //// Traps power/timers
global int 19:LVL_POWER_BARRELS;        // How many flames spawned by firebarrels        
global int 20:LVL_POWER_MINES;          // How powerful a mine explosion is

global int 21:LVL_TIMER_MINES;          // Level Mine timers

global int 23:WEAPON_SHOTS_PLASMA;

global int 24:WEAPON_POWER_MOLOTOV;     // How many flames spawned by molotov

global int 32:WEAPON_POWERS[];
global int 25:WEAPON_AMOUNTS[];

int WeaponCrate[19] = { ClusterBomb, Shotgun, Uzi, MolotovCocktail, 
						Mine, SuicideDemon, Bat, PlasmaGun,
						BFG, Airstriker, Railgun, HomingMissile,
						KamikazeBomber, BananaBomb, Dynamite, Flamethrower,
						ClusterDemon, Kick, NapalmStrike };
						
int ToolCrate[7] = { 	Teleporter, Jetpack, Girders, GirderKit, Parachute, EnergyBarrier, SentryGun };

global bool 49:PLAYER_MOVE;
global int 50:PLAYER_STARTINGHEALTH;
global int 51:PLAYER_STARTINGARMOR;
global int 56:PLAYER_SPEED;
global bool 61:GAME_MAPSCRIPT;
global int 62:GAME_MAPOBJECTS;
global int 58:PLAYER_LIVES;
global int 63:GAME_GAMETYPE;
global bool 30:GAME_BEAMS;
global int 31:GAME_BEAMCHANCE;

Script 933 (int WeapNumber)
	{	SetResultValue((WEAPON_POWERS[WeapNumber]*1.0)*((GAME_DAMAGE_SCALAR*1.5)/100.0)>>16); 	}

// Map specific crap
       
Script 999 OPEN
{
Sector_SetCeilingScale(9, 2, 0, 2, 0);
Sector_SetFade(9, 0, 100, 255);
Scroll_Wall(1, 0, -1.0, 0, 4);
Scroll_Ceiling(9, 0.0, 64, 0);
Scroll_Floor(11, 0.0, 64, 0);
}

function int abs (int x)
{
    if (x < 0)
        return -x;

    return x;
}


function int getaspectratio(void)
{
	int width = getcvar("vid_defwidth");
	int height = getcvar("vid_defheight");
	int nowidescreen = getcvar("vid_nowidescreen");
	int tft = getcvar("vid_tft");
	int aspect = getcvar("vid_aspect");
	switch(aspect)
	{
		case 1:	return ASPECT_16_9;
		case 2:	return ASPECT_16_10;
		case 3:	return ASPECT_4_3;
		case 4:	return ASPECT_5_4;
	}
	if(nowidescreen)
	{
		if(!tft)
			return ASPECT_4_3;
		if(fixedmul(height<<16, fixeddiv(5.0, 4.0)) == width<<16)
			return ASPECT_5_4;
		else
			return ASPECT_4_3;
	}
	if(abs((abs(fixedmul(height<<16, fixeddiv(16.0, 9.0)))>>16) - width) < 10)
	{
		return ASPECT_16_9;
	}
	if(abs((abs(fixedmul(height<<16, fixeddiv(16.0, 10.0)))>>16) - width) < 60)
	{
		if((width == 320 && height == 200) || (width == 640 && height == 400))
			return ASPECT_4_3;
		return ASPECT_16_10;
	}
	if(fixedmul(height<<16, fixeddiv(5.0, 4.0))>>16 == width && tft)
	{
		return ASPECT_5_4;
	}
	return ASPECT_4_3;
}

// Server settings
int GAMETIME;

Script 900 OPEN
{
GAMETIME = GAME_GAMETIME;
numturns = 0;
Switch(Random(1, 5))
    {
        case 1:
            ReplaceTextures("WBG1", "WBG2", 0);
            break;
        case 2:
            ReplaceTextures("WBG1", "WBG3", 0);
            break;
        case 3:
            ReplaceTextures("WBG1", "WBG4", 0);
            break;
        case 4:
            ReplaceTextures("WBG1", "WBG5", 0);
            break;
        case 5:
            ReplaceTextures("WBG1", "WBG6", 0);
            break;
    }
Switch(Random(1, 3))
	{
		case 1:
			break;
		case 2:
			ReplaceTextures("WATER", "BLOOD", 0);
			break;
		case 3:
			ReplaceTextures("WATER", "GWATER", 0);
			break;
	}
ConsoleCommand("compat_clientssendfullbuttoninfo 1");
if(GAME_FALLDAMAGE == True) ConsoleCommand("sv_falldamage 1");
else ConsoleCommand("sv_falldamage 0");
ConsoleCommand("gl_use_models 1");
ConsoleCommand("screenblocks 11");
ConsoleCommand("hud_scale 0");
}

int Music[9][2] = 
	{ {"DUBSTEP", 4821 }, {"SLOWDOWN", 5714}, {"FREAK", 6607},
	{ "JAZZ", 8640 }, { "DOOMY", 191*35 }, {"FREAK2", 78*35 },
	{ "WHISPER", 51*35 }, {"FREAK3", 77*35 }, { "", 0 }};
		

// Client Random Music

Script 968 ENTER clientside
{
	ConsoleCommand("snd_waterlp 0");
	
    if(GetLevelInfo(LEVELINFO_LevelNum) == 0) 
	{ PlayerControl[MusicPlaying][PlayerNumber()] = False; Terminate; }
	
    if(PlayerControl[MusicPlaying][PlayerNumber()] == False)
    {
        while(1)
        {
	    Music[8][1] = Random(35*30, 35*60);

            PlayerControl[MusicPlaying][PlayerNumber()] = True;
            int RandomMusic = Random(0, 8);
		LocalSetMusic(Music[RandomMusic][0]);
		Delay(Music[RandomMusic][1]);
		}
    }
}


// Reset health/inventory at level start
Script 801 ENTER
{
if(GetLevelInfo(LEVELINFO_LevelNum) == 0) Terminate;
//if(NumTurns == 0)
	{

TakeInventory("BasicArmor", CheckInventory("BasicArmor"));
TakeInventory("WindItemR", CheckInventory("WindItemR"));
TakeInventory("WindItemL", CheckInventory("WindItemL"));
SetActorProperty(0, APROP_Health, PLAYER_STARTINGHEALTH);
GiveInventory("ArmorBonus", PLAYER_STARTINGARMOR);

	for(int WeapLoop = 0; weaploop < MaxInventory; weaploop++)
		{
		Inventory[PlayerNumber()][WeapLoop] = WEAPON_AMOUNTS[WeapLoop];
		}
	}
}
                    
Script 956 (VOID)
{
	WeaponMorph(PlayerNumber(), 1, 0);
        ChangeCamera(105, 0, 0);
	SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
} 

// Jetpack thrust clientside syncer
Script 985 (int PlayrNum) clientside
{
        ThrustThingZ(PlayrNum, 16, 0, 0);
}

// Jetpack fuel remaining hudmessage
Script 982 (int PlayerNum)
{
Hudmessageonactor(PlayerNum, PlayerInts[JetpackFuelRemaining][PlayerNum-500]/10);
}

// Fuse timer hudmessage
Script 981 (VOID)
{
if(GetActorProperty(ProjectileTID, APROP_Health) != 0)
Hudmessageonactor(ProjectileTID, GetActorProperty(ProjectileTID, APROP_Health));
}

// Hit by Baseball bat
int BatX;
int BatZ;

Script 965 (VOID)
{
    
    Thing_ChangeTID(0, 556+PlayerNumber());
    
    WeaponForce = 50;
    
    //int BatX = FixedMul(cos(PlayerInts[FacingAngle][BatPlayer] >> 8), FixedMul(cos(PlayerInts[Aim][BatPlayer]), WeaponForce));
    //int BatZ = FixedMul(sin(PlayerInts[Aim][BatPlayer]), WeaponForce);    
    
    BatX = BatX*65536;
    BatZ = BatZ*65536;
    
    SetActorVelocity(556+PlayerNumber(), BatX, 0, BatZ, 0, 0);
    While(GetActorVelX(556+PlayerNumber()) + GetActorVelZ(556+PlayerNumber()) != 0) Delay(25);
    Thing_ChangeTID(556+PlayerNumber(), PlayerNumber()+500);
}


// Count how long missile has been in the air

Script 976 (int C)
{
if(C == 0)
    {
	if(WeaponInAir < 8)
	        WeaponInAir++;
    }
}

Script 971 (VOID)
{
	SetResultValue((WeaponInAir*5)+ACS_ExecuteWithResult(933, 0, 0));
}

// Mine TID Setters/Damage Script

Int MineIteration = 1001;

Script 977 (VOID)
{
        if(ActivatorTid() > 1000) terminate;
        if(MineIteration > 1006) MineIteration = 1001;
        Thing_ChangeTid(0, MineIteration); MineIteration++;
}

// Mine fuse ticker

Script 978 (VOID)
{
Thing_ChangeTid(0, 999); SetActorAngle(999, 0.33);
SetActorProperty(999, APROP_INVULNERABLE, 0);
int Health = GetActorProperty(999, APROP_HEALTH);
SetActorProperty(999, APROP_HEALTH, Health-1);
SetActorProperty(999, APROP_INVULNERABLE, 1);
}

// Crate Pickup

Script 979 (int CrateType, int Amount)
{
		int TID = ActivatorTID()-500;
		print(i:TID);
		
    if(CrateType == 1)          // Weapons
        {
            int CrateWeapon = Random(0,18);
            Inventory[TID][WeaponCrate[CrateWeapon]] += 1;
            SetFont("BIGFONT");
            SetHudSize(800, 600, 0);
            HudMessage(s:"You picked up ", s:WeaponNiceName[WeaponCrate[CrateWeapon]], s:" ammo"; HUDMSG_FADEINOUT, 30, CR_GOLD, 400.0, 250.0, 3.0, 0.5, 0.5);
        }
 else if(CrateType == 2)          // Tools
        {
            CrateWeapon = Random(0, 5);
	    Inventory[TID][ToolCrate[CrateWeapon]] += 1;
            SetFont("BIGFONT");
            SetHudSize(800, 600, 0);
            HudMessage(s:"You picked up a ", s:WeaponNiceName[ToolCrate[CrateWeapon]]; HUDMSG_FADEINOUT, 30, CR_GOLD, 400.0, 250.0, 3.0, 0.5, 0.5);     
        }
 else if(CrateType == 3)
	{
		SetActorProperty(TID, APROP_Health, GetActorProperty(0, APROP_Health) + Amount);
	        SetFont("BIGFONT");
        	SetHudSize(800, 600, 0);
		HudMessage(s:"+", i:Amount, s:" health!"; HUDMSG_FADEINOUT, 30, CR_GOLD, 400.0, 250.0, 3.0, 0.5, 0.5);
	}

  AmbientSound(voices[PlayerSkin[PlayerNumber()]][6], 127);

}
	
// Fire Barrel firespawner function
int FireIteration = 600;

function void SpawnFlames (int TID, int GlobalType)
{
    For(Int FireSpawnLoop = GlobalType ; FireSpawnLoop > 0; FireSpawnLoop--)
        {
        
            if(Random(1,2) == 1) int RandomAngle = 0;
                                else RandomAngle = 128;
            
            int RandomSpeed = Random(2, 12);
            int RandomZ = Random(8, 32);
        
        SpawnProjectile(TID, "FireSpawner", RandomAngle, RandomSpeed, 4+RandomZ, 1, FireSpawnLoop+FireIteration);
        }
}

// Fire spawner script
Script 980 (int Type)
{

Thing_ChangeTid(0, 616);
    
        if(Type == 0)       // Barrel
                SpawnFlames(616, LVL_POWER_BARRELS);
        else                // Molotov
                SpawnFlames(616, WEAPON_POWER_MOLOTOV);

Thing_ChangeTid(616, 0);
}


// Pain/Damage turn cancellation script called on player pain state
Script 991 (VOID)
{
    ACS_Execute(891, 0);
    SetActorProperty(PlayerNumber()+500, APROP_SPEED, int2fix(PLAYER_SPEED)/100);
    if(PlayerControl[PlayerTurn][PlayerNumber()] == False)
        {
            Thing_ChangeTid(0, 556+PlayerNumber());
            While(GetActorVelX(0) + GetActorVelZ(0) != 0)
                Delay(35);
            Thing_ChangeTid(556+PlayerNumber(), PlayerNumber()+500);
        }
		
    if(PlayerControl[PlayerTurn][PlayerNumber()] == True && Moving == True) 
	{
		moving = false;
		shooting = false;
		PlayerControl[3][PlayerNumber()] = True;
		SetPlayerProperty(0, ON, PROP_TOTALLYFROZEN);
	}
	
    While(GetActorY(0) != LVL_YPOS)
        {
            SetActorVelocity(0, GetActorVelX(0), 0, GetActorVelZ(0), 0, 1);
            SetActorPosition(0, GetActorX(0), LVL_YPOS, GetActorZ(0), 0);
            delay(1);
        }
	if(GetActorProperty(0, APROP_HEALTH) == 0)
	{
		SetActorState(0, "Explode");
	}

}

Script 891 (VOID) clientside
{
    if(PlayerControl[PlayerTurn][PlayerNumber()] == True) PlayerControl[3][PlayerNumber()] = True;
    While(GetActorY(0) != LVL_YPOS)
        {
            SetActorVelocity(0, GetActorVelX(0), 0, GetActorVelZ(0), 0, 1);
            SetActorPosition(0, GetActorX(0), LVL_YPOS, GetActorZ(0), 0);
            delay(1);
        }
}

str GirderFacing = "Horizontal";

// Fuse Selection
Script 989 (VOID) net
{
 if(PlayerControl[PlayerTurn][PlayerNumber()] == True) 
        
        {
            
        if  (PlayerWeapon[PlayerNumber()] == "Grenade" || PlayerWeapon[PlayerNumber()] == "Cluster" ||
			PlayerWeapon[PlayerNumber()] == "Mine" || PlayerWeapon[PlayerNumber()] == "Banana" )
                {
                int fuse = fuseseconds[PlayerNumber()];
                if(fuse < 8) fuse++;
                else fuse = 1;
                fuseseconds[PlayerNumber()] = fuse;
                SetFont("BIGFONT");
                SetHudSize(800,600,0);
                HudMessage(i: fuse, s:" second fuse"; HUDMSG_FADEINOUT, 21, CR_GOLD, 400.0, 40.0, 3.0, 0.5, 0.5);
                }
    else    if (PlayerWeapon[PlayerNumber()] == "KamikazeBomber")
                {
                int NumberToFire = FireAmount[PlayerNumber()];
                if(NumberToFire < 3) NumberToFire++;
                else NumberToFire = 1;
                FireAmount[PlayerNumber()] = NumberToFire;
                
                SetFont("BIGFONT");
                SetHudSize(800,600,0);
                HudMessage(i: NumberToFire, s:" ", s:WeaponNiceName[PlayerInts[WeaponIndex][PlayerNumber()]]; HUDMSG_FADEINOUT, 21, CR_GOLD, 400.0, 40.0, 3.0, 0.5, 0.5);
                }
        
    else    if  (PlayerWeapon[PlayerNumber()] == "Girder" || PlayerWeapon[PlayerNumber()] == "GirderKit")
                {
                    if(ThingCountName("GHPlace", 211) == 1)
                        {   SpawnSpot("GDPlace", 211, 213, 64);
                            Thing_Remove(211);
                            Thing_ChangeTid(213, 211);
                            GirderFacing = "DiagonalLeft";
                        }
                else if(ThingCountName("GDPlace", 211) == 1 && GirderFacing == "DiagonalLeft")
                        {   SpawnSpot("GVPlace", 211, 213, 64);
                            Thing_Remove(211);
                            Thing_ChangeTid(213, 211);
                            GirderFacing = "Vertical";
                        }
                else if(ThingCountName("GDPlace", 211) == 1 && GirderFacing == "DiagonalRight")
                        {   SpawnSpot("GHPlace", 211, 213, 64);
                            Thing_Remove(211);
                            Thing_ChangeTid(213, 211);
                            GirderFacing = "Horizontal";
                        }
                else if(ThingCountName("GVPlace", 211) == 1)
                        {   SpawnSpot("GDPlace", 211, 213, 192);
                            Thing_Remove(211);
                            Thing_ChangeTid(213, 211);
                            GirderFacing = "DiagonalRight";
                        }
                }
        }
}

// TID setting/Camera setting
function void SetupPlayer (int PlayerNum)
{
        Thing_ChangeTID(0, 500+PlayerNum);
        PlayerControl[1][PlayerNum] = False;
        PlayerInts[BeforeHealth][PlayerNum] = 0;
        PlayerInts[AfterHealth][PlayerNum] = 0;
        Players++;
        alive[PlayerNum] = true;
        SetActorProperty(500+PlayerNum, APROP_SPEED, int2fix(PLAYER_SPEED)/100);
        SetPlayerProperty(0, ON, PROP_TOTALLYFROZEN);
}

function void ForceCamera (void)
{
        ChangeCamera(105, 0, 0);
}



 
Script 1 ENTER
{

if(PlayerIsSpectator(PlayerNumber()) == 1) { ForceCamera(); terminate; }

if(GetLevelInfo(LEVELINFO_LevelNum) == 0)
    { Thing_ChangeTid(0, PlayerNumber()+500); Terminate; }

if(NumTurns < 1 && PlayerControl[4][PlayerNumber()] == False)
    { 	PlayerControl[4][PlayerNumber()] = True;
		PlayerInts[Lives][PlayerNumber()] = PLAYER_LIVES; }

	Delay(1);

if(GetLevelInfo(LEVELINFO_LevelNum) == 32)
	ScriptWait(851);

if(PlayerInts[Lives][PlayerNumber()] > 0) 
    {
	PlayerSkin[PlayerNumber()] = PlayerClass(PlayerNumber());
	TakeActorInventory(PlayerNumber()+500, "CurrentPitchNegItem", CheckActorInventory(PlayerNumber()+500, "CurrentPitchNegItem"));
	TakeActorInventory(PlayerNumber()+500, "CurrentPitchItem", CheckActorInventory(PlayerNumber()+500, "CurrentPitchItem"));
        TakeActorInventory(PlayerNumber()+500, "HealthMaxItem", CheckActorInventory(PlayerNumber()+500, "HealthMaxItem"));
        TakeActorInventory(PlayerNumber()+500, "ArmorMaxItem", CheckActorInventory(PlayerNumber()+500, "ArmorMaxItem"));
        GiveActorInventory(PlayerNumber()+500, "HealthMaxItem", PLAYER_STARTINGHEALTH);
        GiveActorInventory(PlayerNumber()+500, "ArmorMaxItem", PLAYER_STARTINGARMOR);
        if(GAME_GAMETYPE == 0)
            {
                SetupPlayer(PlayerNumber());
				
                if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
				{
				While( GetActorY(PlayerNumber()+500) != LVL_YPOS 
                            || NotWater(PlayerNumber()+500) == False)

					{
					SetActorPosition(PlayerNumber()+500, Random(-8000.0, 8000.0), LVL_YPOS, 4000.0, 0);
					ForceDirection(PlayerNumber());
					if(timer()%12 == 0) delay(1);
					}
				
                SetActorPosition(PlayerNumber()+500,
                    GetActorX(PlayerNumber()+500), LVL_YPOS, 
                        GetActorFloorZ(PlayerNumber()+500) + 48.0, 0);
				
				}
				
				ForceDirection(PlayerNumber());
            }
        else if(GAME_GAMETYPE == 1) 
            {
                SetupPlayer(PlayerNumber());
                    
                if(blueteam <= redteam) 
                    { 
                        for(int LivesCheck = PLAYER_LIVES; LivesCheck > 0; LivesCheck--)
                            blueteam++; 
                        playerteam2[playernumber()] = "Blue"; }
                else if(redteam < blueteam) 
                    { 
                        for(LivesCheck = PLAYER_LIVES; LivesCheck > 0; LivesCheck--)
                            redteam++; 
                        playerteam2[playernumber()] = "Red"; }

                if(PlayerTeam2[PlayerNumber()] == "Blue")
                    {
                        int BlueTeamInitPos = -8000.0;
                    
                        While( GetActorY(PlayerNumber()+500) != LVL_YPOS || NotWater(PlayerNumber()+500) == False)
                            {
                                if(BlueTeamInitPos < -1000.0)
                                    {
                                        if(Random(1,4) < 3) 
                                        BlueTeamInitPos += Random(500.0, 1000.0);
                                    else BlueTeamInitPos += Random(800.0, 1200.0);
                                }
                            
                            SetActorPosition(PlayerNumber()+500, 
                                    BlueTeamInitPos+Random(-150.0, 150.0)
                                                ,LVL_YPOS, 4000.0, 0);
                            delay(1);
                        }
                }
                
            else if(PlayerTeam2[PlayerNumber()] == "Red")
                {
                    int RedTeamInitPos = 8000.0;
                    
                    While( GetActorY(PlayerNumber()+500) != LVL_YPOS 
                            || NotWater(PlayerNumber()+500) == False)
                        {
                            if(RedTeamInitPos > 1000.0)
                                {
                                    if(Random(1,4) < 3) 
                                        RedTeamInitPos -= Random(500.0, 1000.0);
                                    else RedTeamInitPos -= Random(800.0, 1200.0);
                                }
                            SetActorPosition(PlayerNumber()+500, RedTeamInitPos+Random(-300.0, 300.0), LVL_YPOS, 4000.0, 0);
                            delay(1);
                        }
                }

  SetActorPosition(PlayerNumber()+500, GetActorX(PlayerNumber()+500), 
            LVL_YPOS, GetActorFLoorZ(PlayerNumber()+500) + 48.0, 0);
  ForceDirection(PlayerNumber());
  ForceCamera(); } ForceCamera(); } ForceCamera();
}


Script 4 RESPAWN
{
if(GetLevelInfo(LEVELINFO_LevelNum) == 0) 
    { Thing_ChangeTid(0, PlayerNumber()+500); Terminate; }
if(PlayerInts[Lives][PlayerNumber()] > 0) 
    {
        if(GAME_GAMETYPE == 0)
            {
                SetupPlayer(PlayerNumber());

                    While( GetActorY(PlayerNumber()+500) != LVL_YPOS 
                            || NotWater(PlayerNumber()+500) == False)

                            {
                            SetActorPosition(PlayerNumber()+500, Random(-8000.0, 8000.0), LVL_YPOS, 4000.0, 0);
                            delay(2);
                            }
                SetActorPosition(PlayerNumber()+500,
                    GetActorX(PlayerNumber()+500), LVL_YPOS, 
                        GetActorFLoorZ(PlayerNumber()+500) + 48.0, 0);
            }
        else if(GAME_GAMETYPE == 1) 
            {
                SetupPlayer(PlayerNumber());

                if(PlayerTeam2[PlayerNumber()] == "Blue")
                    {
                        int BlueTeamInitPos = -8000.0;
                    
                        While( GetActorY(PlayerNumber()+500) != LVL_YPOS || NotWater(PlayerNumber()+500) == False)
                            {
                                if(BlueTeamInitPos < -1000.0)
                                    {
                                        if(Random(1,2) == 1) 
                                        BlueTeamInitPos += Random(150.0, 300.0);
                                    else BlueTeamInitPos += Random(100.0, 600.0);
                                }
                            
                            SetActorPosition(PlayerNumber()+500, 
                                    BlueTeamInitPos+Random(-150.0, 150.0)
                                                ,LVL_YPOS, 4000.0, 0);
                            delay(2);
                        }
                }
            else if(PlayerTeam2[PlayerNumber()] == "Red")
                {
                    int RedTeamInitPos = 8000.0;
                    
                    While( GetActorY(PlayerNumber()+500) != LVL_YPOS 
                            || NotWater(PlayerNumber()+500) == False)
                        {
                            if(RedTeamInitPos > 1000.0)
                                {
                                    if(Random(1,2) == 1) 
                                        RedTeamInitPos -= Random(150.0, 300.0);
                                    else RedTeamInitPos -= Random(100.0, 600.0);
                                }
                            SetActorPosition(PlayerNumber()+500, RedTeamInitPos+Random(-300.0, 300.0), LVL_YPOS, 4000.0, 0);
                            delay(2);
                        }
                }

  SetActorPosition(PlayerNumber()+500, GetActorX(PlayerNumber()+500), 
            LVL_YPOS, GetActorFLoorZ(PlayerNumber()+500) + 48.0, 0);
  
  ForceDirection(PlayerNumber());
  ForceCamera();           
}
ForceCamera();
}
Else if(PlayerInts[Lives][PlayerNumber()] == 0)
    {
    ForceCamera();
    SetHudSize(1024, 768, 0);
    SetFont("BIGFONT");
    HudMessage(s:"You are dead!"; HUDMSG_FADEINOUT, 7000, CR_RED, 512.0, 640.0, 30.0, 5.0, 20.0);
    }
}            

Script 5 DEATH
{
if(PlayerControl[PlayerTurn][PlayerNumber()] == True) TimeLoop = 0;
Thing_ChangeTID(0, 2538);
UnMorphActor(0, 1);
Players--;
ConsoleCommand("use");
if(GAME_GAMETYPE == 1)
    {
        if(PlayerTeam2[PlayerNumber()] == "Blue") BlueTeam--;
        else if(PlayerTeam2[PlayerNumber()] == "Red") RedTeam--;
    }
PlayerInts[Lives][PlayerNumber()]--;
Statistics[Deaths]++;			// Deaths ++

for(int killcheck = 0; killcheck < MaxPlayersArray; killcheck++)		// If player was killed during someone elses turn, attribute kill to them
    if(PlayerControl[PlayerTurn][killcheck] == True && PlayerNumber() != killcheck) PlayerInts[Kills][killcheck]++;

PlayerInts[AfterHealth][PlayerNumber()] = 0;
alive[PlayerNumber()] = false;
Delay(35);
SetActorState(2538, "Explode");
Thing_ChangeTID(2538, 0);
}

Script 6 (int gone) DISCONNECT
{
if(PlayerIsSpectator(gone) != 2)
{
if(PlayerControl[PlayerTurn][gone] == True) TimeLoop = 0;
if(Alive[gone] == true)
    {
        PlayerControl[1][gone] = True;
		
		if(GAME_GAMETYPE == 1)
			{
			if(PlayerTeam2[gone] == "Blue") BlueTeam -= PlayerInts[Lives][gone];
			else if(PlayerTeam2[gone] == "Red") RedTeam -= PlayerInts[Lives][gone];
			}
			
        PlayerInts[Lives][gone] = 0;
        Thing_ChangeTid(0, 0);
        Players--;
        alive[gone] = false;
        PlayerInts[BeforeHealth][gone] = 0;
        PlayerInts[AfterHealth][gone] = 0;
    }
if(PlayerCount() == 0)
	{
	for(int countdown = 10; countdown > 0; countdown--)
		{
		PrintBold(s:"Returning to lobby in ", i:countdown, s:" seconds");
		Delay(35);
		}
			Exit_Normal(0);
			terminate;
	}
}
}

// WIND INITIALISER
Script 995 (VOID)
{
for(int floop = 0; floop < MaxPlayersArray; floop++)
    {   TakeActorInventory(500+floop, "WindItemL", 6); 
        TakeActorInventory(500+floop, "WindItemR", 6);  }

    Wind = Random(0, LVL_WINDMAX);
    if(Random(1, 2) == 1) 
            {
                WindDirection = 0; 
                for(floop = 0; floop < MaxPlayersArray; floop++)
                    GiveActorInventory(500+floop, "WindItemL", Wind);
            }
        else 
            {
                WindDirection = 128;
                for(floop = 0; floop < MaxPlayersArray; floop++)
                    GiveActorInventory(500+floop, "WindItemR", Wind);
            }
            
        For(int WindLoop = 255; WindLoop > 0; WindLoop--)
            {   Sector_SetWind(WindLoop, 0, 0, 0);
		Sector_SetWind(WindLoop, Wind, WindDirection, 0); }
    AmbientSound("world/wind", 127);
    ACS_ExecuteAlways(993, 0, Wind, WindDirection);     // Make sure the client is notified of wind change
}

// Client wind synchroniser

Script 993 (int CWind, int CWindDirection) clientside
{
For(int WindLoop = 255; WindLoop > 0; WindLoop--)
	{ Sector_SetWind(WindLoop, 0, 0, 0); 
	Sector_SetWind(WindLoop, CWind, CWindDirection, 0); }
SetFont("BIGFONT");
SetHudSize(800, 600, 0);
if(CWind != 0)  {
                if(CWindDirection == 0)  HudMessageBold(s:"Wind is blowing East at ", d: CWind*10, s:" knots"; HUDMSG_FADEINOUT, 59, CR_WHITE,
                        400.0, 70.0, 6.0, 0.5, 0.5);
                else    HudMessageBold(s:"Wind is blowing West at ", d: CWind*10, s:" knots"; HUDMSG_FADEINOUT, 59, CR_WHITE,
                        400.0, 70.0, 6.0, 0.5, 0.5);
                }
else            HudMessageBold(s:"The wind has stopped"; HUDMSG_FADEINOUT, 59, CR_WHITE, 400.0, 50.0, 4.0, 0.5, 0.5);
}


function bool NotWater (int tid)
{
    
    bool IsNotWater;

    if(GetActorFloorZ(tid) < GetSectorCeilingZ(9, 0, 0))
       IsNotWater = false;
	   
       else IsNotWater = true;
       
    return IsNotWater;
}

// Level mine spawner


Script SPAWN_MINES OPEN
{
if(GetLevelInfo(LEVELINFO_LevelNum) == 0 || 
	LVL_CHANCE_MINES == 0 || 
	GetLevelInfo(LEVELINFO_LevelNum) == 32) 
	
	{ MinesSpawning = False; Terminate; }

	SetHudSize(640, 480, 0); 
	SetFont("BIGFONT"); 
	HudMessageBold(s:"Please Wait"; HUDMSG_PLAIN, 5, CR_GOLD, 320.0, 200.0, 0); 


for(int LvlMines = LVL_CHANCE_MINES; LvlMines > 0; LvlMines--)
    {
                
                int RandomSelect = 50;
                
            SetActorPosition(RandomSelect, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(RandomSelect)+3000.0, 0);    
    
                While( (GetActorY(RandomSelect) != LVL_YPOS || NotWater(RandomSelect) == False ))
                    {   
                        SetActorPosition(RandomSelect, Random(-7000.0, 7000.0), LVL_YPOS, GetActorFloorZ(RandomSelect)+3000.0, 0);
                        if(NotWater(RandomSelect) == True) break;
						if(timer()%12 == 0)
							delay(1);
                    }

                SpawnSpot("Mine", RandomSelect, RandomSelect+100, 0);
                SetActorPosition(RandomSelect+100, GetActorX(RandomSelect+100), LVL_YPOS, GetActorFloorZ(RandomSelect+100), 0);
                SetActorProperty(RandomSelect+100, APROP_Health, LVL_TIMER_MINES);
                Thing_ChangeTid(RandomSelect+100, 0);
    }
HudMessageBold(s:""; HUDMSG_PLAIN, 5, CR_GOLD, 320.0, 200.0, 0); 
MinesSpawning = False;
}
		
// Explosive Barrel Spawner

Script SPAWN_BARRELS (VOID)
{
For(int SpawnerLoop = 50; SpawnerLoop < 56; SpawnerLoop++)
{

if(Random(1, 5) == 1)
    SpawnSpot("FireBarrel", SpawnerLoop, SpawnerLoop+100, 0);
else 
    SpawnSpot("ExplosiveBarrel", SpawnerLoop, SpawnerLoop+100, 0);
	
    SetActorPosition(SpawnerLoop+100, Random(-8000.0, 8000.0), 
                                LVL_YPOS, GetActorFloorZ(SpawnerLoop+100) + 3000.0, 0);
	if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
	{
    While(NotWater(SpawnerLoop+100) == False)
        {
            SetActorPosition(SpawnerLoop+100, Random(-8000.0, 8000.0), 
                                LVL_YPOS, GetActorFloorZ(SpawnerLoop+100) + 3000.0, 0);
            delay(1);
        }
	}
	else SetActorPosition(SpawnerLoop+100, random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(SpawnerLoop+100) + 3000.0, 0);
	
    SetActorVelocity(SpawnerLoop+100, 0, 0, -15, 1, 0);    
 
	delay(1);
 
    Thing_ChangeTID(SpawnerLoop+100, 0);
    }

SetFont("BIGFONT");
SetHudSize(800, 600, 0);
HudMessageBold(s:BarrelMsg[Random(0, 3)]; HUDMSG_FADEINOUT, 1, CR_YELLOW, 
                  400.0, 200.0, 2.0, 0.5, 0.5);
Delay(35*2);
}

// Health Spawner

Script SPAWN_HEALTH (int Type, int PlayrNum)
{
          
    SetFont("BIGFONT");
    SetHudSize(800, 600, 0);
    HudMessageBold(s:MedkitMsg[Random(0,3)]; HUDMSG_FADEINOUT, 1, CR_YELLOW, 
                  400.0, 200.0, 2.0, 0.5, 0.5);
    
    int MedkitRandom = Random(1, 100);
    if(MedkitRandom <= LVL_CHANCE_MEDKITS_SMALL) str    MedkitStr = "Stimpack";
                                        else            MedkitStr = "Medikit"; 
    
    AmbientSound("world/airdrop", 127);
    SetGravity(1000.0);
    Delay(35);
    
    SpawnSpot(MedkitStr, 50, 555, 0);
    SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);    
	if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
	{
    While( NotWater(555) == False )           
        {
            SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
            delay(1);
        }
	}
	else
	{
		SetActorPosition(555, Random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
	}
	
    SetActorPosition(555, GetActorX(555), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
    SetActorVelocity(555, 0, 0, -6, 1, 0);
	
	  AmbientSound(voices[PlayerSkin[PlayrNum]][1], 127);
        
    Delay(35);
    While(GetActorVelZ(555) < -1.0) Delay(5);
    
    Thing_ChangeTid(555, 0);
    SetGravity(Int2Fix(GAME_GRAVITY));
    Delay(35);
}

// Tool Crate spawner

Script SPAWN_TOOLCRATE (int PlayrNum)
{
    
    SetFont("BIGFONT");
    SetHudSize(800, 600, 0);
    HudMessageBold(s:ToolMsg[Random(0,3)]; HUDMSG_FADEINOUT, 1, CR_YELLOW, 
                  400.0, 200.0, 2.0, 0.5, 0.5);

    AmbientSound("world/airdrop", 127);
    SetGravity(1000.0);    
    Delay(35);
    
    SpawnSpot("ToolCrate", 50, 555, 0);
    SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
    
	if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
	{
    While( NotWater(555) == False )           
        {
            SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
            delay(1);
        }
    }
	else
	{
	SetActorPosition(555, Random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
	}
	
    SetActorPosition(555, GetActorX(555), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
    SetActorVelocity(555, 0, 0, -6, 1, 0);    

	  AmbientSound(voices[PlayerSkin[PlayrNum]][1], 127);

    Delay(35);
    While(GetActorVelZ(555) < -1.0) Delay(5);
    
    Thing_ChangeTid(555, 0);
    
    SetGravity(Int2Fix(GAME_GRAVITY));
    Delay(35);
}


// Weapon Crate Spawner


Script SPAWN_WEAPONCRATE (int PlayrNum)
{
    
    SetFont("BIGFONT");
    SetHudSize(800, 600, 0);
    HudMessageBold(s:CrateMsg[Random(0,3)]; HUDMSG_FADEINOUT, 1, CR_YELLOW, 
                  400.0, 200.0, 2.0, 0.5, 0.5);
                  
    AmbientSound("world/airdrop", 127);
    SetGravity(1000.0);
    Delay(35);
    
    SpawnSpot("WeaponCrate", 50, 555, 0);
    SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);    
    if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
	{
	While( NotWater(555) == False )           
        {
            SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
            delay(1);
        }
    }
	else
	{
		SetActorPosition(555, Random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
	}
	
    SetActorPosition(555, GetActorX(555), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
    SetActorVelocity(555, 0, 0, -10, 1, 0);    

	  AmbientSound(voices[PlayerSkin[PlayrNum]][1], 127);

    Delay(35);
    While(GetActorVelZ(555) < -1.0) Delay(5);
    Thing_ChangeTid(555, 0);
    
    SetGravity(Int2Fix(GAME_GRAVITY));
    Delay(35);
}

// Armor Spawner


Script SPAWN_ARMOR (int PlayrNum)
{  
    SetFont("BIGFONT");
    SetHudSize(800, 600, 0);
    HudMessageBold(s:ArmorMsg[Random(0,3)]; HUDMSG_FADEINOUT, 1, CR_YELLOW, 
                  400.0, 200.0, 2.0, 0.5, 0.5);        
                  
        int ArmorRandom = Random(1, 100);
        If(ArmorRandom <= LVL_CHANCE_ARMOR_GREEN)   str ArmorStr = "GreenArmor";
 else   if(ArmorRandom <= 100-LVL_CHANCE_ARMOR_RED)        ArmorStr = "BlueArmor";
                                            else        ArmorStr = "RedArmor";

        AmbientSound("world/airdrop", 127);
        SetGravity(1000.0);
        Delay(35);
    
        SpawnSpot(ArmorStr, 50, 555, 0);
            SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
		
		if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
		{
            While( NotWater(555) == False )           
                {
                SetActorPosition(555, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
                delay(1);
                }
        }
		else
		{
			SetActorPosition(555, Random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
		}
        SetActorPosition(555, GetActorX(555), LVL_YPOS, GetActorFloorZ(555)+3000.0, 0);
        SetActorVelocity(555, 0, 0, -10, 1, 0);            

		  AmbientSound(voices[PlayerSkin[PlayrNum]][1], 127);

        Delay(35);
        While(GetActorVelZ(555) < -1.0) Delay(5);
    
    Thing_ChangeTid(555, 0);
    SetGravity(Int2Fix(GAME_GRAVITY));
    Delay(35);
}


    ///////////////////////////
    // PLAYER WEAPON SCRIPTS //
    ///////////////////////////


// Player has no ammo display
Script 988 (VOID)
{
    SetFont("BIGFONT");
    SetHudSize(800, 600, 0);
    HudMessage(s:"No Ammo!"; HUDMSG_FADEINOUT, 50, CR_RED, 400.0, 150.0, 1.0, 0.2, 0.2);
}

str WeaponSound[MaxInventory] = 
			{ "Weapons\RocketLoad", "Weapons\GrenadeLoad", "Weapons\ClusterLoad",
            "Weapons\ShotgunLoad", "Weapons\UziLoad", "Weapons\MolotovLoad", 
			"Weapons\MineLoad", "Demon/Melee", "Weapons\BatLoad", "Weapons\PlasmaLoad", 
			"Weapons\BFGLoad", "Weapons\TeleportLoad", "Weapons\TeleportLoad", 
			"Weapons\RailLoad", "Weapons\GrenadeLoad","Weapons\HomingLoad", 
			"Weapons\KamikazeBomberLoad", "Weapons\GrenadeLoad", "Weapons\RocketLoad",
			"Weapons\GrenadeLoad", "Weapons\ShotgunLoad", "Weapons\ClusterDemonLoad",
			"Weapons\PlasmaLoad", "Weapons\GrenadeLoad", "Weapons\ClusterLoad", 
			"Weapons\ClusterLoad", "Weapons\GrenadeLoad", "Weapons\Chicken", "Weapons\TeleportLoad" };
			
str WeaponClass[5][MaxInventory] = { 
				{
				"SiskoBazooka", "SiskoGrenade", "SiskoCluster", "SiskoShotgun", 
				"SiskoUzi", "SiskoMolotov","SiskoMine", "SiskoDemon", "SiskoBat", "SiskoPlasma", 
				"SiskoBFG", "SiskoButton", "SiskoButton", "SiskoRailgun", "SiskoJetPack", 
				"SiskoBazooka", "SiskoHeadless", "SiskoButton", "SiskoBanana", "SiskoDynamite", 
				"Sisko", "SiskoClusterDemon", "SiskoButton", "SiskoButton", "Sisko", "SiskoButton", 
				"SiskoBackpack", "Sisko", "SiskoButton", "SiskoCrossbow"
				},
				{
				"OdoBazooka", "OdoGrenade", "OdoCluster", "OdoShotgun", 
				"OdoUzi", "OdoMolotov","OdoMine", "OdoDemon", "OdoBat", "OdoPlasma", 
				"OdoBFG", "OdoButton", "OdoButton", "OdoRailgun", "OdoJetpack", 
				"OdoBazooka", "OdoHeadless", "OdoButton", "OdoBanana", "OdoDynamite", 
				"Odo", "OdoClusterDemon", "OdoButton", "OdoButton", "Odo", "OdoButton", 
				"OdoBackpack", "Odo", "OdoButton", "OdoCrossbow"
				}, 
				{
				"ChiefBazooka", "ChiefGrenade", "ChiefCluster", "ChiefShotgun", 
				"ChiefUzi", "ChiefMolotov","ChiefMine", "ChiefDemon", "ChiefBat", "ChiefPlasma", 
				"ChiefBFG", "ChiefButton", "ChiefButton", "ChiefRailgun", "ChiefJetpack", 
				"ChiefBazooka", "ChiefHeadless", "ChiefButton", "ChiefBanana", "ChiefDynamite", 
				"Chief", "ChiefClusterDemon", "ChiefButton", "ChiefButton", "Chief", "ChiefButton", 
				"ChiefBackpack", "Chief", "ChiefButton", "ChiefCrossbow"
				},
				{
				"QuarkBazooka", "QuarkGrenade", "QuarkCluster", "QuarkShotgun", 
				"QuarkUzi", "QuarkMolotov","QuarkMine", "QuarkDemon", "QuarkBat", "QuarkPlasma", 
				"QuarkBFG", "QuarkButton", "QuarkButton", "QuarkRailgun", "QuarkJetpack", 
				"QuarkBazooka", "QuarkHeadless", "QuarkButton", "QuarkBanana", "QuarkDynamite", 
				"Quark", "QuarkClusterDemon", "QuarkButton", "QuarkButton", "Quark", "QuarkButton", 
				"QuarkBackpack", "Quark", "QuarkButton", "QuarkCrossbow"
				},
				{
				"CatBazooka", "CatGrenade", "CatCluster", "CatShotgun", 
				"CatUzi", "CatMolotov","CatMine", "CatDemon", "CatBat", "CatPlasma", 
				"CatBFG", "CatButton", "CatButton", "CatRailgun", "CatJetpack", 
				"CatBazooka", "CatHeadless", "CatButton", "CatBanana", "CatDynamite", 
				"Cat", "CatClusterDemon", "CatButton", "CatButton", "Cat", "CatButton", 
				"CatBackpack", "Cat", "CatButton", "CatCrossbow"
				} };

function void WeaponMorph (int PlayerNum, bool Returning, int WeaponNumber)
	{
		int MorphX = GetActorX(PlayerNum+500);
		int MorphZ = GetActorZ(PlayerNum+500);

	    int CurrentHealth = GetActorProperty(500+PlayerNum, APROP_HEALTH);
 	    int CurrentArmor = CheckActorInventory(500+PlayerNum, "BasicArmor");

	   	 UnMorphActor(500+PlayerNum, 1);

	if(Returning == False)
            MorphActor(500+PlayerNum, WeaponClass[PlayerSkin[PlayerNumber()]][WeaponNumber - 1], "", 1024768, MRF_FULLHEALTH | MRF_NEWTIDBEHAVIOUR | MRF_UNDOBYDEATHFORCED, "DummyAim", "DummyAim");
	if(Returning == True)
	    MorphActor(500+PlayerNum, WeaponClass[PlayerSkin[PlayerNumber()]][24], "", 1024768, MRF_FULLHEALTH | MRF_NEWTIDBEHAVIOUR | MRF_UNDOBYDEATHFORCED, "DummyAim", "DummyAim");
            
		SetActorProperty(500+PlayerNum, APROP_HEALTH, CurrentHealth);
		SetActorPosition(500+PlayerNum, MorphX, LVL_YPOS, MorphZ, 0);
      		GiveInventory("ArmorBonus", CurrentArmor);
	}

// Player weapon selection
Script 987 (int WeaponNumber) net
{
	Thing_Remove(960);
    delay(4);

    if(PlayerControl[HasFired][PlayerNumber()] == False) PlayerInts[WeaponIndex][PlayerNumber()] = WeaponNumber - 1;
    
    if(PlayerControl[PlayerTurn][PlayerNumber()] == True && PlayerControl[IsFiring][PlayerNumber()] == False && ShotgunShots == WEAPON_SHOTS_SHOTGUN)        
        
        {
            if(WeaponNumber != 13 || WeaponNumber != 12 || WeaponNumber != 16 || WeaponNumber != 18 || WeaponNumber != 26)
                { Thing_Remove(212); Thing_Remove(211); GUI_Cursor = False; }
            
            PlayerControl[Menu][PlayerNumber()] = False;
            ACS_Execute(3, 0, PlayerNumber()+500);
            ACS_Execute(996, 0, PlayerNumber());
            ACS_Execute(882, 0, PlayerNumber());
            SkinWeapon[PlayerNumber()] = WeaponNumber - 1;
		WeaponMorph(PlayerNumber(), 0, WeaponNumber);
		ChangeCamera(105, 0, 0);
            Delay(15);
            Shooting = True;
            SwitchedWeapon = True;
            
            PlayerWeapon[PlayerNumber()] = WeaponList[WeaponNumber - 1]; 
            ActivatorSound(WeaponSound[WeaponNumber-1], 127);

	    

            if(WeaponNumber == 15)
                {
                if(PlayerControl[JetpackUsed][PlayerNumber()] == True) 
                    { PlayerControl[JetpackUsed][PlayerNumber()] = False; PlayerInts[JetpackFuelRemaining][PlayerNumber()] = 150;}                
                }
                
                if(ShotgunShots == WEAPON_SHOTS_SHOTGUN && PlayerControl[JetpackUsed][PlayerNumber()] == False) 
                {
                    SetFont("BIGFONT");
                    SetHudSize(800,600,0);
                    HudMessageBold(s:"Weapon: ", s:WeaponNiceName[WeaponNumber-1]; HUDMSG_PLAIN, 22, CR_TAN, 320.0, 520.0, 0);
        
                    Delay(8);
                    SwitchedWeapon = False;
                }
	     if(WeaponNumber == 7 || WeaponNumber == 8 || WeaponNumber == 15 
		|| WeaponNumber == 17 || WeaponNumber == 20 || WeaponNumber == 22 
			|| WeaponNumber == 25 )
			    PlayerInts[Aim][PlayerNumber()] = 0;
            }
        }


// Homing missile scripts
// clientside TID enforcer
Script 855 (VOID) clientside
{
Thing_ChangeTid(0, ProjectileTID);
}

// Homing script
Script 983 (VOID)
{
     
    Delay(35);
    SetActorState(ProjectileTID, "NoGrav", 0);
    
    int HomingForceX = 0.05;
    int HomingForceZ = 0.05;

    //SetActorPitch(ProjectileTID, 0.25);

    While(ThingCount(T_NONE, ProjectileTID) != 0)

        {   
            if(HomingForceX < 1.2) HomingForceX += 0.02;
            if(HomingForceZ < 1.2) HomingForceZ += 0.02;
        
            SetActorPitch(ProjectileTID, GetTargetPitch(ProjectileTID, 212));
            SetActorAngle(ProjectileTID, GetTargetAngle(ProjectileTID, 212));
            
            int HomX = FixedMul(cos(GetActorAngle(ProjectileTID)), FixedMul(cos(GetActorPitch(ProjectileTID)), HomingForceX));
            int HomZ = FixedMul(sin(GetActorPitch(ProjectileTID)), HomingForceZ);
                       
            SetActorVelocity(ProjectileTID, HomX, 0, -HomZ, True, False);
//            ACS_ExecuteAlways(973, 0, HomX, HomZ);
            delay(1);
        }
}

function bool SpawnDemonCheck(int PlayrNum)
{
    bool Check = False;
    
    if( GetActorAngle(PlayrNum+500) >> 8 < 32 || 
            GetActorAngle(PlayrNum+500) >> 8 > 224 )

                { 
                    if(Spawn("BlockCheck", GetActorX(PlayrNum+500)+(18*65536), 
                                GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 799, 0) == True)
                                        Check = True;    
                }

    else        {   
                    if(Spawn("BlockCheck", GetActorX(PlayrNum+500)-(18*65536), 
                                GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 799, 0) == True)
                                        Check = True;    
                }
Thing_Remove(799);
return Check;
}

// Checks if there is space in front of the player to spawn the current weapon
function bool SpawnBlockCheck(int PlayrNum)
{
    bool Check = False;
    
    if( GetActorAngle(PlayrNum+500) >> 8 < 32 || 
            GetActorAngle(PlayrNum+500) >> 8 > 224 )

                { 
                    if(Spawn("BlockCheck", GetActorX(PlayrNum+500)+(17*65536), 
                                GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 799, 0) == True)
                                        Check = True;    
                }

    else        {   
                    if(Spawn("BlockCheck", GetActorX(PlayrNum+500)-(17*65536), 
                                GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 799, 0) == True)
                                        Check = True;    
                }
Thing_Remove(799);
return Check;
}

// Spawns a dummy actor to spawn projectiles in front of the player
function bool SpawnDummyFire(int PlayrNum)
{
    bool returning = false;
    
    if( GetActorAngle(PlayrNum+500) >> 8 < 32 || 
            GetActorAngle(PlayrNum+500) >> 8 > 224 )
            {
                if ( Spawn("DummyAim", GetActorX(PlayrNum+500)+(17*65536), 
                    GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 200, 0) == True) 
                        {   returning = True;  }
            }
    else 
        
        if ( Spawn("DummyAim", GetActorX(PlayrNum+500)-(17*65536), 
                    GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 200, 0) == True)
                        returning = True;
return returning;
}

function bool SpawnDummyPlace(int PlayrNum)
{
    bool returning = false;
    
    if( GetActorAngle(PlayrNum+500) >> 8 < 32 || 
            GetActorAngle(PlayrNum+500) >> 8 > 224 )
            {
                if ( Spawn("DummyPlace", GetActorX(PlayrNum+500)+(28*65536), 
                    GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 200, 0) == True) 
                        {   returning = True;  }
            }
    else 
        
        if ( Spawn("DummyPlace", GetActorX(PlayrNum+500)-(28*65536), 
                    GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(32*65536), 200, 0) == True)
                        returning = True;
Thing_Remove(200);
return returning;
}


//Forces the player to face either left or right
function void ForceDirection(int PlayrNum)
{
        if( GetActorAngle(PlayrNum+500) >> 8 < 32 || 
            GetActorAngle(PlayrNum+500) >> 8 > 224 )                
                SetActorAngle(PlayrNum+500, 1.0);
        else    SetActorAngle(PlayrNum+500, 0.5);
	SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500), 0);
}

// Calculate the X force applied to a projectile
function int CalcMisX (int PlayrNum, int WeaponForceX)
{
MisX = FixedMul(cos(PlayerInts[FacingAngle][PlayrNum] >> 8), FixedMul(cos(PlayerInts[Aim][PlayrNum]), WeaponForceX));
return MisX;
}

// Calculate the Z force applied to a projectile
function int CalcMisZ (int PlayrNum, int WeaponForceZ)
{
MisZ = FixedMul(sin(PlayerInts[Aim][PlayrNum]), WeaponForceZ);
return MisZ;
}

Script 996 (int PlayrNum) 
{

//Ammo Checks    
if(PlayerControl[HasFired][PlayrNum] == True) terminate;

for(int AmmoCheck = 0; AmmoCheck < MaxInventory; AmmoCheck++)
    {
        if((PlayerWeapon[PlayrNum] == WeaponList[AmmoCheck]) && (Inventory[PlayrNum][AmmoCheck] == 0))
        { 
            ACS_Execute(988, 0); 
            Delay(15); 
            restart; 
        }
    }

        WeaponForce = 0;
        int WeaponForceX = 0;
        int WeaponForceZ = 0;      
        
        ForceDirection(PlayrNum);
   

                                                    ///////////////////////////////////////////
                                                    // FIRING BAZOOKA, GRENADE/CLUSTER, MOLOTOV
                                                    ///////////////////////////////////////////
if( PlayerWeapon[PlayrNum] == "BazookaRocket" ||
        PlayerWeapon[PlayrNum] == "Grenade" ||
        PlayerWeapon[PlayrNum] == "Cluster" ||
        PlayerWeapon[PlayrNum] == "Molotov" ||
        PlayerWeapon[PlayrNum] == "PlasmaGun" ||
        PlayerWeapon[PlayrNum] == "WeaponBFG" ||
        PlayerWeapon[PlayrNum] == "Banana" ||
        (PlayerWeapon[PlayrNum] == "HomingMissile" &&
        ThingCountName("GUITarget2", 212) != 0) && Targetted == True)    
 
                {

        while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN) 
            
                {
                
                if( PlayerWeapon[PlayrNum] != "BazookaRocket" &&
                    PlayerWeapon[PlayrNum] != "Grenade" &&                 
                    PlayerWeapon[PlayrNum] != "Cluster" &&
                    PlayerWeapon[PlayrNum] != "Molotov" &&
                    PlayerWeapon[PlayrNum] != "PlasmaGun" &&
                    PlayerWeapon[PlayrNum] != "WeaponBFG" &&
                    PlayerWeapon[PlayrNum] != "Banana" &&
                    PlayerWeapon[PlayrNum] != "HomingMissile" ) 
                            { delay(8); Shooting = True; restart; }
                           
                int PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);   
                    
                    int CurrentWeapon = PlayerWeapon[PlayrNum];
                    delay(1);
                    
                while(PlayerFire & BT_ATTACK)                               // Check for input, increase weapon force
                {

                    SetPlayerProperty(0, ON, PROP_FROZEN);
                   
                    ForceDirection(PlayrNum);

                    PlayerControl[IsFiring][PlayrNum] = True;                              // Up to a maximum of 100
                    PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
                    if(WeaponForce >= 100) { WeaponForce = 100; break; }
                    if(!PlayerFire & BT_ATTACK) break;
                    SetActorState(500+PlayrNum, "PreFiring");
                    WeaponForce++;
                    GiveActorInventory(500+PlayrNum, "ForceItem", 1);
                
                    Delay(2);

                    
                }
            
            if(WeaponForce !=0) 
                {

		    if(PlayerWeapon[PlayrNum] == "Grenade" ||
			PlayerWeapon[PlayrNum] == "Cluster" || 
			 PlayerWeapon[PlayrNum] == "Molotov" )
			AmbientSound(voices[PlayerSkin[PlayrNum]][9], 127);
		else if(PlayerWeapon[PlayrNum] == "Banana")
			AmbientSound(voices[PlayerSkin[PlayrNum]][10], 127);
		else
			AmbientSound(voices[PlayerSkin[PlayrNum]][2], 127);
			
			Delay(35);
                                     
                    if(PlayerWeapon[PlayrNum] == "WeaponBFG")
                        {
                            AmbientSound("weapons/bfgf", 127);
                            Delay(30);
                        }
                        
                    WeaponForce = Weaponforce * 2;
                    SetActorState(500+PlayrNum, "Firing");
                    SetPlayerProperty(0, ON, PROP_FROZEN);
                    
                    CalcMisX(PlayrNum, WeaponForce); 
                    CalcMisZ(PlayrNum, WeaponForce);
                    ForceDirection(PlayrNum);
                                  
                        Delay(8);

                    if(PlayerWeapon[PlayrNum] != "PlasmaGun" && PlayerWeapon[PlayrNum] != "HomingMissile")
                        {
                            if(PlayerWeapon[PlayrNum] == "Grenade" || PlayerWeapon[PlayrNum] == "Cluster")
                                AmbientSound("weapons\grenadethrow", 127);
                                
                            SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)+32.0, 0);
                            SpawnProjectile(PlayrNum+500, CurrentWeapon, PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 1, ProjectileTID);
                            SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)-32.0, 0);
                            SetActorProperty(ProjectileTID, APROP_HEALTH, FuseSeconds[PlayrNum]);
                            SetActorAngle(ProjectileTID, PlayerInts[FacingAngle][PlayrNum]);
                            PlayerControl[HasFired][PlayrNum] = True;
                            if(PlayerWeapon[PlayrNum] == "BazookaRocket") Inventory[PlayrNum][0] -= 1;
                    else    if(PlayerWeapon[PlayrNum] == "Grenade") Inventory[PlayrNum][1] -= 1;
                    else    if(PlayerWeapon[PlayrNum] == "Cluster") Inventory[PlayrNum][2] -= 1;
                    else    if(PlayerWeapon[PlayrNum] == "WeaponBFG") Inventory[PlayrNum][10] -= 1;
                    else    if(PlayerWeapon[PlayrNum] == "Banana") Inventory[PlayrNum][18] -= 1;
                    else    if(PlayerWeapon[PlayrNum] == "Molotov") Inventory[PlayrNum][5] -= 1;
                            Delay(1);
                        }
                   else if(PlayerWeapon[PlayrNum] == "PlasmaGun")
                            for(int PlasmaShots = WEAPON_SHOTS_PLASMA; PlasmaShots > 0; PlasmaShots--)
                                {
                                 
                                    CalcMisX(PlayrNum, WeaponForce); 
                                    CalcMisZ(PlayrNum, WeaponForce);
                                    
                                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)+32.0, 0);
                                    SpawnProjectile(PlayrNum+500, CurrentWeapon, PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 1, ProjectileTID);
                                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)-32.0, 0);
                                    SetActorState(500+PlayrNum, "Firing");
                                    SetActorProperty(ProjectileTID, APROP_HEALTH, FuseSeconds[PlayrNum]);
                                    SetActorAngle(ProjectileTID, PlayerInts[FacingAngle][PlayrNum]);
                                    Delay(15);
                                    
                                        ForceDirection(PlayrNum);
                
                                        if(PlasmaShots == 1) 
						{ PlayerControl[HasFired][PlayrNum] = True; 
							Inventory[PlayrNum][9] -= 1; }
                                }
                                
                    else if(PlayerWeapon[PlayrNum] == "HomingMissile")
                        {
                                
                            SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)+32.0, 0);
                            SpawnProjectile(PlayrNum+500, CurrentWeapon, PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 1, ProjectileTID);
                            SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)-32.0, 0);
                            SetActorAngle(ProjectileTID, PlayerInts[FacingAngle][PlayrNum]);
                            PlayerControl[HasFired][PlayrNum] = True;
                            Inventory[PlayrNum][15] -= 1;
                            Delay(1);
                            ACS_Execute(983, 0);
                            Targetted = False;
                        }
                    TakeActorInventory(500+PlayrNum, "PreviousForceItem", 999);
                    GiveActorInventory(500+PlayrNum, "PreviousForceItem", CheckactorInventory(500+playrnum, "ForceItem"));
                    TakeActorInventory(500+PlayrNum, "ForceItem", 999);
                    WeaponForce = 0;                                        // Reset force

                    
                    PlayerControl[IsFiring][PlayrNum] = false;
                    
                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;

		TakeActorInventory(PlayrNum+500, "PreviousAimItem", CheckActorInventory(PlayrNum+500, "PreviousAimItem"));
		GiveActorInventory(PlayrNum+500, "PreviousAimItem", PreviousAngle[PlayrNum]);

                    Delay(12);
                    SetActorState(500+PlayrNum, "DoneFiring", 0);
                    SetPlayerProperty(0, OFF, PROP_FROZEN);
                    Terminate;
                }
            }
            if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        }






                                                    ////////////////
                                                    // FIRING SHOTGUN
                                                    ////////////////

else if(PlayerWeapon[PlayrNum] == "WeaponShotgun")
        {
            
            while(Shooting == True) 
            {
            if(PlayerWeapon[PlayrNum] != "WeaponShotgun" && ShotgunShots == WEAPON_SHOTS_SHOTGUN) break;
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            if(PlayerFire & BT_ATTACK)
                {
                    PlayerControl[IsFiring][PlayrNum] = True;
                    WeaponForce = 2000;
                    SetActorState(500+PlayrNum, "Firing");
                    SetPlayerProperty(0, ON, PROP_FROZEN);
                    
                        Delay(1);
                        
                    CalcMisX(PlayrNum, WeaponForce); 
                    CalcMisZ(PlayrNum, WeaponForce);
            
                    ActivatorSound("shotguy/attack", 127);
                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)+32.0, 0);
                    SpawnProjectile(PlayrNum+500, "ShotgunShells", PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 0, ProjectileTID);
                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)-32.0, 0);
                    Delay(8);
                    
                    SetActorState(500+PlayrNum, "DoneFiring", 0);
                    SetPlayerProperty(0, OFF, PROP_FROZEN);
                    ACS_Execute(3, 0, PlayrNum+500);

                    WeaponForce = 0;        
                    
                    PlayerControl[IsFiring][PlayrNum] = false;
                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                    
                    ShotgunShots--;
                    Delay(35);
                    
                    if(ShotgunShots == 0) 
                        { 
				Inventory[PlayrNum][3] -= 1; 
				ShotgunShots = WEAPON_SHOTS_SHOTGUN; 
				PlayerControl[HasFired][PlayrNum] = True; Terminate; }
                }
            if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        }
        if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
    }

                                                    ////////////////
                                                    // FIRING UZI
                                                    ////////////////

    else if(PlayerWeapon[PlayrNum] == "WeaponUzi" || PlayerWeapon[PlayrNum] == "Flamethrower")
        {
            
            while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN)
            {
            if(PlayerWeapon[PlayrNum] != "WeaponUzi" && Playerweapon[PlayrNum] != "Flamethrower") break;
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            
            while(PlayerFire & BT_ATTACK)
                {
                    if(PlayerWeapon[PlayrNum] == "WeaponUzi") 
                        {
                            PlayerControl[IsFiring][PlayrNum] = True;
                            WeaponForce = 2000;
                            SetActorState(500+PlayrNum, "Firing");
                            SetPlayerProperty(0, ON, PROP_FROZEN);

                            Delay(1);
                                                            
                            For(int UziLoop = 10; UziLoop > 0; UziLoop--)
                                {
                            
                                    CalcMisX(PlayrNum, WeaponForce); 
                                    CalcMisZ(PlayrNum, WeaponForce);
                            
                                    AmbientSound("weapons\uzifire", 127);                    

                                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)+32.0, 0);
                                    SetActorState(500+PlayrNum, "Firing");
                                    SpawnProjectile(500+PlayrNum, "UziShot", PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ+Random(-4, 4), 1, 0);
                                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)-32.0, 0);
                                    Delay(6);
                                }
				Inventory[PlayrNum][4] -= 1;
                            }
                    if(PlayerWeapon[PlayrNum] == "Flamethrower")
                        {
                            PlayerControl[IsFiring][PlayrNum] = True;
                            WeaponForce = 100;
                            SetActorState(500+PlayrNum, "Firing");
                            SetPlayerProperty(0, ON, PROP_FROZEN);

                            Delay(1);
                                                            
                            For(int FlameLoop = 4; FlameLoop > 0; FlameLoop--)
                                {
                            
                                    CalcMisX(PlayrNum, WeaponForce); 
                                    CalcMisZ(PlayrNum, WeaponForce);
                            
                                    AmbientSound("weapons\flamefire", 127);                    
                                
                                    SetActorState(500+PlayrNum, "Firing");
                                        SetActorPosition(500+PlayrNum,
                                            GetActorX(500+PlayrNum),
                                            GetActorY(500+PlayrNum),
                                            GetActorZ(500+PlayrNum)+24.0, 0);
                                    
                                    SpawnProjectile(500+PlayrNum, "FireSpawner", PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 1.0, 0);
                                    
                                    SetActorState(500+PlayrNum, "Firing");
                                        SetActorPosition(500+PlayrNum,
                                            GetActorX(500+PlayrNum),
                                            GetActorY(500+PlayrNum),
                                            GetActorZ(500+PlayrNum)-24.0, 0);
                                            
                                    Delay(6);
                                }
				Inventory[PlayrNum][20] -= 1;
                            }
                    Delay(8);        

                    WeaponForce = 0;        
                    
                    PlayerControl[IsFiring][PlayrNum] = false;
                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                    PlayerFire = 0;

                    PlayerControl[HasFired][PlayrNum] = True;
                    
                    SetActorState(500+PlayrNum, "DoneFiring", 0);
                    SetPlayerProperty(0, OFF, PROP_FROZEN);
                    terminate;
                }
            if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        }
        if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        
    }



                                                    ////////////////
                                                    // FIRING MINE
                                                    ////////////////
                                                    
else if(PlayerWeapon[PlayrNum] == "Mine" || PlayerWeapon[PlayrNum] == "Dynamite")
        {
            
            PlayerControl[HasFired][PlayrNum] = False;
            while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN) 
            {
            if(PlayerWeapon[PlayrNum] != "Mine" && PlayerWeapon[PlayrNum] != "Dynamite") break;
            
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);

            if(PlayerFire & BT_ATTACK &&
                ( SpawnDummyFire(PlayrNum) == True))
                    {
                            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
                            PlayerControl[IsFiring][PlayrNum] = True;
                    	    SetPlayerProperty(0, ON, PROP_TOTALLYFROZEN);
			    SetActorState(500+PlayrNum, "Dropping");
			    Delay(18);
                    if(PlayerControl[HasFired][PlayrNum] == True) terminate;
                    	    SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
                            WeaponForce = 0;
                            SpawnProjectile(PlayrNum+500, PlayerWeapon[PlayrNum], PlayerInts[FacingAngle][PlayrNum] >> 8, 3, 1, 1, ProjectileTID);
                            SetActorProperty(ProjectileTID, APROP_HEALTH, FuseSeconds[PlayrNum]);
                            Delay(35);
                            Thing_ChangeTid(ProjectileTID, 0);
                            Delay(6);
                    }
                    
                    if(PlayerControl[IsFiring][PlayrNum] == False) { delay(1); restart; }
                    
                    WeaponForce = 0;        
                    AmbientSound(voices[PlayerSkin[PlayrNum]][12], 127);
                    PlayerControl[IsFiring][PlayrNum] = false;
                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                    PlayerFire = 0;
                    if(PlayerWeapon[PlayrNum] == "Mine") 
					Inventory[PlayrNum][6] -= 1;
                    else Inventory[PlayrNum][19] -= 1;
                    PlayerControl[HasFired][PlayrNum] = True;
                    terminate;
                }
        if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        }
    
                                                    ////////////////
                                                    // FIRING DEMON
                                                    ////////////////    

else if(PlayerWeapon[PlayrNum] == "WeaponDemon" || PlayerWeapon[PlayrNum] == "ClusterDemon" )
        {
            
            PlayerControl[HasFired][PlayrNum] = False;
            while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN) 
            {
            if(PlayerWeapon[PlayrNum] != "WeaponDemon" && PlayerWeapon[PlayrNum] != "ClusterDemon") break;
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            if(PlayerFire & BT_ATTACK)
                    {
                        PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
                        PlayerControl[IsFiring][PlayrNum] = True;
                    
                            if(PlayerControl[HasFired][PlayrNum] == True) terminate;
                    
                            //if(SpawnDemonCheck(PlayrNum) == True)
                                {
                                    Delay(3);
                                    
                                    WeaponForce = 20;
                                    CalcMisX(PlayrNum, WeaponForce); 
                                    CalcMisZ(PlayrNum, WeaponForce);
                                    SetActorState(500+PlayrNum, "Firing");
                                    delay(4);
                                
                                    if(PlayerWeapon[PlayrNum] == "WeaponDemon")
                                        {    
                                            SetActorPosition(500+PlayrNum, GetActorX(500+PlayrNum), LVL_YPOS,
                                                            GetActorZ(500+PlayrNum)+32.0, 0);
                                            SpawnProjectile(500+PlayrNum, "WeaponDemon", PlayerInts[FacingAngle][PlayrNum] >> 8, 20, 8, 1, ProjectileTID);
                                            SetActorPosition(500+PlayrNum, GetActorX(500+PlayrNum), LVL_YPOS,
                                                            GetActorZ(500+PlayrNum)-32.0,0);
                                            Inventory[PlayrNum][7] -= 1;
                                        }
                                
                                else if (PlayerWeapon[PlayrNum] == "ClusterDemon")
                                        {
                                            SetActorPosition(500+PlayrNum, GetActorX(500+PlayrNum), LVL_YPOS,
                                                            GetActorZ(500+PlayrNum)+32.0,0);
                                            SpawnProjectile(500+PlayrNum, "ClusterDemon", PlayerInts[FacingAngle][PlayrNum] >> 8, 20, 8, 1, ProjectileTID);
                                            SetActorPosition(500+PlayrNum, GetActorX(500+PlayrNum), LVL_YPOS,
                                                            GetActorZ(500+PlayrNum)-32.0,0);
						Inventory[PlayrNum][21] -= 1;
                                        }
                                        
                                    SetActorState(500+PlayrNum, "DoneFiring", 0);
                                    Delay(35);
                                    ACS_Execute(948, 0, PlayrNum);

                                    PlayerControl[HasFired][PlayrNum] = True;                    
                                    WeaponForce = 0;        
                    
                                    PlayerControl[IsFiring][PlayrNum] = false;
                                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                                    PlayerFire = 0;
                                    terminate;                    
                                }                     
                    Delay(6);                 
                    if(PlayerControl[IsFiring][PlayrNum] == False) { delay(1); restart; }          
                }
                if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
            }
            if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        }
     


     
else if(PlayerWeapon[PlayrNum] == "BaseballBat" || PlayerWeapon[PlayrNum] == "Kick" || PlayerWeapon[PlayrNum] == "SkipTurnAmmo")
    {
        PlayerControl[HasFired][PlayrNum] = False;
        while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN) 
        {
            if(PlayerWeapon[PlayrNum] != "BaseballBat" && PlayerWeapon[PlayrNum] != "Kick" && PlayerWeapon[PlayrNum] != "SkipTurnAmmo") break;
            
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            if(PlayerFire & BT_ATTACK)
            {
                if(PlayerWeapon[PlayrNum] == "BaseballBat")
                {   
                    WeaponForce = 50;
                    
                    PlayerControl[IsFiring][PlayrNum] = True;
                        
                    BatPlayer = PlayrNum;
                        
                    Delay(1);
                    
                    CalcMisX(PlayrNum, WeaponForce); 
                    CalcMisZ(PlayrNum, WeaponForce);
                    BatX = MisX;
                    BatZ = MisZ;
                            
                    SetActorState(500+PlayrNum, "Firing");
                    SetActorPosition(500+PlayrNum, GetActorX(500+PlayrNum), LVL_YPOS,
                                                            GetActorZ(500+PlayrNum)+32.0,0);
                    SpawnProjectile(500+PLayrNum, "BaseballBat", PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 0, 0);
                    SetActorPosition(500+PlayrNum, GetActorX(500+PlayrNum), LVL_YPOS,
                                                            GetActorZ(500+PlayrNum)-32.0,0);
                    SetActorPosition(ProjectileTID, GetActorX(500+PlayrNum), LVL_YPOS, GetActorZ(500+PlayrNum)+32.0, 0);
                    SetActorState(500+PlayrNum, "DoneFiring", 0);
                    Delay(41);
                }

                else if(PlayerWeapon[PlayrNum] == "Kick")
                {
                    PlayerControl[IsFiring][PlayrNum] = True;
                    SetActorState(PlayrNum+500, "Kick");
                    KickFacing = GetActorAngle(500+PlayrNum);
                    Delay(4);
                }

                else if(PlayerWeapon[PlayrNum] == "SkipTurnAmmo")
                {
                    PlayerControl[IsFiring][PlayrNum] = True;
                    AmbientSound("weapons\chicken2", 127);
                }   
                                                       
            }
                    
            if(PlayerControl[IsFiring][PlayrNum] == False) 
            { 
                delay(1);
                restart; 
            }

            WeaponForce = 0;        
            PlayerControl[IsFiring][PlayrNum] = false;
            PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
            PlayerFire = 0;
            
            if(PlayerWeapon[PlayrNum] == "BaseballBat") Inventory[PlayrNum][8] -= 1;
            else if(PlayerWeapon[PlayrNum] == "Kick")

            Inventory[PlayrNum][24] -= 1;

            PlayerControl[HasFired][PlayrNum] = True;
            terminate;
        }
        if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
    }
                                                    
                                                    
                                                    
                                                    
                                                    ////////////////
                                                    // FIRING TELEPORT
                                                    ////////////////

else if(PlayerWeapon[PlayrNum] == "ItemTeleport" && ShotgunShots == WEAPON_SHOTS_SHOTGUN)

{
    GUI_Cursor = False;
    Thing_Remove(211);
    Thing_Remove(212);
    delay(1);                
    Spawn("GuiCursor", GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500), 215, 0);
	Spawn("PlayerTeleport", GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500), 211, 0);
    GUI_Cursor = True;
    While(GUI_Clicked == False && PlayerWeapon[PlayrNum] == "ItemTeleport") Delay(1);

    if(PlayerWeapon[PlayrNum] != "ItemTeleport") 
		{ 
        GUI_Clicked = False;
        GUI_Cursor = False;
        Thing_Remove(211);
        Thing_Remove(212);
        delay(1); restart; 
		}             
                        
    GUI_Clicked = False;
    GUI_Cursor = False;

    Thing_Move(PlayrNum+500, 212, 0);
	SpawnSpot("TeleportFogNormal", 212, 0, 0);
	AmbientSound("misc/teleport", 100);
    Thing_Remove(212);
    SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
    Inventory[PlayrNum][11] -= 1;
    PlayerControl[HasFired][PlayrNum] = True;
                    
}

                                                    ////////////////
                                                    // FIRING AIRSTRIKE / NAPALM STRIKE
                                                    ////////////////

else if((PlayerWeapon[PlayrNum] == "AirStrike" || PlayerWeapon[PlayrNum] == "NapalmStrikeAmmo") && ShotgunShots == WEAPON_SHOTS_SHOTGUN)
    {
        GUI_Cursor = False;
        Thing_Remove(212);
        Thing_Remove(211);
        delay(4);                
        Spawn("GuiCursor", GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500), 211, 0);
        GUI_Cursor = True;

        While((GUI_Clicked == False && ClientMenu[PlayrNum] == false) && (PlayerWeapon[PlayrNum] == "AirStrike" || PlayerWeapon[PlayrNum] == "NapalmStrikeAmmo")) Delay(3);

        if(PlayerWeapon[PlayrNum] != "AirStrike" && PlayerWeapon[PlayrNum] != "NapalmStrikeAmmo") 
        { 	
            GUI_Clicked = False;
            GUI_Cursor = False;
            Thing_Remove(211);
            Thing_Remove(212);
            delay(1); 
            restart;
        }             
                        
        GUI_Clicked = False;
        GUI_Cursor = False;

	 	     AmbientSound (voices[PlayerSkin[PlayrNum]][11], 127);
        AmbientSound ("weapons\airraid", 127);
        Delay(35);
        AmbientSound ("world/airdrop", 127);
        SetActorPosition(212, GetActorX(212), LVL_YPOS, GetActorFloorZ(212)+2000.0, 0);
                
        Airstrike = True;
        if(PlayerWeapon[PlayrNum] == "AirStrike")
        {
            For(int AirstrikeRockets = 6; AirstrikeRockets > 0; AirstrikeRockets--)
            {
                SpawnProjectile(212, "AirstrikeRocket", 0, 0, 0, 1, 220 + AirstrikeRockets);
                SetActorPosition(220 + AirstrikeRockets, GetActorX(212)-256*65536 + AirstrikeRockets*96.0 , LVL_YPOS, 2000.0, 0);
                ThrustThingZ(220, 8, 1, 1);
                Thing_ChangeTid(220 + AirstrikeRockets, ProjectileTID);
                Delay(5);                            
            }
        }
        else
        {
            For(AirstrikeRockets = 6; AirstrikeRockets > 0; AirstrikeRockets--)
            {
                SpawnProjectile(212, "NapalmStrikeRocket", 0, 0, 0, 1, 220 + AirstrikeRockets);
                SetActorPosition(220 + AirstrikeRockets, GetActorX(212)-256*65536 + AirstrikeRockets*96.0 , LVL_YPOS, 2000.0, 0);
                ThrustThingZ(220, 8, 1, 1);
                Thing_ChangeTid(220 + AirstrikeRockets, ProjectileTID);
                Delay(5);                            
            }
                    
            Airstrike = False;
            GUI_Clicked = False;
            GUI_Cursor = False;
            Thing_Remove(212);
            SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
		
            if(PlayerWeapon[PlayrNum] == "AirStrike") Inventory[PlayrNum][AirStrike] -= 1;
            else	Inventory[PlayrNum][NapalmStrike] -= 1;
            
            PlayerControl[HasFired][PlayrNum] = True;
                    
        }
    }
                                                    ////////////////
                                                    // FIRING RAILGUN
                                                    ////////////////
else if(PlayerWeapon[PlayrNum] == "WeaponRailGun")
        {
            
            while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN ) 
            {
            if(PlayerWeapon[PlayrNum] != "WeaponRailGun") break;
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            
            if(PlayerFire & BT_ATTACK)
                {
                    PlayerControl[IsFiring][PlayrNum] = True;
                    WeaponForce = 2000;
                    SetActorState(500+PlayrNum, "Firing");
                    SetPlayerProperty(0, ON, PROP_FROZEN);
                    
                        Delay(1);
                        
                    CalcMisX(PlayrNum, WeaponForce); 
                    CalcMisZ(PlayrNum, WeaponForce);
                    
                        if(GetActorAngle(PlayrNum+500) >> 8 < 32 || 
                            GetActorAngle(PlayrNum+500) >> 8 > 224 )    
                            Spawn("RailDummy", GetActorX(PlayrNum+500)+(17*65536), LVL_YPOS, GetActorZ(PlayrNum+500)+(32*65536), 200, PlayerInts[FacingAngle][PlayrNum] >> 8);
                                else
                            Spawn("RailDummy", GetActorX(PlayrNum+500)-(17*65536), LVL_YPOS, GetActorZ(PlayrNum+500)+(32*65536), 200, PlayerInts[FacingAngle][PlayrNum] >> 8);
                    
                    SetActorPitch(200, -PlayerInts[Aim][PlayrNum]);
                    SetActorState(200, "RailFire", 0);
                    
                    Delay(8);        
                    SetActorState(500+PlayrNum, "DoneFiring", 0);
                    SetPlayerProperty(0, OFF, PROP_FROZEN);

                    WeaponForce = 0;        
                    
                    PlayerControl[IsFiring][PlayrNum] = false;
                    PlayerControl[HasFired][PlayrNum] = true;
                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                    
                    Inventory[PlayrNum][13] -= 1;
                    terminate;
                }
                Delay(1);
            }
         }


                                                    ////////////////
                                                    // FIRING PARACHUTE
                                                    ////////////////
         
    else if(PlayerWeapon[PlayrNum] == "ParachuteAmmo")
    {
        while(Shooting == True && PlayerControl[IsFiring][PlayrNum] == False && ShotgunShots == WEAPON_SHOTS_SHOTGUN ) 
        {
            if(PlayerWeapon[PlayrNum] !="ParachuteAmmo") break;

            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            
            While(PlayerFire & BT_ATTACK && Inventory[PlayrNum][26] > 0)
            {
                delay(2);

                if(GetActorVelZ(PlayrNum+500) == 0) restart;

                SetActivator(PlayrNum+500);
                SpawnSpot("Parachute", PlayrNum+500, 1290, GetActorAngle(PlayrNum+500));
                
                While(GetActorVelz(PlayrNum+500) != 0 && PlayerFire & BT_ATTACK)
                {
                    SetActorPosition(PlayrNum+500, GetActorX(1290), LVL_YPOS, GetActorZ(1290), 0);
                    SetActorVelocity(1290, GetActorVelX(PlayrNum+500), 0, GetActorVelZ(PlayrNum+500), 0, 0);

                    if(GetActorVelZ(PlayrNum+500) < -2.0)
                    {
                        SetActorVelocity(1290, GetActorVelX(PlayrNum+500), 0, -2.0, 0, 0);
                        SetActorVelocity(PlayrNum+500, GetActorVelX(PlayrNum+500), 0, -2.0, 0, 0);
                    }
					
					if(PlayerFire & BT_LOOKUP)
					{
						SetActorVelocity(1290, GetActorVelX(PlayrNum+500), 0, -0.75, 0, 0);
                        SetActorVelocity(PlayrNum+500, GetActorVelX(PlayrNum+500), 0, -0.75, 0, 0);
					}
					
                    Delay(1);
                    PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
                                          
                }
                        
                Thing_Remove(1290);
                Delay(2);
                
                WeaponForce = 0;
                PlayerFire = 0;
                Inventory[PlayrNum][26] -= 1; 
            }
                    
            Delay(1); 
            Restart;
        }
            
        if(PlayerControl[HasFired][PlayrNum] == False) Delay(1); Restart;
    }

	                                                ////////////////
                                                    // FIRING NINJA ROPE
                                                    ////////////////
         
else if(PlayerWeapon[PlayrNum] == "RopeAmmo")
        {

            while(Shooting == True && PlayerControl[IsFiring][PlayrNum] == False && ShotgunShots == WEAPON_SHOTS_SHOTGUN ) 
            {
            
            if(PlayerWeapon[PlayrNum] != "RopeAmmo") 
				{ Thing_Remove(210); break; }

            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            
            if(PlayerFire & BT_ATTACK)
                {
				
				if(PlayerInts[RopesRemaining][PlayrNum] == 0 &&
					Inventory[PlayrNum][NinjaRope] > 0)
					
					PlayerInts[RopesRemaining][PlayrNum] = WEAPON_POWERS[NinjaRope];
					
				if(ThingCountName("RopeHook", 0) > 0)
					{
					PlayerFire = 0;
					delay(8);
					Thing_Remove(ProjectileTID);
					}					
				else
					{
                    WeaponForce = 300;
                    SetActorState(500+PlayrNum, "Firing");
                    SetPlayerProperty(0, ON, PROP_FROZEN);
                    
                        Delay(1);
                        
                    CalcMisX(PlayrNum, WeaponForce); 
                    CalcMisZ(PlayrNum, WeaponForce);
            
                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)+32.0, 0);
                    SpawnProjectile(PlayrNum+500, "RopeHook", PlayerInts[FacingAngle][PlayrNum] >> 8, MisX, MisZ, 0, ProjectileTID);
                    SetActorPosition(PlayrNum+500, GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500)-32.0, 0);
                    Delay(20);
					
										
					while(GetActorVelZ(ProjectileTID) + GetActorVelX(ProjectileTID) != 0)
						delay(1);
						
					SetActorState(500+PlayrNum, "DoneFiring", 0);
                    ACS_Execute(3, 0, PlayrNum+500);
					
					while(ThingCount(0, projectiletid) == 1)
					{			
						delay(1);
						PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
						
						if(PlayerFire & BT_ATTACK)
							Thing_Remove(ProjectileTID);	
						if(PlayerFire & BT_MOVERIGHT)
							SetActorVelocity(PlayrNum+500, GetActorVelX(PlayrNum+500)+0.5, 0, GetActorVelZ(PlayrNum+500), 0, 0);
						if(PlayerFire & BT_MOVELEFT)
							SetActorVelocity(PlayrNum+500, GetActorVelX(PlayrNum+500)-0.5, 0, GetActorVelZ(PlayrNum+500), 0, 0);
							
						int RopeLength = GetPlayerInput(PlayrNum, INPUT_UPMOVE);
						
						if(RopeLength > 0)
							PlayerInts[RopeLengthMod][PlayrNum] = 5;
						else if(RopeLength < 0)	
							PlayerInts[RopeLengthMod][PlayrNum] = -5;
						else if(RopeLength == 0)
							PlayerInts[RopeLengthMod][PlayrNum] = 0;
							
						ACS_Execute(ROPE_HOLD, 0, PlayrNum+500, -1, 100);
							
					}
					
					SetPlayerProperty(0, OFF, PROP_FROZEN);
					if(PlayerInts[RopesRemaining][PlayrNum] > 0)
						PlayerInts[RopesRemaining][PlayrNum]--;
						
					else Inventory[PlayrNum][NinjaRope]--;
					
                    WeaponForce = 0;        
                    
                    PlayerControl[IsFiring][PlayrNum] = false;
                    PreviousAngle[PlayrNum] = 45;
					}
				
                }

                             
                Delay(1); Restart;
            }
            
            if(PlayerControl[HasFired][PlayrNum] == False) Delay(1); Restart;
        } 

                                                    ////////////////
                                                    // FIRING JETPACK
                                                    ////////////////
         
else if(PlayerWeapon[PlayrNum] == "ItemJetpack")
        {

            while(Shooting == True && PlayerControl[IsFiring][PlayrNum] == False && ShotgunShots == WEAPON_SHOTS_SHOTGUN 
                    && PlayerControl[JetpackUsed][PlayrNum] == false ) 
            {
            
            if(PlayerWeapon[PlayrNum] != "ItemJetpack") break;

            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            
            while(PlayerFire & BT_ATTACK && PlayerInts[JetpackFuelRemaining][PlayrNum] != 0)
                {
                    
                    if(PlayerWeapon[PlayrNum] != "ItemJetpack") break;
                                        
                    PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
                    
                    SetActivator(PlayrNum+500);
		//  ACS_Execute(985, 0, PlayrNum+500);
                    
                    if(GetActorAngle(PlayrNum+500) >> 8 < 32 || 
                        GetActorAngle(PlayrNum+500) >> 8 > 224 )
    
                            Spawn("DummyAim", GetActorX(PlayrNum+500)-(17*65536), GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(16*65536), 200, 0);
                                else
                            Spawn("DummyAim", GetActorX(PlayrNum+500)+(17*65536), GetActorY(PlayrNum+500), GetActorZ(PlayrNum+500)+(16*65536), 200, 0);

                        SpawnProjectile(200, FireStr[Random(0,9)], 0, 0, Random(-2, -5), 0, 0);
                            Thing_Remove(200);
                        AmbientSound("weapons\jetpack", 90);
                        ThrustThingZ(PlayrNum+500, 16, 0, 0);
                    
                    if(!PlayerFire & BT_ATTACK || PlayerInts[JetpackFuelRemaining][PlayrNum] == 0) break;
                    

                    PlayerInts[JetpackFuelRemaining][PlayrNum]--;
					PlayerInts[JetpackFuelRemaining][PlayrNum]--;
					
                    ACS_Execute(982, 0, PlayrNum+500);
                    Delay(2);
                
                    WeaponForce = 0;
                    
                }

                    if (PlayerInts[JetpackFuelRemaining][PlayrNum] == 0)
                    
                        {   
                            
                            PlayerControl[JetpackUsed][PlayrNum] = True;
                            PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;                    
                            Inventory[PlayrNum][Jetpack] -= 1;
                        }
                    else if (PlayerControl[EndTurn][PlayrNum] == True && PlayerInts[JetpackFuelRemaining][PlayrNum] < 150)
                        {
                            PlayerControl[JetpackUsed][PlayrNum] = True;
                            Inventory[PlayrNum][Jetpack] -= 1;
                        }
                    
                Delay(1); Restart;
            }
            
            if(PlayerControl[HasFired][PlayrNum] == False) Delay(1); Restart;
        }         
         
         
         
                                                    ////////////////
                                                    // FIRING HOMING MISSILE
                                                    ////////////////


else if(PlayerWeapon[PlayrNum] == "HomingMissile" && ShotgunShots == WEAPON_SHOTS_SHOTGUN && ThingCountName("GUITarget2", 212) == 0)

        {
                    GUI_Cursor = False;
                    Thing_Remove(212);
                    Thing_Remove(211);
                    GUI_Cursor = True;
                    Delay(1);
                    Spawn("GUITarget", GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500), 211, 0);
                    SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
                    While(GUI_Clicked == False && PlayerWeapon[PlayrNum] == "HomingMissile") Delay(1);

                        if(PlayerWeapon[PlayrNum] != "HomingMissile")
                                { 
                                    GUI_Clicked = False;
                                    GUI_Cursor = False;
                                    Thing_Remove(211);
                                    Thing_Remove(212);
                                    delay(1); restart; }             
                        
                        GUI_Clicked = False;
                        GUI_Cursor = False;

                  
        }         
         



                                                    ////////////////
                                                    // FIRING KAMIKAZE BOMBER
                                                    ////////////////


else if(PlayerWeapon[PlayrNum] == "KamikazeBomber")
        {
            
            PlayerControl[HasFired][PlayrNum] = False;
            while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN) 
            {
            if(PlayerWeapon[PlayrNum] != "KamikazeBomber") break;
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
        
            if(PlayerFire == BT_ATTACK)
                    {
                    
                    PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
                    PlayerControl[IsFiring][PlayrNum] = True;
                    
                    if(PlayerControl[HasFired][PlayrNum] == True) terminate;
                            
                            for(int KamikazeFiring = FireAmount[PlayrNum]; KamikazeFiring > 0; KamikazeFiring--)
                                {
                                    if(Inventory[PlayrNum][16] > 0)
                                        {
                                            PlayerControl[HasFired][PlayrNum] = True;
                                            SetActorState(500+PlayrNum, "Firing");
                                            delay(4);
                                            SpawnProjectile(500+PlayrNum, "KamikazeBomber", PlayerInts[FacingAngle][PlayrNum] >> 8, 40, 10, 0.7, ProjectileTID);
                                            Inventory[PlayrNum][16] -= 1;
                                            SetActorProperty(ProjectileTID, APROP_HEALTH, FuseSeconds[PlayrNum]);
                                            SetActorState(500+PlayrNum, "DoneFiring", 0);
                                            Delay(35);
                                        }
                                }
                            Delay(6);
                    }
                    if(PlayerControl[IsFiring][PlayrNum] == False) { delay(1); restart; }
                    
                    WeaponForce = 0;        
                    
                    PlayerControl[IsFiring][PlayrNum] = false;
                    PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                    PlayerFire = 0;
                    
                    PlayerControl[HasFired][PlayrNum] = True;
                    terminate;
                }
            if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
      }
                                                    
                                                //////////////////
                                                // PLACING BARRIER
                                                //////////////////
                                                
else if(PlayerWeapon[PlayrNum] == "Barrier" || PlayerWeapon[PlayrNum] == "SentryGun" )
        {
           
            bool BarrierFloorCheck;

            if(PlayerWeapon[PlayrNum] == "Barrier")
                Spawn("BarrierPlace", 
                    GetActorX(PlayrNum+500), LVL_YPOS, 
                    GetActorZ(PlayrNum+500)+2.0, 211, 0);
            else
                Spawn("SentryPlace", 
                    GetActorX(PlayrNum+500), LVL_YPOS, 
                    GetActorZ(PlayrNum+500)+2.0, 211, 0);
            delay(1);
            
            CreateTranslation(15, 0:255=182:191);
            PlayerControl[HasFired][PlayrNum] = False;
            
            while(Shooting == True && ShotgunShots == WEAPON_SHOTS_SHOTGUN) 
            {
                
                SetActorAngle(211, GetActorAngle(PlayrNum+500));
                
                if(GetActorZ(211) - GetActorFloorZ(211) < 4.0 ||
                    SpawnDummyPlace(PlayrNum) != False ) 
                 { BarrierFloorCheck = True; Thing_SetTranslation(211, 0); }
            else { Thing_SetTranslation(211, 15); BarrierFloorCheck = False; }
                
                    if(GetActorAngle(PlayrNum+500) >> 8 < 32 || 
                                GetActorAngle(PlayrNum+500) >> 8 > 224 )                
                                    SetActorPosition(211, GetActorX(PlayrNum+500)+64.0, LVL_YPOS, GetActorZ(PlayrNum+500), 0);
                        else        SetActorPosition(211, GetActorX(PlayrNum+500)-64.0, LVL_YPOS, GetActorZ(PlayrNum+500), 0);
            
            if(PlayerWeapon[PlayrNum] != "Barrier" && PlayerWeapon[PlayrNum] != "SentryGun") 
                { Thing_Remove(211); restart; }
            
            PlayerFire = GetPlayerInput(PlayrNum, INPUT_BUTTONS);
            
            if((PlayerFire & BT_ATTACK) && (BarrierFloorCheck == True))
                    {
                        WeaponForce = 0;
                    
                        PlayerControl[IsFiring][PlayrNum] = True;
                        Delay(1);
                         
                            SetActorState(500+PlayrNum, "Firing");
                            if(PlayerWeapon[PlayrNum] == "Barrier")
                                Spawn("BarrierBars", GetActorX(211), LVL_YPOS, GetActorZ(211), 696, 0);
                            if(PlayerWeapon[PlayrNum] == "SentryGun")
                                {
                                    if(GetActorAngle(PlayrNum+500) >> 8 < 32 || 
                                        GetActorAngle(PlayrNum+500) >> 8 > 224 ) 
                                    SetActorState(PlayrNum+500, "PlacingSentryL", 0);
                                        else
                                    SetActorState(PlayrNum+500, "PlacingSentryR", 0);
                                }
                            
                                //Spawn("SentryGun", GetActorX(211), LVL_YPOS, GetActorZ(211), 696, 0);
                            
                               if(GetActorAngle(PlayrNum+500) >> 8 < 32 || 
                                GetActorAngle(PlayrNum+500) >> 8 > 224 )
                                SetActorAngle(696, 1.0);
                        else    SetActorAngle(696, 0.5);
                            
                            
                            Thing_ChangeTID(696, 0);
                            Thing_Remove(211);
                            
                            AmbientSound("tools\girder", 127);                            
                            SetActorState(500+PlayrNum, "DoneFiring", 0);
                            Delay(41);
                                                       
                    }
            else if ((PlayerFire & BT_ATTACK) && (BarrierFloorCheck == False))
                    {   
                            AmbientSound("world\clickfail", 127);
                    }
                    
                    if(PlayerControl[IsFiring][PlayrNum] == False) { delay(1);}
                     
                     else
                        {
                            WeaponForce = 0;        
                    
                            PlayerControl[IsFiring][PlayrNum] = false;
                            PreviousAngle[PlayrNum] = PlayerInts[Aim][PlayrNum]*360>>16;
                            PlayerFire = 0;
                            
                            if(PlayerWeapon[PlayrNum] == "Barrier")
                                Inventory[PlayrNum][22] -= 1;
                            if(PlayerWeapon[PlayrNum] == "SentryGun")
                                Inventory[PlayrNum][23] -= 1;
                            PlayerControl[HasFired][PlayrNum] = True;
                            terminate;
                        }
                }
        if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
        }
                                                    ////////////////
                                                    // PLACING GIRDER
                                                    ////////////////

else if(PlayerWeapon[PlayrNum] == "Girder" || PlayerWeapon[PlayrNum] == "GirderKit" 
			&& ShotgunShots == WEAPON_SHOTS_SHOTGUN)

        {
                    GUI_Cursor = False;
                    Thing_Remove(212);
                    Thing_Remove(211);
                    delay(1);
                    GUI_Cursor = True;
                    GirderFacing = "Horizontal";
                    bool GirderPlaced = False;
                    Spawn("GHPlace", GetActorX(PlayrNum+500), LVL_YPOS, GetActorZ(PlayrNum+500), 211, 64);
                    While(GUI_Clicked == False && (PlayerWeapon[PlayrNum] == "Girder" || PlayerWeapon[PlayrNum] == "GirderKit")) Delay(1);
                        
                        if(PlayerWeapon[PlayrNum] != "Girder" && PlayerWeapon[PlayrNum] != "GirderKit" )
                                { 
                                    GUI_Clicked = False;
                                    GUI_Cursor = False;
                                    Thing_Remove(211);
                                    Thing_Remove(212);
                                    SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
                                    delay(1); restart; }                                 
                    		
			CreateTranslation(50, 0:255=176:191);

                    if(GUI_Clicked == True && DistanceXZ(212, 500+PlayrNum) < 1024)
                            {
                                if(GirderFacing == "Horizontal")
                                    {
                                            
                                        if( Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)+64.0, LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)-64.0, LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)+32.0, LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)-32.0, LVL_YPOS, GetActorZ(212), 0, 0) != 0)
                                        
                                            {
                                                Girder(212, "GirderHorizontal");
                                                GirderPlaced = True;
                                            }
                                    }
                            else if(GirderFacing == "Vertical")
                                    {
                                        if( Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212)+64.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212)-64.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212)+32.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212)-32.0, 0, 0) != 0 )
                                            
                                            {
                                                Girder(212, "GirderVertical");
                                                GirderPlaced = True;
                                            }
                                    }
                            else if(GirderFacing == "DiagonalLeft")
                                    {
                                        
                                        if( Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)+64.0, LVL_YPOS, GetActorZ(212)+64.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)-64.0, LVL_YPOS, GetActorZ(212)-64.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)+32.0, LVL_YPOS, GetActorZ(212)+32.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)-32.0, LVL_YPOS, GetActorZ(212)-32.0, 0, 0) != 0 ) 
                                            
                                            {
                                                Girder(212, "DiagonalLeft");
                                                GirderPlaced = True;
                                            }
                                    }
                            else if(GirderFacing == "DiagonalRight")
                                    {
                                        
                                        if( Spawn("GirderBlockCheck", GetActorX(212), LVL_YPOS, GetActorZ(212), 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)+64.0, LVL_YPOS, GetActorZ(212)-64.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)-64.0, LVL_YPOS, GetActorZ(212)+64.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)+32.0, LVL_YPOS, GetActorZ(212)-32.0, 0, 0) != 0 &&
                                            Spawn("GirderBlockCheck", GetActorX(212)-32.0, LVL_YPOS, GetActorZ(212)+32.0, 0, 0) != 0 ) 
                                            
                                            {
                                                Girder(212, "DiagonalRight");
                                                GirderPlaced = True;
                                            }
                                    }        
                                if(GirderPlaced == True)
                                    {
					if(PlayerWeapon[PlayrNum] == "Girder")
						{
	                                            Inventory[PlayrNum][17] -= 1;
	                                            PlayerControl[HasFired][PlayrNum] = True;
	                                            SetActorState(500+PlayrNum, "DoneFiring", 0);
	                                            AmbientSound("tools\girder", 127);
	                                            SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
						}
					if(PlayerWeapon[PlayrNum] == "GirderKit")
						{
							AmbientSound("tools\girder", 127);
							GirdersPlaced++;
								if(GirdersPlaced == WEAPON_POWERS[25])
									{
										GirdersPlaced = 0;
										Inventory[PlayrNum][25] -= 1;
	                                            				PlayerControl[HasFired][PlayrNum] = True;
	                                            				SetActorState(500+PlayrNum, "DoneFiring", 0);
	                                           				AmbientSound("tools\girder", 127);
	                                            				SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
									}
						}

                                    }
                            else    
                                    {
                                            AmbientSound("world/clickfail", 127);
                                            GirderFacing = "Horizontal";
                                    }
                            }
                
                                GUI_Clicked = False;
                                GUI_Cursor = False;                
        }         

    if (PlayerControl[HasFired][PlayrNum] == False) { Delay(1); restart; }
}

int DemonTrigger;

Script 948 (int ActivePlayer)           // Demon Explosion Trigger 
{
While(ThingCountName("WeaponDemon", ProjectileTID) != 0 || ThingCountName("ClusterDemon", ProjectileTID) != 0 || ThingCountName("ClusterDemonCluster", ProjectileTID) != 0)
    {
        DemonTrigger = GetPlayerInput(ActivePlayer, INPUT_BUTTONS);
        
        if(DemonTrigger & BT_ATTACK)
            {
                SetActorProperty(ProjectileTID, APROP_SeeSound, "");
                SetActorState(ProjectileTID, "Explode", 0);
                Thing_ChangeTid(ProjectileTID, 0);
                Delay(25);
            }
        ForceMissileAxis();
        
        Delay(1);
    }
}

Script 830 (VOID)           // Demon Cluster Trigger 
{
For(int RandomSpawnLoop = 6; RandomSpawnLoop > 0; RandomSpawnLoop--)
    {
    if(Random(0,1) == 1)
        {
            Thing_Projectile(ProjectileTID, "ClusterDemonCluster", 0, Random(12, 24), Random(-4, 8));
            SetActorAngle(ProjectileTID, GetActorAngle(ProjectileTID)-128.0);
        }
    else
        {
            Thing_Projectile(ProjectileTID, "ClusterDemonCluster", 0, Random(12, 24), Random(-4, 8));
        }
    }
}

Script 831 (VOID)
{
Thing_ChangeTid(0, ProjectileTID);
}

int AimModifier = 1;

        ///////////////////////////////////////
        //  PLAYER MOVEMENT && AIMING SCRIPT //
        ///////////////////////////////////////

Script 998 (int PlayNum)
{

While(Moving == True || Aiming == True) 
	{

	        // AIMING

		if(Aiming == True && GetActorVelX(PlayNum+500) + GetActorVelZ(PlayNum+500) == 0)
		{
		    if(PlayerWeapon[PlayNum] != "Teleport" &&   
			PlayerWeapon[PlayNum] != "Girder" &&
			PlayerWeapon[PlayNum] != "Barrier" &&
			PlayerWeapon[PlayNum] != "Airstrike" &&
			PlayerWeapon[PlayNum] != "NapalmStrikeAmmo" &&
			PlayerWeapon[PlayNum] != "WeaponDemon" &&
			PlayerWeapon[PlayNum] != "ClusterDemon" &&
			PlayerWeapon[PlayNum] != "Dynamite" &&
			PlayerWeapon[PlayNum] != "Mine" &&
			PlayerWeapon[PlayNum] != "Kick" &&
			PlayerWeapon[PlayNum] != "" )
			{

	    PlayerInts[AimButton][PlayNum] = GetPlayerInput(PlayNum, INPUT_UPMOVE);
    
		int PlayerAimMod = GetPlayerInput(PlayNum, INPUT_BUTTONS);

	    if(PlayerAimMod & BT_SPEED) AimModifier = 5;
        	else AimModifier = 1;

	    if(PlayerInts[AimButton][PlayNum] > 0 )
        	{ if(PlayerInts[Aim][PlayNum] > -0.25 ) 
	            PlayerInts[Aim][PlayNum] -= 0.001 * AimModifier; }

		else if(PlayerInts[AimButton][PlayNum] < 0 )
	        { if(PlayerInts[Aim][PlayNum] < 0.25 ) 
        	    PlayerInts[Aim][PlayNum] += 0.001 * AimModifier; }

		    if(PlayerInts[Aim][PlayNum] < -0.25) 
		        PlayerInts[Aim][PlayNum] = -0.25;
		    if(PlayerInts[Aim][PlayNum] > 0.25) 
		        PlayerInts[Aim][PlayNum] = 0.25;
			
			if(PlayerInts[MoveButton][PlayNum] & BT_MOVELEFT || 
			PlayerInts[MoveButton][PlayNum] & BT_MOVERIGHT) {}
		
		    else SetActorPitch(500+PlayNum, PlayerInts[Aim][PlayNum]);
       			
			}

			else SetActorPitch(500+PlayNum, PlayerInts[Aim][PlayNum]);

		if(PlayerWeapon[PlayNum] != "Teleport" &&   
			PlayerWeapon[PlayNum] != "Girder" &&
			PlayerWeapon[PlayNum] != "Barrier" &&
			PlayerWeapon[PlayNum] != "Airstrike" &&
			PlayerWeapon[PlayNum] != "NapalmStrikeAmmo" &&
			PlayerWeapon[PlayNum] != "WeaponDemon" &&
			PlayerWeapon[PlayNum] != "ClusterDemon" &&
			PlayerWeapon[PlayNum] != "Dynamite" &&
			PlayerWeapon[PlayNum] != "Mine" &&
			PlayerWeapon[PlayNum] != "" )
				HUDAim[PlayNum] = PlayerInts[Aim][PlayNum]*360>>16;
			else	
				HUDAim[PlayNum] = 0;

				// Sets the on-screen HUD pitch numbers and the player aiming states
				////////////////////

		if(PlayerInts[Aim][PlayNum]*360>>16 != CheckActorInventory(PlayNum+500, "CurrentPitchItem") ||
		PlayerInts[Aim][PlayNum]*360>>16 != CheckActorInventory(PlayNum+500, "CurrentPitchNegItem"))
		{
			if(PlayerInts[Aim][PlayNum]*360>>16 > 0)
				{
					TakeActorInventory(PlayNum+500, "CurrentPitchNegItem", CheckActorInventory(PlayNum+500, "CurrentPitchNegItem"));
					TakeActorInventory(PlayNum+500, "CurrentPitchItem", CheckActorInventory(PlayNum+500, "CurrentPitchItem"));
					GiveActorInventory(PlayNum+500, "CurrentPItchItem", HUDAim[PlayNum]);
				}
			else 	
				{
					TakeActorInventory(PlayNum+500, "CurrentPitchItem", CheckActorInventory(PlayNum+500, "CurrentPitchItem"));
					TakeActorInventory(PlayNum+500, "CurrentPitchNegItem", CheckActorInventory(PlayNum+500, "CurrentPitchNegItem"));
					GiveActorInventory(PlayNum+500, "CurrentPitchNegItem", -HUDAim[PlayNum]);
				}
		
		if(CheckInventory("CurrentPitchItem") != 0 && GetActorVelZ(PlayNum+500) == 0 && IsWallJumping == False)
			SetActorState(0, AimStates[0][CheckActorInventory(PlayNum+500, "CurrentPitchItem")]-1);	
		else if(CheckInventory("CurrentPitchNegItem") != 0 && GetActorVelZ(PlayNum+500) == 0 && IsWallJumping == False)
			SetActorState(0, AimStates[1][CheckActorInventory(PlayNum+500, "CurrentPitchNegItem")]-1);
		else if(PlayerWeapon[PlayNum] == "Bazooka" ||
			PlayerWeapon[PlayNum] == "HomingMissile" ||
			PlayerWeapon[PlayNum] == "Girder" ||
			PlayerWeapon[PlayNum] == "Barrier" ||
			PlayerWeapon[PlayNum] == "ItemTeleport" ||
			PlayerWeapon[PlayNum] == "Airstrike" ||
			PlayerWeapon[PlayNum] == "WeaponShotgun" ||
			PlayerWeapon[PlayNum] == "WeaponUzi" )
				SetActorState(0, "AIM");
		
		
		if(timer() % 3 == 0)
			ACS_Execute(CROSSHAIR, 0, PlayNum+500);
		
		}
	}
	
	SetActivator(PlayNum+500);
	SetFont("BIGFONT");
	SetHudSize(640, 400, 0);

        // MOVING

	if(Moving == True)
    	{
        	
        	PlayerInts[MoveButton][PlayNum] = GetPlayerInput(-1, INPUT_BUTTONS);
        
            	if(PlayerInts[MoveButton][PlayNum] & BT_MOVELEFT)
	                { PlayerInts[FacingAngle][PlayNum] = 0.5; }
				else if(PlayerInts[MoveButton][PlayNum] & BT_MOVERIGHT)
                	{ PlayerInts[FacingAngle][PlayNum] = 1.0; }
       
            ForceDirection(PlayNum);

        	if(GetActorY(PlayNum+500) != LVL_YPOS)
	            {
					SetActorPosition(PlayNum+500, GetActorX(PlayNum+500), LVL_YPOS, GetActorZ(PlayNum+500), 0);
					SetActorVelocity(PlayNum+500, GetActorVelX(PlayNum+500), 0, GetActorVelZ(PlayNum+500), 0, 0);
				}

    	    SetActorAngle(0, PlayerInts[FacingAngle][PlayNum]);        
		}
		delay(1);
	}
}

function bool CheckPlayerHealth (int Time)
{
    bool damaged = false;
    if(Time==1)
        {   for(int looper = 0; looper < 33; looper++)
                    {
                        PlayerInts[BeforeHealth][looper] = GetActorProperty(500+Looper, APROP_HEALTH);
                        PlayerInts[TurnDamageTaken][looper] = 0;
                    }
        }
    if(Time==2)
        {   for(looper = 0; looper < 33; looper++)
                    PlayerInts[AfterHealth][looper] = GetActorProperty(500+Looper, APROP_HEALTH);
        }
    if(Time==3)
        {
            for(looper = 0; looper < 33; looper++)
                    if(PlayerInts[BeforeHealth][looper] > PlayerInts[AfterHealth][looper])
                            {
                                PlayerInts[TurnDamageTaken][looper] = PlayerInts[BeforeHealth][looper] - PlayerInts[AfterHealth][looper];
                                damaged = true;
                            }
        }
return damaged;
}

        /////////////////////////
        // TURN CONTROL SCRIPT //
        /////////////////////////


bool BarrelsSpawning = False;
bool MedkitsSpawning = False;
bool CratesSpawning = False;
bool ArmorSpawning = False;
bool ToolsSpawning = False;
bool StuffHappening = False;
bool GameStarted = False;

Script 2 OPEN
{
GameStarted = False;
if(GetLevelInfo(LEVELINFO_LevelNum) == 0) Terminate;
SetGravity(GAME_GRAVITY * 1.0);

if(GetLevelInfo(LEVELINFO_LevelNum) == 32)
	{
		if(Random(1, 2) == 1)
			ACS_Execute(851, 0, -4000, 4400, 21);
		else
			ACS_Execute(851, 0, -6000, 6000, 10);
		ScriptWait(851);
	}
else 
		ACS_Execute(SPAWN_MINES, 0);
		
// Ceiling_RaiseInstant(9, 0, GAME_MAPWATER);
if(RunOnce == False) {

While(MinesSpawning == True) 
		Delay(8);

while(Players > 1)
    {
	
	GameStarted = True;
        
	RunOnce = True;
    for(PlayerLoop = 0; PlayerLoop < MaxPlayersArray; PlayerLoop++)
		{
		SetPlayerProperty(1, ON, PROP_TOTALLYFROZEN);
		HudMessageBold(s:""; HUDMSG_PLAIN, 5, CR_GOLD, 320.0, 240.0, 1); 
		 
		if(GAME_GAMETYPE == 1)
			{
            SetHudSize(640, 480, 0);
            SetFont("BIGFONT");
            HudMessage(s:"\c-LIVES LEFT\n\chBLUE TEAM: \c-", i:BlueTeam,
                       s:"\n\cgRED TEAM: \c-", i:RedTeam; HUDMSG_PLAIN, 
					   5555, CR_GOLD, 70.0, 40.0, 0);
            }
            
        if((PlayerInts[Lives][PlayerLoop] > 0 && GAME_GAMETYPE == 0) || 
                (PlayerInts[Lives][PlayerLoop] > 0 &&
                    GAME_GAMETYPE == 1 && PlayerTeam2[PlayerLoop] != PlayerTeam2[LastPlayer]) 
					||  ThingCount(T_NONE, 500+PLayerLoop) != 0)
            {
                
		// last-measure attempt to reset controls for all players
            for(int FuckItAll = MaxPlayersArray; FuckItAll >=0; FuckItAll--)
            {
            PlayerControl[Menu][FuckItAll] = False;
            }
		WeaponInAir = 0;

			DidFire = False;
			ShotStatus = "None";
			BeamPower = "None";
			ShotStat[0] = 0;
			ShotStat[1] = 0;

            ACS_ExecuteAlways(881, 0, PlayerLoop);            // Make sure client camera is focused
            ACS_ExecuteAlways(879, 0, PlayerLoop);            // Reset client fired status
			
            if(GAME_MAPSCRIPT == True)
				ACS_Execute(500, 0);
				
            ACS_Terminate(949, 0);
            
            delay(1);
            ACS_ExecuteAlways(3, 0, PlayerLoop+500);
            
            PlayerInts[JetpackFuelRemaining][PlayerLoop] = 150;
			PlayerInts[RopesRemaining][PlayerLoop] = WEAPON_POWERS[NinjaRope];
			
            PlayerControl[PlayerTurn][PlayerLoop] = True;
            PlayerControl[EndTurn][PlayerLoop] = False;
            PlayerInts[FacingAngle][PlayerLoop] = GetActorAngle(PlayerLoop+500);
            PlayerControl[3][PlayerLoop] = False;
            PlayerWalljumpCheck = "None";

            NumTurns++;
            WindTurns++;
            
            ForceDirection(PlayerLoop);
            
                if(GAME_SUDDENDEATH == True) 
                    { 
                        if(GAME_SUDDENDEATHMODE == 0)
                                {
                                    Ceiling_RaiseByValue(9, 8, GAME_SUDDENDEATH_WATERRISE);
                                        TagWait(9); }
                        else if(GAME_SUDDENDEATHMODE == 1)
                                {
                                    for (int ploop = 0; ploop < MaxPlayersArray; ploop++)
                                        {
                                         SetActorProperty(ploop+500, APROP_HEALTH, 1);
                                        }
                                }
                        else if(GAME_SUDDENDEATHMODE == 2)
                                {
                                    for (ploop = 0; ploop < MaxPlayersArray; ploop++)
                                        {
                                            for(int DamLoop = 15; DamLoop > 0; DamLoop--)
                                                if(GetActorProperty(ploop+500, APROP_HEALTH) > 1)
                                                    SetActorProperty(ploop+500, APROP_HEALTH, GetActorProperty(ploop+500, APROP_HEALTH)-1);
                                        }
                                }
                    }
                    
                Thing_Damage(660, 1, 0);

                        SetActorProperty(1200, APROP_INVULNERABLE, 0);
                        int Health = GetActorProperty(1200, APROP_HEALTH);
                        SetActorState(1200, "Dim", 0);
                        SetActorProperty(1200, APROP_HEALTH, Health-1);
                        SetActorProperty(1200, APROP_INVULNERABLE, 1);
                        
                if(WindTurns > Random(4, 10)) 
                        { WindTurns = 0; ACS_Execute(995, 0); }        // Wind
                        
                if(LVL_CHANCE_BARRELS > 0) // Barrels
                    {
                        if(ThingCount(T_BARREL, 0) < LVL_CHANCE_BARRELS &&           
                            Random(1, LVL_CHANCE_BARRELS ) < LVL_CHANCE_BARRELS / 5) 
                                { ACS_Execute(SPAWN_BARRELS, 0); BarrelsSpawning = True; }
                                    if(BarrelsSpawning == True) ScriptWait(SPAWN_BARRELS);
                    }
                if(NumTurns%GAME_DROPTURNS == 0)
                        {
                if(Random(1, 100) > 100 - LVL_CHANCE_MEDKITS) 
                        { ACS_Execute(SPAWN_HEALTH, 0); MedkitsSpawning = True; }
                            if(MedkitsSpawning == True) ScriptWait(SPAWN_HEALTH);                

                if(Random(1, 100) > 100 - LVL_CHANCE_ARMOR)
                        { ACS_Execute(SPAWN_ARMOR, 0); ArmorSpawning = True; }
                            if(ArmorSpawning == True) ScriptWait(SPAWN_ARMOR);

                if(Random(1, 100) > 100 - LVL_CHANCE_CRATES)
                        { ACS_Execute(SPAWN_WEAPONCRATE, 0); CratesSpawning = True; }
                            if(CratesSpawning == True) ScriptWait(SPAWN_WEAPONCRATE);
							
                if(Random(1, 100) > 100 - LVL_CHANCE_TOOLS)
                        { ACS_Execute(SPAWN_TOOLCRATE, 0); ToolsSpawning = True; }
                            if(ToolsSpawning == True) ScriptWait(SPAWN_TOOLCRATE);
                            }
                            
                    BarrelsSpawning = False;
                    MedkitsSpawning = False;
                    ArmorSpawning = False;
                    CratesSpawning = False;
                    ToolsSpawning = False;

                if(GAME_BEAMS == TRUE)
			{
				If(Random(1, 100) > 100 - GAME_BEAMCHANCE)
				   {
					ACS_Execute(SPAWN_BEAM, 0, Random(0, 3));
					ScriptWait(SPAWN_BEAM);
					delay(15);
				   }
			}

                SetActivator(PlayerLoop+500);
                
                AmbientSound("Ready", 127);
                
                SetActivator(0);
 
            int x = GetActorX (500+PlayerLoop);
            int y = GetActorY (500+PlayerLoop);
            int z = GetActorZ (500+PlayerLoop);
            SetActorPosition(100, x, y-512.0, z+32.0, 0);        
        
            SetActivator(PlayerLoop+500);
            SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
	    SetPlayerProperty(0, OFF, PROP_FROZEN);
            
		AmbientSound(voices[PlayerSkin[PlayerLoop]][0], 127);

            SetFont("BIGFONT");
            SetHudSize(800, 600, 0);
            HudMessage  (s:"Hint: ", s:Hints[Random(0, 18)]; HUDMSG_FADEINOUT, 150,
                            CR_WHITE, 400.0, 155.0, 8.0, 0.5, 4.0);
        
            SetFont("bigfont");
            SetHudSize(640, 480, 0);
            HudMessageBold  (n:PlayerNumber()+1, s:"'s \c-turn!"; HUDMSG_FADEINOUT, 1,
                                CR_TAN, 320.0, 174.0, 6.0, 0.5, 1.5);
        
        SetActivator(0);
        
        Moving = True;
        Aiming = True;
        Shooting = True;
        ShotgunShots = 2;
        str TimeColorStr = "Green";
        
        CheckPlayerHealth(1);
                    
        ACS_Execute(998, 0, PlayerLoop);    // Moving & Aiming
        ACS_Execute(996, 0, PlayerLoop);    // Fire
        ACS_Execute(937, 0, PlayerLoop+500);    // Idle check
    
            for(TimeLoop = GAME_TURNTIME; TimeLoop >= 0; TimeLoop--)
                {

			for(int giveloop = 0; giveloop < MaxPlayersArray; giveloop++)
				{
					TakeActorInventory(500+GiveLoop, "GameTimeMinutes", CheckActorInventory(500+GiveLoop, "GameTimeMinutes"));
					GiveActorInventory(500+GiveLoop, "GameTimeMinutes", GAMETIME/60);
					TakeActorInventory(500+GiveLoop, "GameTimeSeconds", CheckActorInventory(500+GiveLoop, "GameTimeSeconds"));
					GiveActorInventory(500+GiveLoop, "GameTimeSeconds", GAMETIME%60);
					TakeActorInventory(500+GiveLoop, "TurnTime", CheckActorInventory(500+GiveLoop, "TurnTime"));				
					GiveActorInventory(500+GiveLoop, "TurnTime", TimeLoop);
				}

                    Statistics[TotalGameTime]++;
					
                    If(PlayerControl[3][PlayerLoop] == True || PlayerControl[1][PlayerLoop] == True) 
                        {   PlayerControl[3][PlayerLoop] = False; 
                            PlayerControl[1][PlayerLoop] = False;
                            TimeLoop = 0;   }
        
                    delay(35);
                    GAMETIME--;
                    
                    if  (GAMETIME <= 45 && GAME_SUDDENDEATH == False || 
                        GAME_SUDDENDEATH == True && SuddenDeathNotice == False) 
                            ACS_Execute(930, 0);                  
                   
                    while(PlayerControl[IsFiring][PlayerLoop] == True) 
						{ Delay(1); }
                    
                    if(PlayerControl[HasFired][PlayerLoop] == True) 
                        {  	
						Thing_Remove(966);
						SetActivator(500+PlayerLoop);
						GiveActorInventory(Playerloop+500, "HasFiredItem", 1);
						ACS_Execute(972, 0, PlayerLoop+500);
						PlayerPosition = GetActorX(PlayerLoop+500);
                        TimeLoop = 4;
                        ACS_ExecuteAlways(949, 0, PlayerLoop);
                        ACS_ExecuteAlways(880, 0, PlayerLoop);
						SetActorProperty(500+PlayerLoop, APROP_SPEED, int2fix(PLAYER_SPEED)/100);
						DidFire = True;
						PlayerControl[HasFired][PlayerLoop] = False;
						SetActivator(500+PlayerLoop);
						SetFont("BIGFONT");
						SetActivator(0);
						}
                    
                    if(TimeLoop < 6 && TimeLoop > 0 && DidFire == False) 
						{ 
						if(TimeLoop == 6) AmbientSound(voices[PlayerSkin[PlayerLoop]][14], 127);
						AmbientSound(TimeStr[TimeLoop-1], 127); TimeColorStr = "Red"; 
						}
					}
                
					Moving = False;
					Aiming = False;
					Shooting = False;
                
					HudMessageBold(s:""; HUDMSG_PLAIN, 22, CR_TAN, 400.0, 510.0, 0);
                
	if(ShotgunShots < WEAPON_SHOTS_SHOTGUN) 	// Make sure shotgun ammo is taken if at least 1 shot is taken
            { Inventory[PlayerLoop][3] -= 1; }
							// Make sure if the player has used at least 1 girder in a kit, the ammo is taken
	if(GirdersPlaced != 0 && GirdersPlaced < WEAPON_POWERS[25])
		{
			Inventory[PlayerLoop][25] -= 1;
			GirdersPlaced = 0;
		}
     
        PlayerControl[PlayerTurn][PlayerLoop] = False; 		// End of turn
        TimeLoop = GAME_TURNTIME;			// 

        While(Airstrike == True) Delay(35);        
		
        if(ThingCountName("RopeHook", ProjectileTID) > 0)
			Thing_Remove(210);
			
		Thing_Remove(211);
		Airstrike = False;
		GUI_Clicked = False;
        GUI_Cursor = False;

        SetActivator(PlayerLoop+500);

	if(ThingCountName("TestMarine", PlayerLoop+500) == 0)
		SetActorState(0, "Spawn");
	
        SetPlayerProperty(0, ON, PROP_TOTALLYFROZEN);       // Freeze player after his turn is up
        SetActivator(0);
        ACS_Terminate(998, 0);    // Moving & Aiming
        ACS_Terminate(996, 0);    // Fire
        

        While(ThingCount(T_NONE, ProjectileTID) > 0) Delay(20);      // Wait for missiles to explode before continuing
        Thing_Remove(212);
        Thing_Remove(960);
		
        ACS_Execute(881, 0, PlayerLoop);    // Make sure menu is closed on client side
        PlayerControl[Menu][PlayerLoop] = False;
        delay(1);
        
        PlayerControl[EndTurn][PlayerLoop] = True;

        ACS_Execute(970, 0);                    // Check to see if any extra actions are happening
        
        StuffHappening = True;
        ScriptWait(970);                        // Wait until all actions have completed
		while(ThingCount(T_NONE, ProjectileTID) != 0)
			{
				SetActorPosition(ProjectileTID, GetActorX(ProjectileTID), LVL_YPOS, GetActorZ(ProjectileTID), 0);
				SetActorVelocity(ProjectileTID, GetActorVelX(ProjectileTID), 0, GetActorVelZ(ProjectileTID), 0, 0);
				delay(1);
			}
			
        While(StuffHappening == True) Delay(5);
        While(ThingCount(T_NONE, ProjectileTID) != 0) Delay(5);


	// Damage Statistics for this turn
        Statistics[TurnDamage] = 0;        	// Reset turn damage stat
        
		CheckPlayerHealth(2);				// Initializes 'end of turn' damage values
        
		if(CheckPlayerHealth(3) == True)	// If damage has been taken between start and end of turn
            {
            int TeamDamage = 0;
            for(int looper = 0; looper < MaxPlayersArray; looper++)				// Damage checker
                if(PlayerInts[TurnDamageTaken][looper] > 0)
                    {
                    
					Statistics[TurnDamage] += PlayerInts[TurnDamageTaken][looper];			// If player is damaged, add to turn damage                        
					
					if(PlayerInts[TurnDamageTaken][PlayerLoop] > 0 )
						{
						PlayerInts[TotalPlayerDamage][PlayerLoop] += PlayerInts[TurnDamageTaken][PlayerLoop];
						
						if (PlayerInts[TurnDamageTaken][PlayerLoop] > Statistics[MostSelfDamage])
                                Statistics[MostSuicidal] = looper;
						}
	                
					if(PlayerTeam2[looper] == PlayerTeam2[PlayerLoop] && GAME_GAMETYPE == 1)
                    { 
						PlayerInts[TotalPlayerDamage][PlayerLoop] += PlayerInts[TurnDamageTaken][looper];
						teamdamage += PlayerInts[TurnDamageTaken][looper]; 
					}
			}

			PlayerInts[TotalDamageDone][looper] += Statistics[TurnDamage];
			
			GiveActorInventory(PlayerLoop+500, "Cash", Statistics[TurnDamage]);
                        SetHudSize(800, 600, 0);
                        SetFont("BIGFONT");
			
			if(Statistics[TurnDamage] > 0)
				HudMessageBold(n:PlayerLoop+1, s:"\c- did ", i:Statistics[TurnDamage], s:" damage total";
					 HUDMSG_FADEINOUT, 582, CR_WHITE, 400.0, 480.0-32.0, 5.0, 0.3, 3.0);
					 
			if(PlayerInts[TurnDamageTaken][PlayerLoop] != 0)
				{
					HudMessageBold(i:PlayerInts[TurnDamageTaken][PlayerLoop], s:" \c-of it to himself! "; 
					HUDMSG_FADEINOUT, 583, CR_ORANGE, 400.0, 504.0-32.0, 5.0, 0.3, 3.0);					  					
					TakeActorInventory(PlayerLoop+500, "Cash", PlayerInts[TurnDamageTaken][PlayerLoop]*2);
					
					if(PlayerInts[TurnDamageTaken][PlayerLoop] != 0 && TeamDamage == 0)
						AmbientSound(voices[PlayerSkin[PlayerLoop]][7], 127);
					
					delay(20);
				}
            if(TeamDamage-PlayerInts[TurnDamageTaken][PlayerLoop] != 0 && GAME_GAMETYPE == 1)
				{
		            HudMessageBold(i:TeamDamage-PlayerInts[TurnDamageTaken][PlayerLoop], s:" \c-to his own team! ";
						HUDMSG_FADEINOUT, 584, CR_WHITE, 400.0, 528.0-32.0, 5.0, 0.3, 3.0);
						TakeActorInventory(PlayerLoop+500, "Cash", TeamDamage-PlayerInts[TurnDamageTaken][PlayerLoop]);
						AmbientSound(voices[PlayerSkin[PlayerLoop]][5], 127);
							delay(20);
				}
                        if(Statistics[TurnDamage] > Statistics[BestShot]) { Statistics[BestShot] = Statistics[TurnDamage]; Statistics[BestShooter] = PlayerLoop; }

				int AwardOffset = 0;
				SetHudSize(1024, 768, 0);
				if(PlayerInts[TurnDamageTaken][PlayerLoop] == 0)
					{
				if(Statistics[TurnDamage]-TeamDamage > 200)
					{
						SetFont("shotinc");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 920, CR_UNTRANSLATED,
							840.0, 232.0, 1.0, 3.0, 2.0);
					}
				else if(Statistics[TurnDamage]-TeamDamage > 150)
					{
						SetFont("shotam");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 920, CR_UNTRANSLATED,
							840.0, 232.0, 1.0, 3.0, 2.0);
					}
							
				else if(Statistics[TurnDamage]-TeamDamage > 100)
					{
						SetFont("shotgrt");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 920, CR_UNTRANSLATED,
							840.0, 232.0, 1.0, 3.0, 2.0);
					}
				else if(Statistics[TurnDamage]-TeamDamage > 50)
					{
						SetFont("shotgd");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 920, CR_UNTRANSLATED,
							840.0, 232.0, 1.0, 3.0, 2.0);
					}
				if(ShotStat[0] < 0) ShotStat[0] = -ShotStat[0];
				if(ShotStat[0]>>16 > 4000 && ShotStat[1]>>16 > 1000 && Statistics[TurnDamage] != 0 && PlayerInts[TurnDamageTaken][PlayerLoop] == 0)
					{
						GiveActorInventory(PlayerLoop+500, "Cash", Statistics[TurnDamage]/3);
						AwardOffset += 32.0;
						SetFont("shot-skl");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 921, CR_UNTRANSLATED,
							840.0, 240.0+AwardOffset, 1.0, 3.0, 2.0);
					}
				if(ShotStat[1]>>16 > 1200 && PreviousAngle[PlayerLoop] >= 70 && Statistics[TurnDamage] != 0 )
					{
						GiveActorInventory(PlayerLoop+500, "Cash", Statistics[TurnDamage]/4);
						AwardOffset += 32.0;
						SetFont("shot-hi");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 923, CR_UNTRANSLATED,
							840.0, 240.0+AwardOffset, 1.0, 3.0, 2.0);
					}
				if(Backshot == True && Statistics[TurnDamage] != 0)
					{
						GiveActorInventory(PlayerLoop+500, "Cash", Statistics[TurnDamage]/5);
						AwardOffset += 32.0;
						SetFont("shot-bs");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 922, CR_UNTRANSLATED,
							840.0, 240.0+AwardOffset, 1.0, 3.0, 2.0);
					}
				if(ShotStatus == "Tornado" && Statistics[TurnDamage] != 0 )
					{
						GiveActorInventory(PlayerLoop+500, "Cash", Statistics[TurnDamage]/5);
						AwardOffset += 32.0;
						SetFont("shot-tws");
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 925, CR_UNTRANSLATED,
							840.0, 240.0+AwardOffset, 1.0, 3.0, 2.0);
					}
				if(ShotStat[2] < 30 && ( PlayerWeapon[PlayerLoop] != "WeaponShotgun" || 
								PlayerWeapon[PlayerLoop] != "WeaponUzi" ||
								PlayerWeapon[PlayerLoop] != "Mine" ||
								PlayerWeapon[PlayerLoop] != "Railgun" ) && Statistics[TurnDamage] != 0 )
					{
						AwardOffset += 32.0;
						SetFont("shot-chp");
						TakeActorInventory(PlayerLoop+500, "Cash", Statistics[TurnDamage]/2);
						HudMessageBold(s:"a"; HUDMSG_FADEINOUT, 924, CR_UNTRANSLATED,
							840.0, 240.0+AwardOffset, 1.0, 3.0, 2.0);
					}
				}
			              
            }
			if(Statistics[TurnDamage] == 0 && DidFire == True)
			{ AmbientSound(voices[PlayerSkin[PlayerLoop]][3], 127); Delay(45); }
		else if(Statistics[TurnDamage] == 0 && DidFire == False)
			{ AmbientSound(voices[PlayerSkin[PlayerLoop]][15], 127); Delay(45); }
		else if(Statistics[TurnDamage] != 0 && PlayerInts[TurnDamageTaken][PlayerLoop] == 0 && teamdamage == 0)
			{ Ambientsound(voices[PlayerSkin[PlayerLoop]][4], 127); SetActorState(ClosestPlayer, "Shrug"); Delay(45); }
            Delay(35);

        for(int MovementCount = 0; MovementCount < MaxPlayersArray; MovementCount++)
            {
                while((GetActorVelX(MovementCount+500) + GetActorVelZ(MovementCount+500)) != 0) Delay(15);
                // while(GetActorVelX(999) != 0) Delay(15);
            }
        
            if(GAME_GAMETYPE == 0)
                {
                    int WinCheck = 0;
                    for(ploop = 0; ploop < MaxPlayersArray; ploop++)
                        {
                            if(PlayerInts[Lives][ploop] > 0)
                                WinCheck++;
                        }                
                    if(WinCheck == 1)
                        { 
                           bool GameWon = True; 
                            for(ploop = 0; ploop < MaxPlayersArray; ploop++)
                                {
                                    if(PlayerInts[Lives][ploop] > 0)
                                        int GameWonBy = Ploop;
                                }       
                        }
                }
                
            if(GAME_GAMETYPE == 1)
                {
                    if(BlueTeam == 0 && RedTeam > 0)
                        { GameWon = True; GameWonBy = 2; }
                    if(RedTeam == 0 && BlueTeam > 0)
                        { GameWon = True; GameWonBy = 1; }
                }
        
        if(PlayerInts[JetpackFuelRemaining][PlayerLoop] < 150) Inventory[PlayerLoop][Jetpack] -= 1;
        
        LastPlayer = PlayerLoop;
        ACS_Terminate(3, 0);
    }   }
        
    if(GameWon == False) { RunOnce = False; restart; }
}
        
       if(Players == 1 || GameWon == True )
        {
                
            if(GameWon == True)
                {
                    if(PlayerCount() == 1) int votes = 1;
                    else votes = (PlayerCount()/2);
                    
                    for(int damageloop = 0; damageloop < MaxPlayersArray; damageloop++)
                        {   
						
						Statistics[TotalDamage] += PlayerInts[TotalDamageDone][damageloop];
                            
                        if (PlayerInts[TotalDamageDone][damageloop] == 0 && PlayerInGame(DamageLoop) == True)
                            int UselessPlayer = Damageloop;
							
                        if (PlayerInts[Kills][damageloop] > Statistics[TopKills])
                            {   
							Statistics[TopKills] = PlayerInts[Kills][damageloop];
                            Statistics[TopKiller] = Damageloop;
							}
								
                        }
						
				SetHudSize(640, 480, 0);
				SetFont("WINBG");
                HudMessage(s:"a"; HUDMSG_PLAIN, 858, CR_UNTRANSLATED, 320.0, 240.0, 0);
                SetFont("bigfont");
                
                if(GAME_GAMETYPE == 0)
                    {
                    SetActivator(GameWonBy);
					AmbientSound(voices[PlayerSkin[GameWonBy]][8], 127);
                    HudMessageBold (n:GameWonBy+1, s:"\c- has won!"; HUDMSG_PLAIN, 10, CR_GOLD, 320.0, 64.0, 0);
                    }
					
                if(GAME_GAMETYPE == 1)
                    {
                        if(GameWonBy == 1)
                    HudMessageBold (s:"\chBLUE TEAM\c- has won!"; HUDMSG_PLAIN, 10, CR_GOLD, 320.0, 64.0, 0);
                        else if(GameWonBy == 2)
                    HudMessageBold (s:"\cgRED TEAM\c- has won!"; HUDMSG_PLAIN, 10, CR_GOLD, 320.0, 64.0, 0);
                    }
					
            HudMessageBold (s:"TOTALS"; HUDMSG_PLAIN, 11, CR_WHITE, 320.0, 104.0, 0);
            SetHudSize(640, 480, 0);            
            HudMessageBold (s:"GAME TIME\nTURNS\nDAMAGE\nDEATHS\n\nTOP KILLS\n    BY\nBEST SHOT\n    BY\nHIGHEST SHOT\n    BY\n",
                               s:"LONGEST SHOT\n    BY\n\nMOST SUICIDAL\nMOST USELESS\nMOST ACROBATIC"; HUDMSG_PLAIN, 12, CR_GREEN, 160.0, 224.0, 0);
            SetHudSize(640, 480, 0);          
            HudMessageBold (i:Statistics[TotalGameTime]/60, s:":", i:Statistics[TotalGameTime]%60, s:"\n", i:NumTurns, s:"\n",
                                i:Statistics[TotalDamage], s:"\n", i:Statistics[Deaths], s:"\n\n",
                                i:Statistics[TopKills], s:"\n", n:Statistics[TopKiller]+1, s:"\n", i:Statistics[BestShot], s:"\n", n:Statistics[BestShooter]+1, s:"\n", i:Statistics[HighestShot]>>16, s:"\n",
                                n:Statistics[HighestShooter]+1, s:"\n", i: Statistics[LongestShot]>>16, s:"\n", n:Statistics[LongestShooter]+1, s:"\n\n", 
                                n:Statistics[MostSuicidal]+1, s:"\n", n:UselessPlayer+1, s:"\n", n:Statistics[15]+1; HUDMSG_PLAIN, 13, CR_WHITE, 480.0, 224.0, 0);
                    delay(35*8);
                    while(Votes > 0)
                        {
                            SetHudSize(800, 600, 0);
                            SetFont("bigfont");
                            HudMessageBold(s:"Votes needed to continue: ",
                                            i:votes, s:"\nPress USE to vote"; HUDMSG_PLAIN, 66, CR_GOLD, 400.0, 500.0, 0);
                            for(int useloop = 0; useloop < PlayerCount(); useloop++)
                                { int uses = GetPlayerInput(useloop, INPUT_BUTTONS);
                                    if(uses == BT_USE && PlayerControl[Voted][useloop] == false) { votes--; PlayerControl[Voted][useloop] = true;} }
                        delay(1);
                        }
                    NumTurns = 0;
                    Exit_Normal(0);
                    terminate;
                }
      else if(Players == 1 || GameWon == False )
                {
                    SetFont("bigfont");
                    SetHudSize(800, 600, 0);
                    HudMessageBold (s:"Waiting for Players"; HUDMSG_PLAIN, 10, CR_GREEN, 400.0, 300.0, 2.5);
                    delay(35);
					GameStarted = True;
                    restart;
                }		
        
	}
	delay(1);
 }

delay(1); restart;
}


//
//  CAMERA SCRIPT
//


// Related tids
// 	ProjectileTID	- 	Currently active missiles
//	Playertids - 	Track active player
//	555	- 	Active drops
//	556+(PlayerNumber) - Hit player in motion

int ModY = -512.0;
int x;
int y;
int z;
int cx;
int cy;
int cz;
bool RemoveCursor;

int px2;
int py2;
int pz2;


function void MoveCamera(void)
{
	thing_activate(105);
	int x2 = getactorx(100);
	int y2 = getactory(100);
	int z2 = getactorz(100);

	if(x2 != px2 || y2 != py2 || z2 != pz2)
	{
		Thing_Move(101, 100, true);
		Thing_Move(102, 100, true);
		Thing_Move(103, 100, true);
		Thing_Move(104, 100, true);
	}

	px2 = x2;
	py2 = y2;
	pz2 = z2;
}

Script 3 (int ActivePlayer)
{
    // damn there are a lot of conditions to thing lol
    While(PlayerControl[Menu][ActivePlayer-500] == False && ( PlayerControl[PlayerTurn][ActivePlayer-500] == True || 
            (ThingCount(T_NONE, ProjectileTID) != 0 && PlayerWeapon[ActivePlayer-500] != "RopeAmmo") || ThingCount(T_NONE, 555) != 0 || ThingCount(T_NONE, 999) != 0))
    {
  		ForceCamera();
        x = GetActorX (ActivePlayer);
        y = GetActorY (ActivePlayer);
        z = GetActorZ (ActivePlayer);
        cx = GetActorX (100);
        cy = GetActorY (100);
        cz = GetActorZ (100);
   
        int ModX = GetPlayerInput (ActivePlayer-500, INPUT_YAW);
        int ModZ = GetPlayerInput (ActivePlayer-500, INPUT_PITCH);
        int Buttons = GetPlayerInput (ActivePlayer-500, INPUT_BUTTONS);
            
		if (Buttons & BT_USER1 && ModY < -96.0 ) { ModY += 32.0; }           // Zoom
		if (Buttons & BT_USER2 && ModY > -2048.0 ) { ModY -= 32.0; }
        

		// ???
		if( GUI_Cursor == False && PlayerControl[EndTurn][ActivePlayer-500] == False && 
			ThingCount(T_NONE, ProjectileTID) == 0 && ThingCount(T_NONE, 555) == 0 &&
			ThingCount(T_NONE, 999) == 0) 
			{
					SetActorPosition(100, X, ModY, Z+32.0, 0);
					MoveCamera();
			}



		// If no missiles or item drops
		if((ThingCount(T_NONE, ProjectileTID) == 0 && ThingCount(T_NONE, 555) == 0 && 
			ThingCount(T_NONE, 999) == 0 && 
			PlayerControl[EndTurn][ActivePlayer-500] == False) || 
			PlayerWeapon[ActivePlayer-500] == "RopeAmmo")        
			{
                               
				if(PlayerControl[EndTurn][ActivePlayer-500] == True)
				{
					SetActorPosition(100, cx - (ModX*1000), ModY, cz + (ModZ*1200), 0);
					MoveCamera();
				}
				else 
				{  
					if (Buttons & BT_FORWARD || Buttons & BT_BACK || Buttons & BT_MOVELEFT || Buttons & BT_MOVERIGHT || 
						PlayerWeapon[ActivePlayer-500] == "ItemJetpack" || PlayerWeapon[ActivePlayer-500] == "RopeAmmo")
					{
						SetActorPosition(100, x, ModY, z+(32*65536), 0);
						MoveCamera();
					}
					else    
					{
						SetActorPosition(100, cx - (ModX*10000), ModY, cz + (ModZ*10000), 0);
						MoveCamera();
					}
				}
			}




		// If missiles but not mines
		else if(ThingCount(T_NONE, ProjectileTID) != 0 && (ThingCountName("RopeHook", ProjectileTID) == 0) &&
				ThingCount(T_NONE, 999) == 0 )   
				{
					if (Buttons & BT_FORWARD || Buttons & BT_BACK || Buttons & BT_MOVELEFT || Buttons & BT_MOVERIGHT)
					{
						SetActorPosition(100, x, ModY, z+32*1.0, 0);
						MoveCamera();
					}
					else    
					{
						SetActorPosition(100, GetActorX(ProjectileTID), ModY, GetActorZ(ProjectileTID)+(32*65536), 0);
						MoveCamera();
					}
                        
				}
    


		// Item drops, no mines
		else if(ThingCount(T_NONE, 999) == 0 && 
				ThingCount(T_NONE, 555) != 0 && PlayerControl[EndTurn][ActivePlayer] == False)                                   
				{
					SetActorPosition(100, GetActorX(555), ModY, GetActorZ(555)+128*65536, 0);
					MoveCamera();
				}
    



		// ???
		else if(ThingCountName("Mine", 0) != 0 &&
				ThingCount(T_NONE, ProjectileTID) == 0 && 
				PlayerControl[EndTurn][ActivePlayer] == True)    
				{
                    for(int MineCheck = 1001; MineCheck > 1006; MineCheck++)
                        {
                            if(GetActorVelZ(MineCheck) != 0) 
							{
                                SetActorPosition(100, GetActorX(MineCheck), ModY, GetActorZ(MineCheck), 0);
								MoveCamera();
							}

                        }
				}


		 // Active mines  
		else if(ThingCount(T_NONE, 999) != 0 && ThingCount(T_NONE, ProjectileTID) == 0 
            && PlayerControl[EndTurn][ActivePlayer-500] == True && Moving == False)
		{
			SetActorPosition(100, GetActorX(999), ModY, GetActorZ(999)+(32.0), 0);
			MoveCamera();
		}


		// Don't view underwater
	    if(GetActorZ(100) <= GetSectorCeilingZ(9,0,0))
		{
			SetActorPosition(100, cx, ModY, GetSectorCeilingZ(9,0,0)+96.0, 0);       
			MoveCamera();
		}

		// ???
		for(int PlayerCheck = 0; PlayerCheck < MaxPlayersArray; PlayerCheck++)
		{
			while(ThingCount(T_NONE, 556+PlayerCheck) != 0 )
	            {
	                SetActorPosition(100, GetActorX(556+PlayerCheck), ModY, GetActorZ(556+PlayerCheck), 0);
					MoveCamera();
	                Delay(1);
	            }
		}

                                            ///////////////////
                                            ///// CURSOR CODE
                                            ///////////////////
	While (Gui_Cursor == True && PlayerControl[PlayerTurn][ActivePlayer-500] == True)
		{
        
			if( PlayerWeapon[ActivePlayer-500] != "HomingMissile" &&
				PlayerWeapon[ActivePlayer-500] != "Girder" &&
				PlayerWeapon[ActivePlayer-500] != "ItemTeleport" &&
				PlayerWeapon[ActivePlayer-500] != "AirStrike" &&
				PlayerWeapon[ActivePlayer-500] != "NapalmStrikeAmmo" &&
				PlayerWeapon[ActivePlayer-500] != "GirderKit" )	
			{ 
				delay(1); 
				restart;
			}
                
			Shooting = false;
			ModX = GetPlayerInput (ActivePlayer-500, INPUT_YAW);
			ModZ = GetPlayerInput (ActivePlayer-500, INPUT_PITCH);
			Buttons = GetPlayerInput (ActivePlayer-500, INPUT_BUTTONS);
        
			if (Buttons & BT_USER1 && ModY < -96.0 ) ModY += 32.0;           // Zoom
			if (Buttons & BT_USER2 && ModY > -2048.0 ) ModY -= 32.0;
        
			if(DistanceXZ(211, ActivePlayer) > 1024 && (PlayerWeapon[ActivePlayer-500] == "Girder" || PlayerWeapon[ActivePlayer-500] == "GirderKit"))
			{
					Thing_SetTranslation(211, 50);
			}
			else if(DistanceXZ(211, ActivePlayer) < 1024 && (PlayerWeapon[ActivePlayer-500] == "Girder" || PlayerWeapon[ActivePlayer-500] == "GirderKit"))
			{
					Thing_SetTranslation(211, 0);
			}

			SetActorPosition(211, GetActorX(211) - (ModX*4000), LVL_YPOS, GetActorZ(211) + (ModZ*4000), 0);
			MoveCamera();

			if(ThingCount(T_NONE, 211) != 0) 
			{
					SetActorPosition(100, GetActorX(211), ModY, GetActorZ(211), 0);
					SetActorPosition(215, GetActorX(211), ModY, GetActorZ(211), 0);
					MoveCamera();
			}
        
			if(Buttons & BT_ATTACK)
			{
				if(ThingCount(T_NONE, 212) >= 1) { terminate; }
                
				 // Airstrike
				if(PlayerWeapon[ActivePlayer-500] == "AirStrike" || PlayerWeapon[ActivePlayer-500] == "NapalmStrikeAmmo")
				{
					Spawn("ClickedSpot", GetActorX(211), LVL_YPOS, GetActorZ(211), 212, 0);    
					RemoveCursor = True;
				}

				// Homing Missile
				else if (PlayerWeapon[ActivePlayer-500] == "HomingMissile")
				{
					Spawn("GUITarget2", GetActorX(211), LVL_YPOS, GetActorZ(211), 212, 0);     
					RemoveCursor = True;
				}

				// Girder
				else if (PlayerWeapon[ActivePlayer-500] == "Girder" || PlayerWeapon[ActivePlayer-500] == "GirderKit")                           
				{	
					Spawn("DummyAim", GetActorX(211), LVL_YPOS, GetActorZ(211), 212, 0);
					RemoveCursor = True;
				}
                
				// Teleport
				else if (PlayerWeapon[ActivePlayer-500] == "ItemTeleport")                      
				{
					if(Spawnspot("PlayerBlockCheck", 211, 214, 0) == 0)
					{
						AmbientSound("world/clickfail", 127); 
						RemoveCursor = False; 
					}
					else
					{
							RemoveCursor = True;
							Thing_Remove(214);
							delay(1);
							Spawn("ClickedSpot", GetActorX(211), LVL_YPOS, GetActorZ(211), 212, 0);
					}
				}
                
				Delay(1);
                    
				if(ThingCount(T_NONE, 212) != 0 && RemoveCursor == True)
				{   
					GUI_Clicked = True;
					GUI_Cursor = False;
					Thing_Remove(211);
					Thing_Remove(215);
				}
                
                else 
				{ 
					AmbientSound("world/clickfail", 127); 
				}
 
				SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);                                           
				if(RemoveCursor == True)
				{
					Thing_Remove(211);
					Thing_Remove(215);
					delay(35);
                	Targetted = True;
					Shooting = true;
				}

				if(RemoveCursor == False)
				{
					Delay(10);
				}

				restart;
			}
    
			// Don't view underwater
			if(GetActorZ(100) <= GetSectorCeilingZ(9,0,0))
			{
				SetActorPosition(100, cx, ModY, GetSectorCeilingZ(9,0,0)+96.0, 0);       
				MoveCamera();
			}
			delay(1);

		}
		delay(1);
		if(Gui_Cursor == False) restart;
		if(PlayerControl[Menu][ActivePlayer-500] == True) terminate;
	}

	// While Menu is open
	while(PlayerControl[Menu][ActivePlayer-500] == True)		
		{
			delay(1);
		}
    
	While(ThingCount(T_NONE,ProjectileTID) != 0) 
	{
		Delay(5);
	}
	while(ThingCount(T_NONE, 556) != 0 )
	{
		SetActorPosition(100, GetActorX(556), ModY, GetActorZ(556), 0);
		MoveCamera();
		Delay(1);
	}
            
	if(PlayerControl[PlayerTurn][ActivePlayer-500] == true) 
	{ 
		delay(1); 
		restart; 
	}
	else 
	{ 
		GUI_Cursor = False; 
		terminate; 
	}

}

Script 967 ENTER
{
if(GetLevelInfo(LEVELINFO_LevelNum) == 0) Terminate;
for(int PDisplay = 0; PDisplay < MaxPlayersArray; PDisplay++)
            {
                if(PlayerInts[Lives][Pdisplay] > 0)
                    if(PlayerControl[PlayerTurn][PDisplay] == False) DisplayHealthName(PDisplay+500);
            }
delay(5);
restart;
}

// Quick fix for displayhealthname on client side
Script 957 RESPAWN
{
if(GetLevelInfo(LEVELINFO_LevelNum) == 0) Terminate;
ACS_Execute(967, 0);
}




Script 970 (VOID) // Waiting on extra stuff between turns
{
	int Counter = 0;

while(1)
{
    While(ThingCount(T_NONE, ProjectileTID) != 0)                                 // Bugged missile remover
		delay(30);

    for(int ploop = 0; ploop < MaxPlayersArray; ploop++)
	    While(ThingCount(T_NONE, 556+ploop) != 0)
		delay(30);
        
		// Don't end turn until all players have stopped moving
    For(int PlayerMoveCheck = 0; PlayerMoveCheck > MaxPlayersArray ; PlayerMoveCheck++)   
		{   
		While ( GetActorVelX(PlayerMoveCheck+500) +
                GetActorVelZ(PlayerMoveCheck+500) != 0 && 
					NotWater(PlayerMoveCheck+500) == true) 
            Delay(35); 
		}   
               
	while( GetActorVelX(ProjectileTID) + GetActorVelZ(ProjectileTID) + 
			CheckActorInventory(999, "MineActive") +
			(GetActorVelX(1001) + GetActorVelX(1002) + GetActorVelX(1003) +
            GetActorVelX(1004) + GetActorVelX(1005) + GetActorVelX(1006) +
            ThingCount(T_NONE, 999)) != 0)
			Delay(35);

        Counter++;
		
	if(Counter == 5) 
		{ 
		Counter = 0; 
		StuffHappening = False; 
		terminate; 
		}
        
		delay(35);
 }
}

function void ForceMissileAxis (void)
{
if(ThingCountName("WeaponDemon", ProjectileTID) == 0 && ThingCountName("HomingMissile", ProjectileTID) == 0)
    {
            SetActorPosition(ProjectileTID, GetActorX(ProjectileTID), LVL_YPOS, GetActorZ(ProjectileTID), 0);
            
            if(GetActorVelX(ProjectileTID) > 0)
                    SetActorAngle(ProjectileTID, 1.0);
            else if(GetActorVelX(ProjectileTID) < 0)
                    SetActorAngle(ProjectileTID, 0.5);
    }
else 
    {
            SetActorPosition(ProjectileTID, GetActorX(ProjectileTID), LVL_YPOS, GetActorZ(ProjectileTID), 0);
            
            if(GetActorAngle(ProjectileTID) >> 8 < 32 || 
               GetActorAngle(ProjectileTID) >> 8 > 224 )
                    SetActorAngle(ProjectileTID, 1.0);
            else    SetActorAngle(ProjectileTID, 0.5);
    }
}


// MISSILE CONTROL SCRIPT

Script 949 (int Player)                       // Makes sure missiles are facing the right way
{	
	int TimeFired = Timer();    
	TornadoDone = False;	             // And forces them on Y axis
		ForceMissileAxis();
			int DirectionWhenFired = GetActorAngle(ProjectileTID);

    While(ThingCount(T_NONE, ProjectileTID) != 0)
    {

	MissilePos[0] = GetActorX(ProjectileTID);
	MissilePos[1] = GetActorZ(ProjectileTID);
	
	if (BeamPower != "Tornado")
	    {
	
        ForceMissileAxis();

	if(ShotStat[1] < GetActorZ(ProjectileTID)) 
		ShotStat[1] = GetActorZ(ProjectileTID);

        if(GetActorZ(ProjectileTID) > Statistics[HighestShot])
	        { Statistics[HighestShot] = GetActorZ(ProjectileTID);
        	  Statistics[HighestShooter] = Player; }

        if(PlayerPosition > GetActorX(ProjectileTID))
		{
			ShotStat[0] = PlayerPosition-GetActorX(ProjectileTID);
		            if(PlayerPosition-GetActorX(ProjectileTID) > Statistics[LongestShot])
		                 { Statistics[LongestShot] = PlayerPosition-GetActorX(ProjectileTID);
			           Statistics[LongestShooter] = Player; }
		}
    else if(PlayerPosition < GetActorX(ProjectileTID))
		{
			ShotStat[0] = GetActorX(ProjectileTID)-PlayerPosition;
		            if(GetActorX(ProjectileTID) - PlayerPosition > Statistics[LongestShot])
                		{ Statistics[LongestShot] = GetActorX(ProjectileTID) - PlayerPosition;
				  Statistics[LongestShooter] = Player; }
		}

        if(GetActorAngle(ProjectileTID) != DirectionWhenFired && Backshot == False && PlayerWeapon[Player] == "BazookaRocket")
            {   //PlayerInts[14][Player]++;
                backshot = true; }
                else backshot = false;

	if(ThingCount(T_NONE, 760) != 0 || ThingCount(T_NONE, 762) != 0 )
		{
			if(distance(ProjectileTID, 760) < 128)
				{
					if(ThingCountName("SunBeam", 760) == 1) 
						BeamPower = "Sun";
					if(ThingCountName("ElecBeam", 760) == 1)
						BeamPower = "Elec";
					if(ThingCountName("Tornado", 760) == 1 && BeamPower != "TornadoDone")
						BeamPower = "Tornado";
					if(ThingCountName("GooBeam", 760) == 1)
						BeamPower = "Goo";
				}
			if(distance(ProjectileTID, 762) < 128)
				{
					if(ThingCountName("SunBeam", 762) == 1) 
						BeamPower = "Sun";
					if(ThingCountName("ElecBeam", 762) == 1)
						BeamPower = "Elec";
					if(ThingCountName("Tornado", 762) == 1 && BeamPower != "TornadoDone")
						BeamPower = "Tornado";
					if(ThingCountName("GooBeam", 762) == 1)
						BeamPower = "Goo";
				}
		}								
	if(BeamPower != "None" && Timer()%4 == 0)
		{
			if(BeamPower == "Sun")
			SpawnSpot("SunBeamSpot1", ProjectileTID, 0, 0);
			if(BeamPower == "Elec")
			SpawnSpot("ElecBeamSpot1", ProjectileTID, 0, 0);
		}
	}

	if(BeamPower == "Tornado" && (Distance(ProjectileTID, 760) < 112 || Distance(ProjectileTID, 762) < 112))
		{
			int MisVelX = GetActorVelX(ProjectileTID);
			int MisVelZ = GetActorVelZ(ProjectileTID);
			SetActorVelocity(ProjectileTID, 0, 0, MisVelZ, 0, 0);
			delay(1);
			if(Distance(ProjectileTID, 760) < 112)
					{
						SetActorAngle(760, GetTargetAngle(760, ProjectileTID));
						Orbit(760, ProjectileTID, MisVelX>>16, 96, 2);
					}
			else if(Distance(ProjectileTID, 762) < 112)
					{
						SetActorAngle(762, GetTargetAngle(762, ProjectileTID));
						Orbit(762, ProjectileTID, MisVelX>>16, 96, 2);
					}
			
			ShotStatus = "Tornado";
			BeamPower = "TornadoDone";
			
		}
	if(TornadoDone == True) 
		{ SetActorVelocity(ProjectileTID, MisVelX, 0, GetActorVelZ(ProjectileTID), 0, 0); forcemissileaxis();
			While(Distance(ProjectileTID, 760) < 128 || Distance(ProjectileTID, 762) < 128 ) 
				Delay(15); 
			TornadoDone = False; BeamPower = "None";}

	if(BeamPower == "Goo" && (Distance(ProjectileTID, 760) < 112 || Distance(ProjectileTID, 762) < 112))
		{
		
			MisVelX = GetActorVelX(ProjectileTID);
			MisVelZ = GetActorVelZ(ProjectileTID);
			bool GooFirst;
				if(GooFirst == False)
					{
					AmbientSound("shot/goo", 127);
					For(Int SLoop = 8; Sloop > 0; Sloop--)
						{
							SpawnSpot("Sludge1", ProjectileTID, 333, Random(0, 360));
							Spawn("Sludge2", GetActorX(ProjectileTID)+Random(-8.0, 8.0), LVL_YPOS, 								GetActorZ(ProjectileTID)+Random(-8.0, 8.0), 333, Random(0, 360));
							Spawn("Sludge3", GetActorX(ProjectileTID)+Random(-8.0, 8.0), LVL_YPOS, 								GetActorZ(ProjectileTID)+Random(-8.0, 8.0), 333, Random(0, 360));						
						}
						SetActorVelocity(333, -MisVelX, Random(-2.0, 2.0), -MisVelZ, 0, 0);
					GooFirst = True;
					}

			if(Distance(ProjectileTID, 760) < 112 || Distance(ProjectileTID, 762) < 112)
					{	
							
							if((MisVelX > 1.0 || MisVelX < -1.0) && MisVelX != 0)
								SetActorVelocity(ProjectileTID, -MisVelX/2, 0, -MisVelZ/2, 1, 0);
					}
								
			delay(2);
			
			ShotStatus = "Goo";
			BeamPower = "None";
			
		}
	
        	delay(1);
		GooFirst = False;
    }
	int Closest = 10000;

	for(int Flop = 0; Flop < MaxPlayersArray; Flop++)
		{
			if(MissilePos[0] < 0)
				{
					if(-(MissilePos[0] - GetActorX(Flop+500)) < Closest && 
						-(MissilePos[0] - GetActorX(Flop+500)) > 0 )
						{
						Closest = MissilePos[0] - GetActorX(Flop+500);
						ClosestPlayer = Flop+500;
						}
				}
			else	{			
					if((MissilePos[0] - GetActorX(Flop+500)) < Closest &&
						(MissilePos[0] - GetActorX(Flop+500)) > 0)
						{
						Closest = MissilePos[0] - GetActorX(Flop+500);
						ClosestPlayer = Flop+500;
						}
				}
		}

	int TimeFinished = Timer();
	ShotStat[2] = TimeFinished-TimeFired;
	GooFirst = False;
}


// determines if the shot passed through a beam and if so, causes effect at detonation
Script 935 (VOID)
{

if(BeamPower == "Sun")
	{
	Spawn("SunBeamExplosion", MissilePos[0], LVL_YPOS, MissilePos[1], 0, 0);
	}

if(BeamPower == "Elec")
	{
	Spawn("Explosion_Spawner_Blue", MissilePos[0]*1.0, LVL_YPOS, MissilePos[1]*1.0, 0, 0);
	Spawn("LightningBolt", MissilePos[0]*1.0, LVL_YPOS, MissilePos[1]*1.0, 0, 0);
	}
	
}

Script 930 (VOID)
{
 
    if(SuddenDeathNotice == False && GAME_SUDDENDEATH != True)
            {
                SetFont("BIGFONT");
                SetHudSize(640, 480, 0);
                HudMessageBold(s:"SUDDEN DEATH LOOMS!"; HUDMSG_FADEINOUT, 95, CR_RED, 320.0, 200.0, 4.0, 0.5, 0.5);
                SuddenDeathNotice = True;
                GameTimeColorStr = "Red";
            }
            
    if(GAME_SUDDENDEATH != True) While(GAMETIME > 0) Delay(35);
    
        SetFont("BIGFONT");
        SetHudSize(640, 480, 0);
        HudMessageBold(s:"SUDDEN DEATH!"; HUDMSG_FADEINOUT, 95, CR_RED, 320.0, 200.0, 4.0, 0.5, 0.5);
    
    SuddenDeathNotice = True;
    GAME_SUDDENDEATH = True;

}


// Drowning script, ends turn
Script 951 (VOID)
{
if(PlayerControl[PlayerTurn][PlayerNumber()] == True) Timeloop = 0;
Thing_Damage2(0, 500, 12);
}

function int sqrt (int xx)
{
	int r;
	xx = xx + 1 >> 1;
	while (xx > r)
		xx -= r++;
	return r;
}

function int distance (int tid1, int tid2)
{
	int xx, d;
	xx = GetActorX(tid1) - GetActorX(tid2) >> 16;
	d = xx*xx;
	return d;
}

function int distancexz (int tid1, int tid2)
{
	int xx, zz, d;
	xx = GetActorX(tid1) - GetActorX(tid2) >> 16;
	zz = GetActorZ(tid1) - GetActorZ(tid2) >> 16;
	d = sqrt( xx*xx + zz*zz );
	return d;
}

function void hudmessageonactor(int tid, int text)
{
	int dist, ang, vang, pitch, hx, hy;
	int HUDX = 800;
	int HUDY = 600;
	int offset = -24.0;
	
	hx = getactorx(tid) - getactorx(100);
	hy = getactory(tid) - getactory(100); 

	vang = vectorangle(hx,hy);
	ang = (vang - GetActorAngle(100) + 1.0) % 1.0;

	if(((vang+0.125)%0.5) > 0.25) dist = fixeddiv(hy, sin(vang));
	else dist = fixeddiv(hx, cos(vang));
  
	if ((ang < 0.2 || ang > 0.8))
	{
		pitch = vectorangle(dist, getactorz(tid) - (getactorz(100) + 41.0));
		pitch = (pitch + 1.0) % 1.0;

		hx = HUDX/2 - ((HUDX/2) * sin(ang) / cos(ang));
		hy = HUDY/2 - ((HUDX/2) * sin(pitch) / cos(pitch));

		 setfont("SMALLFONT");
   sethudsize(HUDX, HUDY, 0);
   hudmessagebold(i:text; HUDMSG_PLAIN, Tid+1000, CR_RED, (hx<<16)-offset, (hy<<16)+offset, 1.0);

	}
	else
		hudmessagebold(s:" "; HUDMSG_PLAIN, Tid+1000, CR_UNTRANSLATED, 0, 0, 0);
}

str HealthString[MaxPlayersArray];

function void DisplayHealthName(int tid)
{
 int dist;
 int ang, vang, pitch, hx, hy;
	int HUDX = 800;
	int HUDY = 600;
	int offset = 0.0;
	
	hx = getactorx(tid) - getactorx(100);
	hy = getactory(tid) - getactory(100); 

	vang = vectorangle(hx,hy);
	ang = (vang - GetActorAngle(100) + 1.0) % 1.0;

	if(((vang+0.125)%0.5) > 0.25) dist = fixeddiv(hy, sin(vang));
	else dist = fixeddiv(hx, cos(vang));
  
  if ((ang < 0.2 || ang > 0.8))
	{
		pitch = vectorangle(dist, getactorz(tid) - (getactorz(100) + 41.0));
		pitch = (pitch + 1.0) % 1.0;

		hx = HUDX/2 - ((HUDX/2) * sin(ang) / cos(ang));
		hy = HUDY/2 - ((HUDX/2) * sin(pitch) / cos(pitch));

		 setfont("SMALLFONT");
   sethudsize(HUDX, HUDY, 0);
   

        if(GetActorProperty(tid, APROP_Health) > 100) HealthString[tid-500] = "GREEN";

else    if(GetActorProperty(tid, APROP_Health) < 100 && 
           GetActorProperty(tid, APROP_Health) > 50 ) HealthString[tid-500] = "YELLOW";

else        HealthString[tid-500] = "RED";
   
 
    setactivator(tid);
   
   hudmessagebold(n:0; HUDMSG_PLAIN, tid, CR_YELLOW, (hx<<16), (hy<<16)-offset, 1.0);
   hudmessagebold(i:GetActorProperty(tid, APROP_Health); HUDMSG_PLAIN | HUDMSG_COLORSTRING,
                            Tid-100, HealthString[tid-500], (hx<<16), (hy<<16)-(offset-8.0), 0.3);
    if(GAME_GAMETYPE == 1 && PlayerTeam2[tid-500] == "Blue")
        HudMessageBold(s:"\chBLUE"; HUDMSG_PLAIN, tid+1400, CR_UNTRANSLATED, (hx<<16), (hy<<16)-(offset-42.0), 0.3);
    if(GAME_GAMETYPE == 1 && PlayerTeam2[tid-500] == "Red")
        HudMessageBold(s:"\cgRED"; HUDMSG_PLAIN, tid+1400, CR_UNTRANSLATED, (hx<<16), (hy<<16)-(offset-42.0), 0.3);

	}
	else
		 
    hudmessage(s:" "; HUDMSG_PLAIN, Tid, CR_UNTRANSLATED, 0, 0, 0.1);
    hudmessage(s:" "; HUDMSG_PLAIN, Tid-100, CR_UNTRANSLATED, 0, 0, 0.1);
}

function int GetTargetPitch (int tid1, int tid2)
{
    int px, py, pz, pxy, pang;
    px = GetActorX(tid2) - GetActorX(tid1);
    py = GetActorY(tid2) - GetActorY(tid1);
    pz = GetActorZ(tid2) - GetActorZ(tid1);
    pang = VectorAngle(px, py);
    if(((pang+0.125)%0.5) > 0.25) pxy = fixeddiv(py, sin(pang));
    else pxy = fixeddiv(px, cos(pang));
    return -VectorAngle(pxy, pz);
}


function int distancexyz2 (int dx1, int dy1, int dz1, int dx2, int dy2, int dz2)
{
	int dx, dy, dz, dd;
	dx = dx1 - dx2;
	dy = dy1 - dy2;
	dz = dz1 - dz2;
	dd = sqrt(dx*dx + dy*dy + dz*dz);
	return dd;
}


function int GetTargetPitchxyz2 (int gtpx1, int gtpy1, int gtpz1, int gtpx2, int gtpy2, int gtpz2)
{
    int gtpx, gtpy, gtpz, gtpxy, gtpang;
    gtpx = gtpx2 - gtpx1;
    gtpy = gtpy2 - gtpy1;
    gtpz = gtpz2 - gtpz1;
    gtpang = VectorAngle(gtpx, gtpy);
    if(((gtpang+0.125)%0.5) > 0.25) gtpxy = fixeddiv(gtpy, sin(gtpang));
    else gtpxy = fixeddiv(x, cos(gtpang));
    return -VectorAngle(gtpxy, gtpz);
}

function int GetTargetAngle (int tid1, int tid2)
{
    int gtx1 = GetActorX(tid1);
    int gtx2 = GetActorX(tid2);
    int gtz1 = GetActorZ(tid1);
    int gtz2 = GetActorZ(tid2);
    int gtx = gtx2 - gtx1;
    int gtz = gtz2 - gtz1;
    return VectorAngle(gtx, gtz);
}

// Clientside inventory updater
Script 909 (int PlayNum, int Weapon, int CountInv) CLIENTSIDE
{	
	Inventory[PlayNum][Weapon] = CountInv;
}

// Menu trigger
Script 886 (VOID) net
{
      if(GetActorVelZ(PlayerNumber()+500) != 0) terminate;
      if(GetActorVelX(PlayerNumber()+500) != 0) terminate;
	for(int wloop = 0; wloop < MaxInventory; wloop++)
		ACS_ExecuteAlways(909, 0, PlayerNumber(), wloop, Inventory[PlayerNumber()][Wloop]);

     if(PlayerControl[PlayerTurn][PlayerNumber()] == True && PlayerControl[Menu][PlayerNumber()] == False
        && PlayerControl[HasFired][PlayerNumber()] == False && PlayerControl[IsFiring][PlayerNumber()] == False && GirdersPlaced == 0)
        { 
	    ACS_Execute(909, 0, PlayerNumber());
            Thing_Remove(211); Thing_Remove(212);  Thing_Remove(960); Thing_Remove(215);
            PlayerControl[Menu][PlayerNumber()] = True;
            ACS_Suspend(3, 0);
            ACS_Terminate(996, 0);
            ACS_ExecuteAlways(888, 0, PlayerNumber());
            ACS_ExecuteAlways(887, 0, PlayerNumber()); 
            ACS_Execute(882, 0, PlayerNumber());
	    Shooting = False;
		Spawn("Thought", GetActorX(PlayerNumber()+500), LVL_YPOS, GetActorZ(PlayerNumber()+500)+52.0, 960);
        }

else if(PlayerControl[PlayerTurn][PlayerNumber()] == True && PlayerControl[Menu][PlayerNumber()] == True
        && PlayerControl[HasFired][PlayerNumber()] == False && PlayerControl[IsFiring][PlayerNumber()] == False)
        { 
			Thing_Remove(960);
            Thing_Remove(211); Thing_Remove(212); Thing_Remove(215);
            PlayerControl[Menu][PlayerNumber()] = False;
            ACS_Execute(3, 0, PlayerNumber()+500);
            ACS_Execute(996, 0, PlayerNumber());
            ACS_Execute(882, 0, PlayerNumber());
	    Shooting = True;
        }
}


#define SCREEN_WIDTH 800
#define SCREEN_HEIGHT 600

#define CURSOR_XSENS 15
#define CURSOR_YSENS 15

int mousexadd[MaxPlayersArray];
int mouseyadd[MaxPlayersArray];

int mousex[MaxPlayersArray];
int mousey[MaxPlayersArray];
int mousepress[MaxPlayersArray];                
int mouseclick[MaxPlayersArray];                 

function bool button(int bx, int by, int bwidth, int bheight, str bimage, str boverimage, int bid, int bptid, int WeaponNumber)
{

    SetHudSize(SCREEN_WIDTH, SCREEN_HEIGHT, 0);
    if(mousex[bptid] > bx - Half(bwidth) && mousex[bptid] < bx + Half(bwidth) && mousey[bptid] > by - Half(bheight) && mousey[bptid] < by + Half(bheight))
        {
            SetFont("BigFont");
            HudMessage(s:WeaponNiceName[WeaponNumber-1]; 0, bid+200, CR_TAN, 668.0, 268.0, 0.1);            
            SetFont(boverimage);
            if(mousepress[bptid] == true)
                {
                    return true;
                }
        }
    else
        {
            SetFont(bimage);
        }
    
    HudMessage(s:"a"; 0, bid, 0, Int2Fix(bx), Int2Fix(by), 0.1);
    setfont("Smallfont");
    HudMessage(i:Inventory[bptid][WeaponNumber-1]; 0, bid+100, 0, int2fix(bx)-16.0, int2fix(by)-16.0, 0.1);
    return false;
}

// Clientside trickery (Clientsided scripts do not receive serverside variables)

Script 882 (int Player) clientside
{
if(ClientMenu[Player] == True) ClientMenu[Player] = false;
else ClientMenu[Player] = True;
}

Script 881 (int Player) clientside
{
for(int FuckItAll = 0; FuckItAll < MaxPlayersArray; FuckItAll++)
    {
        ClientMenu[FuckItAll] = false;
    }
}

bool HasClientFired[MaxPlayersArray];

Script 880 (int Player) clientside
{
    HasClientFired[Player] = True;
}

Script 879 (int Player) clientside
{
    HasClientFired[Player] = False;
}

// clientsided weapons hud menu
//////////////////////////////////////////////////////////////////////////
#DEFINE XShift -8
#DEFINE YShift -1
 
Script 887 (int Player) clientside
{

               if(ClientMenu[Player] == false 
			|| HasClientFired[Player] == true) 
				{ ACS_Execute(3, 0, Player+500); Thing_Remove(960); terminate; }
               
		SetHudSize(640, 480, 0);
                SetFont("WEAPBOX");
                HudMessage(s:"a"; HUDMSG_PLAIN, 9000, CR_UNTRANSLATED,
                            551.0-16.0, 336.0, 0.2);

    if(Inventory[Player][Bazooka] > 0)
    { if(button(600+XSHIFT, 320, 32, 32, "WRCKA0", "WRCKB0", 800, PlayerNumber(), 1) == true)
        { ConsoleCommand("Puke 987 1"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 320, 32, 32, "WRCKC0", "WRCKC0", 800, PlayerNumber(), 1);
                    
    if(Inventory[Player][HomingMissile] > 0)
        { if(button(634+XSHIFT, 320, 32, 32, "WHOMA0", "WHOMB0", 801, PlayerNumber(), 16) == true)
            { ConsoleCommand("Puke 987 16"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 320, 32, 32, "WHOMC0", "WHOMC0", 801, PlayerNumber(), 16);
        
    if(Inventory[Player][SkipTurn] > 0)
        { if(button(668+XSHIFT, 320, 32, 32, "WSKPB0", "WSKPA0", 868, PlayerNumber(), 28) == true)
            { ConsoleCommand("Puke 987 28"); delay(8); ACS_Terminate(888,0);  terminate; }}
    else
        button(634+XSHIFT, 320, 32, 32, "WHOMC0", "WHOMC0", 868, PlayerNumber(), 16);               
//Next Row
    if(Inventory[Player][Grenade] > 0)    
        { if(button(600+XSHIFT, 354+YSHIFT, 32, 32, "WGRNA0", "WGRNB0", 802, PlayerNumber(), 2) == true)
            { ConsoleCommand("Puke 987 2"); delay(8); ACS_Terminate(888,0);  terminate; }}
    else
        button(600+XSHIFT, 354, 32, 32, "WGRNC0", "WGRNC0", 802, PlayerNumber(), 2);
    
    if(Inventory[Player][ClusterBomb] > 0)    
        { if(button(634+XSHIFT, 354+YSHIFT, 32, 32, "WCLSA0", "WCLSB0", 803, PlayerNumber(), 3) == true)
            { ConsoleCommand("Puke 987 3"); delay(8); ACS_Terminate(888,0); terminate; }}
    else                    
        button(634+XSHIFT, 354+YSHIFT, 32, 32, "WCLSC0", "WCLSC0", 803, PlayerNumber(), 3);
    
    if(Inventory[Player][MolotovCocktail] > 0)    
        { if(button(668+XSHIFT, 354+YSHIFT, 32, 32, "WBOTA0", "WBOTB0", 804, PlayerNumber(), 6) == true)
            { ConsoleCommand("Puke 987 6"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(668+XSHIFT, 354+YSHIFT, 32, 32, "WBOTC0", "WBOTC0", 804, PlayerNumber(), 6);
                
    if(Inventory[Player][BananaBomb] > 0)    
        { if(button(702+XSHIFT, 354+YSHIFT, 32, 32, "WBANA0", "WBANB0", 818, PlayerNumber(), 19) == true)
            { ConsoleCommand("Puke 987 19"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(702+XSHIFT, 354+YSHIFT, 32, 32, "WBANC0", "WBANC0", 818, PlayerNumber(), 19);
                    
    //Next Row                    
                    
    if(Inventory[Player][Shotgun] > 0)    
        { if(button(600+XSHIFT, 388+YSHIFT, 32, 32, "WSHTA0", "WSHTB0", 805, PlayerNumber(), 4) == true)
            { ConsoleCommand("Puke 987 4"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 388+YSHIFT, 32, 32, "WSHTC0", "WSHTC0", 805, PlayerNumber(), 4);
                
    if(Inventory[Player][Uzi] > 0)    
        { if(button(634+XSHIFT, 388+YSHIFT, 32, 32, "WUZIA0", "WUZIB0", 806, PlayerNumber(), 5) == true)
            { ConsoleCommand("Puke 987 5"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 388+YSHIFT, 32, 32, "WUZIC0", "WUZIC0", 806, PlayerNumber(), 5);    
        
//Next Row
                
    if(Inventory[Player][PlasmaGun] > 0)    
        { if(button(600+XSHIFT, 422+YSHIFT, 32, 32, "WPLSA0", "WPLSB0", 807, PlayerNumber(), 10) == true)
            { ConsoleCommand("Puke 987 10"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 422+YSHIFT, 32, 32, "WPLSC0", "WPLSC0", 807, PlayerNumber(), 10); 

        if(Inventory[Player][Railgun] > 0)    
        { if(button(634+XSHIFT, 422+YSHIFT, 32, 32, "WRALA0", "WRALB0", 808, PlayerNumber(), 14) == true)
            { ConsoleCommand("Puke 987 14"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 422+YSHIFT, 32, 32, "WRALC0", "WRALC0", 808, PlayerNumber(), 14);
            
    if(Inventory[Player][BFG] > 0)    
        { if(button(668+XSHIFT, 422+YSHIFT, 32, 32, "WBFGA0", "WBFGB0", 809, PlayerNumber(), 11) == true)
            { ConsoleCommand("Puke 987 11"); delay(8); ACS_Terminate(888,0); terminate; }}
        else
        button(668+XSHIFT, 422+YSHIFT, 32, 32, "WBFGC0", "WBFGC0", 809, PlayerNumber(), 11); 
            
//Next Row
            
    if(Inventory[Player][Mine] > 0)    
        { if(button(600+XSHIFT, 456+YSHIFT, 32, 32, "WMINA0", "WMINB0", 810, PlayerNumber(), 7) == true)
            { ConsoleCommand("Puke 987 7"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 456+YSHIFT, 32, 32, "WMINC0", "WMINC0", 810, PlayerNumber(), 7); 
    
    if(Inventory[Player][Dynamite] > 0)        
                    
        { if(button(634+XSHIFT, 456+YSHIFT, 32, 32, "WDYNA0", "WDYNB0", 819, PlayerNumber(), 20) == true)
            { ConsoleCommand("Puke 987 20"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 456+YSHIFT, 32, 32, "WDYNC0", "WDYNC0", 819, PlayerNumber(), 20); 
    
    if(Inventory[Player][Bat] > 0)        
            
        { if(button(668+XSHIFT, 456+YSHIFT, 32, 32, "WBATA0", "WBATB0", 817, PlayerNumber(), 9) == true)
            { ConsoleCommand("Puke 987 9"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(668+XSHIFT, 456+YSHIFT, 32, 32, "WBATC0", "WBATC0", 817, PlayerNumber(), 9); 

    if(Inventory[Player][Kick] > 0)        
        { if(button(702+XSHIFT, 456+YSHIFT, 32, 32, "WKIKA0", "WKIKB0", 826, PlayerNumber(), 25) == true)
            { ConsoleCommand("Puke 987 25"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(702+XSHIFT, 456+YSHIFT, 32, 32, "WKIKC0", "WKIKC0", 826, PlayerNumber(), 25); 
            
//Next Row
            
    if(Inventory[Player][SuicideDemon] > 0)    
        { if(button(600+XSHIFT, 490+YSHIFT, 32, 32, "WDEMA0", "WDEMB0", 811, PlayerNumber(), 8) == true)
            { ConsoleCommand("Puke 987 8"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 490+YSHIFT, 32, 32, "WDEMC0", "WDEMC0", 811, PlayerNumber(), 8); 
        
    if(Inventory[Player][KamikazeBomber] > 0)    
        { if(button(634+XSHIFT, 490+YSHIFT, 32, 32, "WKMBA0", "WKMBB0", 812, PlayerNumber(), 17) == true)
            { ConsoleCommand("Puke 987 17"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 490+YSHIFT, 32, 32, "WKMBC0", "WKMBC0", 812, PlayerNumber(), 17);
            
    if(Inventory[Player][ClusterDemon] > 0)    
        { if(button(668+XSHIFT, 490+YSHIFT, 32, 32, "WCDMA0", "WCDMB0", 833, PlayerNumber(), 22) == true)
            { ConsoleCommand("Puke 987 22"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(668+XSHIFT, 490+YSHIFT, 32, 32, "WCDMC0", "WCDMC0", 833, PlayerNumber(), 22);

//Next Row
            
    if(Inventory[Player][Jetpack] > 0)    
        { if(button(600+XSHIFT, 524+YSHIFT, 32, 32, "WJETA0", "WJETB0", 813, PlayerNumber(), 15) == true)
            { ConsoleCommand("Puke 987 15"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 524+YSHIFT, 32, 32, "WJETC0", "WJETC0", 813, PlayerNumber(), 15);
        
    if(Inventory[Player][Teleporter] > 0)    
        { if(button(634+XSHIFT, 524+YSHIFT, 32, 32, "WTELA0", "WTELB0", 814, PlayerNumber(), 12) == true)
            { ConsoleCommand("Puke 987 12"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 524+YSHIFT, 32, 32, "WTELC0", "WTELC0", 814, PlayerNumber(), 12);
                
    if(Inventory[Player][Girders] > 0)    
        { if(button(668+XSHIFT, 524+YSHIFT, 32, 32, "WGIRA0", "WGIRB0", 815, PlayerNumber(), 18) == true)
            { ConsoleCommand("Puke 987 18"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(668+XSHIFT, 524+YSHIFT, 32, 32, "WGIRC0", "WGIRC0", 815, PlayerNumber(), 9);
            
    if(Inventory[Player][GirderKit] > 0)    
        { if(button(702+XSHIFT, 524+YSHIFT, 32, 32, "WGR2A0", "WGR2B0", 839, PlayerNumber(), 26) == true)
            { ConsoleCommand("Puke 987 26"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(702+XSHIFT, 524+YSHIFT, 32, 32, "WGR2C0", "WGR2C0", 839, PlayerNumber(), 26);

    if(Inventory[Player][Parachute] > 0)    
        { if(button(736+XSHIFT, 524+YSHIFT, 32, 32, "WPARB0", "WPARA0", 855, PlayerNumber(), 27) == true)
            { ConsoleCommand("Puke 987 27"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(736+XSHIFT, 524+YSHIFT, 32, 32, "WPARC0", "WPARC0", 855, PlayerNumber(), 27);
	
	if(Inventory[Player][NinjaRope] > 0)    
        { if(button(770+XSHIFT, 524+YSHIFT, 32, 32, "WNINA0", "WNINB0", 887, PlayerNumber(), 30) == true)
            { ConsoleCommand("Puke 987 30"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(770+XSHIFT, 524+YSHIFT, 32, 32, "WNINC0", "WNINC0", 887, PlayerNumber(), 30);	
            
//Next Row
                
    if(Inventory[Player][Airstriker] > 0)    
        { if(button(600+XSHIFT, 558+YSHIFT, 32, 32, "WAIRA0", "WAIRB0", 816, PlayerNumber(), 13) == true)
            { ConsoleCommand("Puke 987 13"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(600+XSHIFT, 558+YSHIFT, 32, 32, "WAIRC0", "WAIRC0", 816, PlayerNumber(), 13);
		
    if(Inventory[Player][NapalmStrike] > 0)    
        { if(button(634+XSHIFT, 558+YSHIFT, 32, 32, "WNAPA0", "WNAPB0", 869, PlayerNumber(), 29) == true)
            { ConsoleCommand("Puke 987 29"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(634+XSHIFT, 558+YSHIFT, 32, 32, "WNAPC0", "WNAPC0", 869, PlayerNumber(), 29);                    
		
    if(Inventory[Player][Flamethrower] > 0)    
        { if(button(668+XSHIFT, 558+YSHIFT, 32, 32, "WFLMA0", "WFLMB0", 821, PlayerNumber(), 21) == true)
            { ConsoleCommand("Puke 987 21"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(668+XSHIFT, 558+YSHIFT, 32, 32, "WFLMC0", "WFLMC0", 821, PlayerNumber(), 21);
    
    if(Inventory[Player][SentryGun] > 0)    
        { if(button(702+XSHIFT, 558+YSHIFT, 32, 32, "WSENA0", "WSENB0", 836, PlayerNumber(), 24) == true)
            { ConsoleCommand("Puke 987 24"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(702+XSHIFT, 558+YSHIFT, 32, 32, "WSENC0", "WSENC0", 836, PlayerNumber(), 24);
        
    if(Inventory[Player][EnergyBarrier] > 0)    
        { if(button(736+XSHIFT, 558+YSHIFT, 32, 32, "WBRXA0", "WBRXB0", 834, PlayerNumber(), 23) == true)
            { ConsoleCommand("Puke 987 23"); delay(8); ACS_Terminate(888,0); terminate; }}
    else
        button(736+XSHIFT, 558+YSHIFT, 32, 32, "WBRXC0", "WBRXC0", 834, PlayerNumber(), 23);

		delay(1);
restart;
}

function int Int2Fix(int value)     { return value * 1.0; }
function int Half(int value)        { return value / 2; }


// clientsided mouse for weapons hud menu
script 888 (int Player) clientside
{

        if(ClientMenu[Player] == false || HasClientFired[Player] == true) { ACS_Execute(3, 0, Player+500); terminate; }
        Shooting = False;
        
    // force resolution
    sethudsize(SCREEN_WIDTH, SCREEN_HEIGHT, 0);
   
    // loop
        {
            // get the amount of turning the player is doing
            mousexadd[playernumber()] = GetPlayerInput (playernumber(), INPUT_YAW);
           
            // get the amount of looking up/down the player is doing
            mouseyadd[playernumber()] = GetPlayerInput (playernumber(), INPUT_PITCH);
                   
            // get what buttons the player is pressing
            mouseclick[playernumber()] = GetPlayerInput(playernumber(), INPUT_BUTTONS);

            // apply the amount of turning to the cursor's x
            mousex[playernumber()] -= mousexadd[playernumber()] / CURSOR_XSENS;
           
            // apply the amount of looking to the cursor's y
            mousey[playernumber()] -= mouseyadd[playernumber()] / CURSOR_YSENS;
                   
            //check if the mouse has hit any of the side of the screen
            if(mousex[playernumber()] < 0) mousex[playernumber()] = 0;
            if(mousey[playernumber()] < 0) mousey[playernumber()] = 0;
            if(mousex[playernumber()] > SCREEN_WIDTH) mousex[playernumber()] = SCREEN_WIDTH;
            if(mousey[playernumber()] > SCREEN_HEIGHT) mousey[playernumber()] = SCREEN_HEIGHT; 


                setfont("cursor");
                  
            hudmessage(s:"a"; 0, 1, 0, Int2Fix(mousex[playernumber()]) + 0.1, Int2Fix(mousey[playernumber()]) + 0.1, 0.1);
           
            if(mouseclick[playernumber()] & BT_ATTACK)
                {
                    mousepress[playernumber()] = true;
                }
            else
                {
                    mousepress[playernumber()] = false;
                }
               
            delay(1);
        }
restart;
}


// test stuff
// prints a testmarines health and armor to screen
Script 667 (VOID)

{
PrintBold(s:"H: ", i:GetActorProperty(0, APROP_Health), s:" A: ", i:CheckInventory("BasicArmor"));
}

// test stuff, ends a testmarines turn
Script 668 (VOID)
{
for(int hloop = 1000; hloop > 0; hloop--)
    HudMessageBold(s:""; HUDMSG_PLAIN, hloop, CR_RED, 0, 0, 0);
    while(1)
        {
PlayerControl[PlayerTurn][PlayerNumber()] = True;
PlayerControl[EndTurn][PlayerNumber()] = False;
PlayerControl[HasFired][PlayerNumber()] = False;
Moving = True;
Shooting = True;
Aiming = True;
ACS_Terminate(2, 0);
ACS_Execute(3, 0, PlayerNumber()+500);
SetPlayerProperty(1, OFF, PROP_TOTALLYFROZEN);
delay(50);
}}

Script 937 (int PlayrNum)
{
 SetActivator(PlayrNum);
 int IDX = GetActorX(PlayrNum);
 int IDZ = GetActorZ(PlayrNum);
	Delay(35*10);
	if(GetActorX(PlayrNum) == IDX && GetActorZ(PlayrNum) == IDZ && PlayerControl[IsFiring][PlayrNum] == False && PlayerControl[HasFired][PlayrNum] == False
			&& PlayerControl[PlayerTurn][PlayrNum-500] == True && GAME_TURNTIME > 10)
			{
				AmbientSound(voices[PlayerSkin[PlayrNum-500]][13], 127);
				int PrevDir = GetActorAngle(PlayrNum);
				SetActorAngle(PlayrNum, GetTargetAngle(PlayrNum, 100));
				SetPlayerProperty(0, ON, PROP_TOTALLYFROZEN);
				SetActorState(PlayrNum, "Waving");
				Delay(35);
				SetActorAngle(PlayrNum, PrevDir);
				SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
			}
}

// bots testing
// test marine cancel turn
Script 936 (VOID)
{
Timeloop = 0;
ACS_Terminate(853, 0);
}
Script 451 (VOID)

{
int FakeTid;

for(int sloop = Players; sloop > 0; sloop--)
	FakeTid++;

if(GetLevelInfo(LEVELINFO_LevelNum) == 0) 
    { Thing_ChangeTid(0, FakeTid+500); Terminate; }
        if(PlayerControl[4][FakeTid] == False)
            { PlayerControl[4][FakeTid] = True;
                PlayerInts[Lives][FakeTid] = PLAYER_LIVES; }
    if(PlayerInts[Lives][FakeTid] > 0)
    {
        if(GAME_GAMETYPE == 0)
            {
                SetupPlayer(FakeTid);

                    While( GetActorY(FakeTid+500) != LVL_YPOS 
                            || NotWater(FakeTid+500) == False)

                            {
                            SetActorPosition(FakeTid+500, Random(-8000.0, 8000.0), LVL_YPOS, 4000.0, 0);
                            delay(1);
                            }
                SetActorPosition(FakeTid+500,
                    GetActorX(FakeTid+500), LVL_YPOS, 
                        GetActorFLoorZ(FakeTid+500) + 48.0, 0);
            }
        else if(GAME_GAMETYPE == 1) 
            {
                SetupPlayer(FakeTid);
                    
                if(blueteam <= redteam) 
                    { 
                        for(int LivesCheck = PLAYER_LIVES; LivesCheck > 0; LivesCheck--)
                            blueteam++; 
                        playerteam2[FakeTid] = "Blue"; }
                else if(redteam < blueteam) 
                    { 
                        for(LivesCheck = PLAYER_LIVES; LivesCheck > 0; LivesCheck--)
                            redteam++; 
                        playerteam2[FakeTid] = "Red"; }

                if(PlayerTeam2[FakeTid] == "Blue")
                    {
                        int BlueTeamInitPos = -8000.0;
                    
                        While( GetActorY(FakeTid+500) != LVL_YPOS || NotWater(FakeTid+500) == False)
                            {
                                if(BlueTeamInitPos < -1000.0)
                                    {
                                        if(Random(1,4) < 3) 
                                        BlueTeamInitPos += Random(150.0, 300.0);
                                    else BlueTeamInitPos += Random(400.0, 800.0);
                                }
                            
                            SetActorPosition(FakeTid+500, 
                                    BlueTeamInitPos+Random(-150.0, 150.0)
                                                ,LVL_YPOS, 4000.0, 0);
                            delay(1);
                        }
                }
            else if(PlayerTeam2[FakeTid] == "Red")
                {
                    int RedTeamInitPos = 8000.0;
                    
                    While( GetActorY(FakeTid+500) != LVL_YPOS 
                            || NotWater(FakeTid+500) == False)
                        {
                            if(RedTeamInitPos > 1000.0)
                                {
                                    if(Random(1,4) < 3) 
                                        RedTeamInitPos -= Random(150.0, 300.0);
                                    else RedTeamInitPos -= Random(400.0, 800.0);
                                }
                            SetActorPosition(FakeTid+500, RedTeamInitPos+Random(-300.0, 300.0), LVL_YPOS, 4000.0, 0);
                            delay(1);
                        }
                }

  SetActorPosition(FakeTid+500, GetActorX(FakeTid+500), 
            LVL_YPOS, GetActorFLoorZ(FakeTid+500) + 48.0, 0);
  
  ForceCamera(); } ForceCamera(); } ForceCamera();
  
}



// Test marine player emulator
Script 455 (VOID)
{
int FakeTid;
for(int sloop = Players; sloop > 0; sloop--)
    FakeTid++;
    

    FakeTid--;
if(PlayerControl[PlayerTurn][FakeTid] == True) TimeLoop = 0;
Thing_ChangeTID(0, 2538);
Players--;
if(GAME_GAMETYPE == 1)
    {
        if(PlayerTeam2[FakeTid] == "Blue") BlueTeam--;
        else if(PlayerTeam2[FakeTid] == "Red") RedTeam--;
    }
PlayerInts[Lives][FakeTid]--;
Statistics[Deaths]++;
for(int killcheck = 0; killcheck < 32; killcheck++)
    if(PlayerControl[PlayerTurn][killcheck] == True && FakeTid != killcheck) PlayerInts[Kills][killcheck]++;
PlayerInts[BeforeHealth][FakeTid] = 0;
PlayerInts[AfterHealth][FakeTid] = 0;
alive[FakeTid] = false;
Thing_Remove(2538);
PlayerSkin[FakeTid] = Random(0, 3);
}

function void GenerateGround (int tid, str GroundType)
	{
						SpawnSpotForced(GroundType, tid, 0, 0);
	}
	
function void Girder (int tid, str GirderFace)
    {
        if(GirderFace == "GirderHorizontal")
            {
                Spawn("GirderHorizontal", GetActorX(tid), LVL_YPOS, GetActorZ(tid), 0, 0);
                Spawn("GirderHorizontal", GetActorX(tid)+44.0, LVL_YPOS, GetActorZ(tid), 0, 0);
                Spawn("GirderHorizontal", GetActorX(tid)-44.0, LVL_YPOS, GetActorZ(tid), 0, 0);
                Spawn("GirderHorizontal", GetActorX(tid)+88.0, LVL_YPOS, GetActorZ(tid), 0, 0);
                Spawn("GirderHorizontal", GetActorX(tid)-88.0, LVL_YPOS, GetActorZ(tid), 0, 0);
            }
        if(GirderFace == "GirderVertical")
            {
                Spawn("GirderVertical", GetActorX(tid), LVL_YPOS, GetActorZ(tid), 0, 0);
                Spawn("GirderVertical", GetActorX(tid), LVL_YPOS, GetActorZ(tid)+38.0, 0, 0);
                Spawn("GirderVertical", GetActorX(tid), LVL_YPOS, GetActorZ(tid)+76.0, 0, 0);
                Spawn("GirderVertical", GetActorX(tid), LVL_YPOS, GetActorZ(tid)-38.0, 0, 0);
                Spawn("GirderVertical", GetActorX(tid), LVL_YPOS, GetActorZ(tid)-76.0, 0, 0);
            }
        if(GirderFace == "DiagonalLeft")
            {
                Spawn("GirderDiagonal", GetActorX(tid), LVL_YPOS, GetActorZ(tid), 0, 128);
                Spawn("GirderDiagonal", GetActorX(tid)+30.0, LVL_YPOS, GetActorZ(tid)+26.0, 0, 128);
                Spawn("GirderDiagonal", GetActorX(tid)+60.0, LVL_YPOS, GetActorZ(tid)+52.0, 0, 128);
                Spawn("GirderDiagonal", GetActorX(tid)-30.0, LVL_YPOS, GetActorZ(tid)-26.0, 0, 128);
                Spawn("GirderDiagonal", GetActorX(tid)-60.0, LVL_YPOS, GetActorZ(tid)-52.0, 0, 128);
            }
        if(GirderFace == "DiagonalRight")
            {
                Spawn("GirderDiagonal", GetActorX(tid), LVL_YPOS, GetActorZ(tid), 0, 0);
                Spawn("GirderDiagonal", GetActorX(tid)+30.0, LVL_YPOS, GetActorZ(tid)-26.0, 0, 0);
                Spawn("GirderDiagonal", GetActorX(tid)+60.0, LVL_YPOS, GetActorZ(tid)-52.0, 0, 0);
                Spawn("GirderDiagonal", GetActorX(tid)-30.0, LVL_YPOS, GetActorZ(tid)+26.0, 0, 0);
                Spawn("GirderDiagonal", GetActorX(tid)-60.0, LVL_YPOS, GetActorZ(tid)+52.0, 0, 0);
            }
}

//testing stuff, runs test spawning scripts to generate a landscape
script 837 (VOID)
{
ACS_Execute(838, 0, -1600, 15);
Delay(15);
ACS_Execute(851, 0, -1424, 1424, 15);
Delay(35);
ACS_Execute(838, 0, 1600, 15);
Delay(15);

}
str GroundType[4] = { "GroundDirt", "GroundRed", "GroundBlue", "GroundYellow" };

int GroundArray[6000][3];

bool HasGenerated = false;

int MapObjects[5] = { "ObjectTechPillar", "ObjectTechPillar2", "ObjectTechPillar3", "ObjectTechPillar4", "ObjectTechPillar5" };

int DecorObjects[9] = { "Shrub1", "Shrub1B", "Shrub1C", "Shrub2", "Shrub2B", "Shrub2C", "Shrub3", "Shrub3B", "Shrub3C" };

// testing stuff, spawns land
Script 851 (int start, int end, int max)
{
	SetHudSize(640, 400, 0);
	SetFont("BIGFONT");
	HudMessageBold(s:"Please Wait"; HUDMSG_PLAIN, 5, CR_GOLD, 320.0, 200.0, 0);
	
	mapstart = start;
	mapend = end;
	if(HasGenerated == false)
	{
	HasGenerated = True;
	int Ground = GroundType[Random(0, 3)];
	
    int offset = 48;
    start = int2fix(start);
    end = int2fix(end);
	int MaxHeight = Random(4, max);
	int PreviousMax = Random(4, 8);
        
    for(int start2 = start; start2 < end; start2+=48.0)
        {
			if(random(1,2) == 1)
				    { if(PreviousMax >= 5)
                PreviousMax -= Random(1, 3); }
    else if(Random(1, 2) == 1 && PreviousMax < max)
				    PreviousMax += Random(1, 3);
		else if(Random(1, 2) == 1 && PreviousMax < max)
					PreviousMax += Random(3, 4);
			else if(Random(1, 2) == 1 && PreviousMax > 4)
					PreviousMax -= Random(1, 3);

			MaxHeight = PreviousMax;

            Spawn("DummyAim", start2, LVL_YPOS, GetSectorCeilingZ(9, 0, 0)*1.0, 886, 0);
			if(PreviousMax != 0)
            For(int GirderLoop = 0; GirderLoop < MaxHeight; GirderLoop++)
                    {   
						GenerateGround(886, Ground);
                        SetActorPosition(886, start2, LVL_YPOS, GetActorZ(886)+int2fix(offset),0);
                        if(timer()%32 == 0) Delay(1);
                    }
				
            Thing_Remove(886);
        }
		
	for(int ObjLoop = GAME_MAPOBJECTS; objloop > 0; objloop--)
	{
		Spawn(MapObjects[Random(0, 4)], random(mapstart, mapend)*1.0, LVL_YPOS, 1200.0, 0, 0);
	}

for (int decorloop = random(8, 24); decorloop > 0; decorloop--)
	{
		Spawn(DecorObjects[Random(0, 8)], random(mapstart, mapend)*1.0, LVL_YPOS, 1200.0, 0, 0);
	}

for(int ploop = 0; ploop < MaxPlayersArray; ploop++)
			{
				SetActivator(ploop+500);
				SetPlayerProperty(0, 1, PROP_INVULNERABILITY);
				if(GetActorY(ploop+500) != LVL_YPOS)
					SetActorPosition(ploop+500, random(mapstart, mapend)*1.0, LVL_YPOS, 1200.0, 0);
				delay(2);
				While(GetActorVelZ(ploop+500) != 0)
					delay(2);
				SetPlayerProperty(0, 0, PROP_INVULNERABILITY);
			}
			
for(int LvlMines = LVL_CHANCE_MINES; LvlMines > 0; LvlMines--)
				{
				Spawn("Mine", random(mapstart, mapend)*1.0, LVL_YPOS, 1200.0, 2222, 0);
				SetActorProperty(2222, APROP_Health, LVL_TIMER_MINES);
				Thing_ChangeTID(2222, 0);
				}
				
	}
	

}

//testing stuff, spawns a girder at parameters
Script 838 (int GX, int height)
{		
		int offset = 48;
		    GX = int2fix(GX);
			Spawn("DummyAim", GX, LVL_YPOS, 0.0, 887, 0);
		For(int GirderLoop = 0; GirderLoop < height; GirderLoop++)
                    {   	
			if(NotWater(887) == False)
					{
						Spawn("GirderHorizontal", GX, LVL_YPOS, GetActorZ(887), 0 );
						Spawn("GirderHorizontal", GX+44.0, LVL_YPOS, GetActorZ(887), 0 );								
						Spawn("GirderHorizontal", GX-44.0, LVL_YPOS, GetActorZ(887), 0 );
						Spawn("GirderHorizontal", GX+88.0, LVL_YPOS, GetActorZ(887), 0 );								
						Spawn("GirderHorizontal", GX-88.0, LVL_YPOS, GetActorZ(887), 0 );
						Spawn("GirderHorizontal", GX+132.0, LVL_YPOS, GetActorZ(887), 0 );								
						Spawn("GirderHorizontal", GX-132.0, LVL_YPOS, GetActorZ(887), 0 );
						Spawn("GirderHorizontal", GX+176.0, LVL_YPOS, GetActorZ(887), 0 );								
						Spawn("GirderHorizontal", GX-176.0, LVL_YPOS, GetActorZ(887), 0 );
						SetActorPosition(887, GX, LVL_YPOS, GetActorZ(887)+int2fix(offset),0);
                        Delay(1);
					}
                    }
	
		terminate;		
}

//beam spawner

Script SPAWN_BEAM (int Beam)
{
	    

	if(Beam == 0)
		{
			Thing_Remove(760); Thing_Remove(761); Thing_Remove(762);
			SpawnSpot("SunBeam", Random(50, 56), 760, 0);
				if(random(1, 3) == 1)
				SpawnSpot("SunBeam", Random(50, 56), 762, 0);
		
		}
	if(Beam == 1)
		{
			Thing_Remove(760); Thing_Remove(761); Thing_Remove(762);
			SpawnSpot("ElecBeam", Random(50, 56), 760, 0);
				if(random(1, 3) == 1)
					SpawnSpot("ElecBeam", Random(50, 56), 762, 0);

		}
	if(Beam == 2)
		{
			Thing_Remove(760); Thing_Remove(761); Thing_Remove(762);
			SpawnSpot("Tornado", Random(50, 56), 760, 0);
				if(random(1, 3) == 1)
					SpawnSpot("Tornado", Random(50, 56), 762, 0);
		
		}
	if(Beam == 3)
		{
			Thing_Remove(760); Thing_Remove(761); Thing_Remove(762);
			SpawnSpot("GooBeam", Random(50, 56), 760, 0);
			if(random(1, 3) == 1)
				SpawnSpot("GooBeam", Random(50, 56), 762, 0);

		}
	if(Beam == 4)
		{
			if(random(1, 3) == 1) { Thing_Remove(760); Thing_Remove(761); Thing_Remove(762); }
		}

	if(GetLevelInfo(LEVELINFO_LevelNum) != 32)
	{
	if(thingcount(T_NONE, 762) != 0)
	While(NotWater(762) == False )           
        {
            SetActorPosition(762, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(760)+3000.0, 0);
            delay(1);
        }
    
	While( NotWater(760) == False )           
        {
            SetActorPosition(760, Random(-8000.0, 8000.0), LVL_YPOS, GetActorFloorZ(760)+3000.0, 0);
            delay(1);
        }
   	SetActorPosition(762, GetActorX(762), LVL_YPOS, GetActorFloorZ(762), 0);        
   	SetActorPosition(760, GetActorX(760), LVL_YPOS, GetActorFloorZ(760), 0);
	}
	else
	{
		SetActorPosition(760, Random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(760)+3000.0, 0);
		if(ThingCount(T_NONE, 762) != 0)
		SetActorPosition(762, Random(mapstart, mapend)*1.0, LVL_YPOS, GetActorFloorZ(762)+3000.0, 0);
	}
  	        if(Beam == 2)
			{
				SpawnSpot("Tornado2", 760, 761, 0);
				SpawnSpot("Tornado3", 760, 761, 0);
				if(thingcount(t_none, 762) != 0)
					{
						SpawnSpot("Tornado2", 762, 761, 0);
						SpawnSpot("Tornado3", 762, 761, 0);
					}
			}
		if(Beam == 0)
			{
				SpawnSpot("SunBeam2", 760, 761, 0);
			}
		                
}


Script 972 (int PlayerNum)		// Makes the HUD powerbar flash when player fires, removes the item afterwards
{
	Delay(12);
	TakeActorInventory(PlayerNum, "HasFiredItem", 1);
}

//orbit script for twister beams

function int Orbit(int focustid, int orbitobjtid, int speed, int radius, int rotations)
{
   orbitarray[0] = focustid;
   orbitarray[1] = orbitobjtid;
   orbitarray[2] = speed;
   orbitarray[3] = radius;
   orbitarray[4] = rotations;

   acs_executealways(344,0,focustid, 0);
   return 1;
}

Script 344 (int focustid)
{
   int orbitpoint = orbitarray[0];
   int orbx = GetActorX(orbitpoint), orby = GetActorY(orbitpoint);
   int step = 0;
   int angle = GetActorAngle(focustid);
   int speed_var = orbitarray[2];
   int radius_var = orbitarray[3] << 16;
   int rotations = 0;
   int offset;
   int OriginalX = GetActorX(orbitarray[1]);

   While(rotations < OrbitArray[4])
   {
	step++;
      orbx = GetActorX(orbitpoint); orby = GetActorY(orbitpoint);

      offset = FixedDiv(speed_var * 1.0, 360.0) * step;
	rotations = offset>>16;
	if(rotations < 0)
		rotations = -rotations;
	else rotations++;
		

      SetActorPosition(orbitarray[1],
      orbx + FixedMul(radius_var , cos( (angle - offset) % 1.0)),
      orby + FixedMul(radius_var , sin( (angle - offset) % 1.0)),
      			GetActorZ(orbitarray[1]), 0);
	
	SetActorAngle(orbitarray[1], GetTargetAngle(ProjectileTID, orbitarray[1]) + 0.25);	
      delay(1);
   }
   TornadoDone = true;
}

//		Has the player been kicked in the nuts?
Script 575 (VOID)
{
	ForceDirection(PlayerNumber()+500);
	if(GetActorAngle(PlayerNumber()+500) != KickFacing)
					SetResultValue(1);	
			else		SetResultValue(0);
}
Script 573 (VOID)			// Kicked in nuts
	{
		SetActorProperty(0, APROP_HEALTH, GetActorProperty(0, APROP_HEALTH)/2);
		AmbientSound(voices[PlayerSkin[PlayerNumber()]][17], 116);
	}


// Walljumping script

int PlayerWalljumpCount[MaxPlayersArray];
Script 576 (VOID)
{
	Delay(2);
	int PlayerPressingJump = GetPlayerInput(-1, INPUT_BUTTONS);
	// ForceDirection(PlayerNumber()+500);
	
	if(PlayerPressingJump & BT_JUMP)
		{
				if (GetActorVelX(PlayerNumber()+500) < 0  && Spawn("WallJumpCheck", GetActorX(500+PlayerNumber())+32.0, LVL_YPOS, GetActorZ(500+PlayerNumber()), 220, 0) == 0 &&
						(PlayerWalljumpCheck == "East" || PlayerWalljumpCheck == "None"))
					{
						IsWallJumping = True;
						Spawn("WallDust2", GetActorX(500+PlayerNumber())+8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+24.0, 0, 0);
						Spawn("WallDust2", GetActorX(500+PlayerNumber())+8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+16.0, 0, 0);
						Spawn("WallDust", GetActorX(500+PlayerNumber())+8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+48.0, 0, 0);
						Spawn("WallDust", GetActorX(500+PlayerNumber())+8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+56.0, 0, 0);
						
						Moving = False;
						SetPlayerProperty(0, ON, PROP_TOTALLYFROZEN);
						SetActorVelocity(PlayerNumber()+500, 0, 0, 0, 0, 0);
						SetPlayerProperty(0, 1, PROP_FLY); 
						SetActorState(PlayerNumber()+500, "WallJump");
						AmbientSound("foot/rock", 127);
						Delay(6);
						SetPlayerProperty(0, 0, PROP_FLY); 
						PlayerWalljumpCheck = "West";
						PlayerInts[FacingAngle][PlayerNumber()] = 0.5;
						SetActorAngle(PlayerNumber()+500, 0.5);
						ThrustThing(PlayerInts[FacingAngle][PlayerNumber()]*256/360+128, 5, 0, PlayerNumber()+500);
						ThrustThingZ(PlayerNumber()+500, 64, 0, 0);
						AmbientSound(voices[PlayerSkin[PlayerNumber()]][16], 127);
						Delay(4);
						Moving = True;
						
						PlayerWallJumpCount[PlayerNumber()]++;
						SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
						IsWallJumping = False;
					}
			if (GetActorVelX(PlayerNumber()+500) > 0  && Spawn("WallJumpCheck", GetActorX(500+PlayerNumber())-32.0, LVL_YPOS, GetActorZ(500+PlayerNumber()), 220, 0) == 0 &&
						(PlayerWalljumpCheck == "West" || PlayerWalljumpCheck == "None"))
					{
						IsWallJumping = True;
						Spawn("WallDust2", GetActorX(500+PlayerNumber())-8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+24.0, 0, 0);
						Spawn("WallDust2", GetActorX(500+PlayerNumber())-8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+16.0, 0, 0);
						Spawn("WallDust", GetActorX(500+PlayerNumber())-8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+24.0, 0, 0);
						Spawn("WallDust", GetActorX(500+PlayerNumber())-8.0, LVL_YPOS, GetActorZ(500+PlayerNumber())+48.0, 0, 0);
						Moving = False;
						SetPlayerProperty(PlayerNumber(), ON, PROP_TOTALLYFROZEN);
						SetActorVelocity(PlayerNumber()+500, 0, 0, 0, 0, 0);
						SetActorState(PlayerNumber()+500, "WallJump");
						SetPlayerProperty(0, 1, PROP_FLY);
						AmbientSound("foot/rock", 127);
						Delay(6);
						SetPlayerProperty(0, 0, PROP_FLY); 
						PlayerWalljumpCheck = "East";
						PlayerInts[FacingAngle][PlayerNumber()] = 1.0;
						SetActorAngle(PlayerNumber()+500, 1.0);
						ThrustThing(PlayerInts[FacingAngle][PlayerNumber()]*256/360, 5, 0, PlayerNumber()+500);
						ThrustThingZ(PlayerNumber()+500, 64, 0, 0);
						AmbientSound(voices[PlayerSkin[PlayerNumber()]][16], 127);
						Delay(4);
						Moving = True;

						PlayerWallJumpCount[PlayerNumber()]++;
						SetPlayerProperty(0, OFF, PROP_TOTALLYFROZEN);
						IsWallJumping = False;	
					}

				if(PlayerWallJumpCount[PlayerNumber()] > Statistics[Acrobatics])
					Statistics[Acrobatics] = PlayerWallJumpCount[PlayerNumber()];
					Statistics[MostAcrobatic] = PlayerNumber();
				Thing_Remove(220);
		}
}

Script 577 (VOID)
	{	PlayerWalljumpCheck = "None";	}
	
function int sqrt2(int number)
{
    if(number <= 3)
    {
        if(number > 0)
        {
            return 1;
        }
        return 0;
    }

    int oldAns = number >> 1,                     // initial guess
        newAns = (oldAns + number / oldAns) >> 1; // first iteration

    // main iterative method
    while(newAns < oldAns)
    {
        oldAns = newAns;
        newAns = (oldAns + number / oldAns) >> 1;
    }

    return oldAns;
}

/* -- function magnitudeThree(int x, int y, int z) --
 *   sqrt(x**2+y**2+z**2). That's all it is.
 */

function int magnitudeThree(int m3x, int m3y, int m3z)
{
    return sqrt2(m3x*m3x + m3y*m3y + m3z*m3z);
}

script ROPE_HOLD (int Player, int length, int strength)
{
    int myX;   int myY;   int myZ;
    int ropeX; int ropeY; int ropeZ;
    int velX;  int velY;  int velZ;
    int normX; int normY; int normZ;
    int pullX; int pullY; int pullZ;
    int rPullX; int rPullY; int rPullZ;
    int mag; int mode;
    
    strength = (strength << 16) / 100;
    strength = FixedMul(strength, strength);

	while(GetActorVelX(ProjectileTID) + GetActorVelZ(ProjectileTID) != 0)
		Delay(1);
		
    if (length == -1)
    {
        myX   = GetActorX(Player);    myY   = GetActorY(Player);    myZ   = GetActorZ(Player);
        ropeX = GetActorX(ProjectileTID); ropeY = GetActorY(ProjectileTID); ropeZ = GetActorZ(ProjectileTID);
        velX  = myX - ropeX;        velY  = myY - ropeY;        velZ  = myZ - ropeZ;

        length = magnitudeThree(velX >> 16, velY >> 16, velZ >> 16);
    }

    int playerTID = player;

    while (ThingCount(0, ProjectileTID) == 1)
    {
		if(length > 50 && length < 500)
			length += PlayerInts[RopeLengthMod][Player-500];
				
		if(Length > 500) Length = 500;
		if(Length < 20)	Length = 50;

		
        myX   = GetActorX(Player);    myY   = GetActorY(Player);    myZ   = GetActorZ(Player);
        ropeX = GetActorX(ProjectileTID); ropeY = GetActorY(ProjectileTID); ropeZ = GetActorZ(ProjectileTID);
        velX  = myX - ropeX;        velY  = myY - ropeY;        velZ  = myZ - ropeZ;

        // this is where precision goes down the drain
        mag = magnitudeThree(velX >> 16, velY >> 16, velZ >> 16);
    
        normX = velX / mag;   normY = velY / mag;   normZ = velZ / mag;

        if (mag > length)
        {
            rPullX = ropeX + (normX * length);
            rPullY = ropeY + (normY * length);
            rPullZ = ropeZ + (normZ * length);

            pullX = -(velX - (normX * length));
            pullY = -(velY - (normY * length));
            pullZ = -(velZ - (normZ * length));

            pullX = FixedMul(pullX, strength);
            pullY = FixedMul(pullY, strength);
            pullZ = FixedMul(pullZ, strength);
			
			
            if(Spawn("PlayerBlockCheck", PullX, LVL_YPOS, rPullZ))
				SetActorPosition(Player, rPullX, LVL_YPOS, rPullZ, 0);
				
            SetActorVelocity(Player, pullX, 0, pullZ, 1, 0);
        }

        ACS_ExecuteAlways(ROPE_DRAWLINE, 0, ProjectileTID, player, 24);
        Delay(1);
    }
}

script ROPE_DRAWLINE (int grappleTid, int playerTid, int density)
{
    int plX; int plY;  int plZ;
    int grX; int grY;  int grZ;
    int vX;  int vY;   int vZ;
    int nX;  int nY;   int nZ;
    int bX;  int bY;   int bZ;
    int magnitude;
    int pointCount;
    int pointOffset;

    if (ThingCount(0, grappleTid) != 1)
    {
        terminate;
    }

    if (ThingCount(0, playerTid) != 1)
    {
        terminate;
    }

    plX = GetActorX(playerTid); grX = GetActorX(grappleTid);
    plY = GetActorY(playerTid); grY  = GetActorY(grappleTid);
    plZ = GetActorZ(playerTid); grZ  = GetActorZ(grappleTid);
    vX   = grX - plX;       vY   = grY - plY;       vZ   = grZ - plZ;

    // NOTE: More precision bullshit
    magnitude = magnitudeThree(vX >> 16, vY >> 16, vZ >> 16);

    pointCount  = magnitude / density;
    pointOffset = magnitude - (pointCount * density);

    if (magnitude != 0)
    {
        nX = vX / magnitude; nY = vY / magnitude; nZ = vZ / magnitude;

        int i; int j;
        for (i = 0; i < pointCount; i++)
        {
            j = (i * density) + pointOffset;

            bX = (nX * j) + plX;
            bY = (nY * j) + plY;
            bZ = (nZ * j) + plZ;

            Spawn("LinePoint", bX, bY, bZ);
        }
    }

}

#define 		GirderDistance			30.0
#define 		GirderBaseTID			3000
// Girder generation tool script
Script 350 (int TIDoffset)
{
	for(int i = 1; i < 64; i++)
		{
		
		while(ThingCount(0, GirderBaseTID+i+TIDoffset) > 0) 
			delay(1);
			
			Spawn("GirderHorizontal", GetActorX(0)+i*GirderDistance, LVL_YPOS, GetActorZ(0), GirderBaseTID+i+TIDOffset, 0.5);
				if(GetActorZ(0) != GetActorZ(GirderBaseTID+i+TIDoffset))
					{
						Thing_Remove(GirderBaseTID+i+TIDoffset);
						break;
					}
			Thing_ChangeTID(GirderBaseTID+i+TIDoffset, 0);
		}
}

script CROSSHAIR (int TID) CLIENTSIDE
{
Spawn("XHair", GetActorX(TID), LVL_YPOS, GetActorZ(TID)+40.0, 961);
		if(GetActorAngle(TID) > 0.45 && GetActorAngle(TID) < 0.95)
		SetActorVelocity(961, -cos(GetActorPitch(TID))*12, 0, sin(GetActorPitch(TID))*12, 0, 0);
		else
		SetActorVelocity(961, cos(GetActorPitch(TID))*12, 0, sin(GetActorPitch(TID))*12, 0, 0);
		Thing_ChangeTid(961, 0);
}

str ForceActors[10] = { "TriForce_115", "TriForce_115", "TriForce_1530", "TriForce_1530", "TriForce_3045", "TriForce_3045", "TriForce_4560", "TriForce_6075", "TriForce_7590", "TriForce_100" };

script FORCEINDICATOR (int TID) CLIENTSIDE
{
		int Force = CheckActorInventory(TID, "ForceItem") * 1.0;
		int px = GetActorX(TID);
		int pz = GetActorZ(TID);
		
		Spawn(ForceActors[Force], GetActorX(TID), LVL_YPOS, GetActorZ(TID)+40.0, 965);
		
		if(GetActorAngle(TID) > 0.45 && GetActorAngle(TID) < 0.95)
		SetActorPosition(965, px + -cos(GetActorPitch(TID)*Force), LVL_YPOS, pz+40.0 + sin(GetActorPitch(TID)*Force), 0);
		else
		SetActorPosition(965, px + cos(GetActorPitch(TID)*Force), LVL_YPOS, pz+40.0 + sin(GetActorPitch(TID)*Force), 0);
		Thing_ChangeTID(965, 966);
		
}
